For instructions on building and installing the acisbg software, please see
the INSTALL file.

For a discussion on processing ACIS background, see the COOKBOOK file,
the most current version of which is on-line at:

	 http://cxc.harvard.edu/contrib/maxim/acisbg/COOKBOOK

D tools
=======

[![GitHub tag](https://img.shields.io/github/tag/dlang/tools.svg?maxAge=86400)](https://github.com/dlang/tools/releases)
[![Bugzilla Issues](https://img.shields.io/badge/issues-Bugzilla-green.svg)](https://issues.dlang.org/buglist.cgi?component=tools&list_id=220149&product=D&resolution=---)
[![Buildkite](https://img.shields.io/buildkite/8cc605b3a89338bc41b144efcd5226acfe6b91c844a8a27ad9/master.svg?logo=dependabot&style=flat&label=buildkite)](https://buildkite.com/dlang/tools)
[![license](https://img.shields.io/github/license/dlang/tools.svg)](https://github.com/dlang/tools/blob/master/LICENSE.txt)

This repository hosts various tools redistributed with DMD or used
internally during various build tasks.

Program                | Scope    | Description
---------------------- | -------- | -----------------------------------------
catdoc                 | Build    | Concatenates Ddoc files.
changed                | Internal | Change log generator.
chmodzip               | Build    | ZIP file attributes editor.
ddemangle              | Public   | D symbol demangler.
detab                  | Internal | Replaces tabs with spaces.
dget                   | Internal | D source code downloader.
dman                   | Public   | D documentation lookup tool.
dustmite               | Public   | [Test case minimization tool](https://github.com/CyberShadow/DustMite/wiki).
get_dlibcurl32         | Internal | Win32 libcurl downloader/converter.
rdmd                   | Public   | [D build tool](http://dlang.org/rdmd.html).
rdmd_test              | Internal | rdmd test suite.
tests_extractor 	   | Internal | Extracts public unittests (requires DUB)
tolf                   | Internal | Line endings converter.
updatecopyright        | Internal | Update the copyright notices in DMD

To report a problem or browse the list of open bugs, please visit the
[bug tracker](http://issues.dlang.org/).

For a list and descriptions of D development tools, please visit the
[D wiki](http://wiki.dlang.org/Development_tools).

Building
--------

On a Posix system all tools can be built with:

```
make all
```

Using DUB as a build tool
-------------------------

Most tools can also be built with DUB:

```
dub build :ddemangle
```

Running DUB tools
-----------------

Some tools require D's package manager DUB.
By default, DUB builds a binary and executes it. On a Posix system,
the source files can directly be executed with DUB (e.g. `./tests_extractor.d`).
Alternatively, the full single file execution command can be used:

```
dub --single tests_extractor.d
```

Remember that when programs are run via DUB, you need to pass in `--` before
the program's arguments, e.g `dub --single tests_extractor.d -- -i ../phobos/std/algorithm`.

For more information, please see [DUB's documentation][dub-doc].

[dub-doc]: https://code.dlang.org/docs/commandline

DustMite is a general-purpose data reduction tool.

Its main use is to reduce D programs into minimal examples
exhibiting some behavior (usually a compiler bug).

For documentation, see the GitHub wiki:
https://github.com/CyberShadow/DustMite/wiki

DustMite was created by Vladimir Panteleev,
and is distributed under the Boost Software Licence, version 1.0.

# `gopls`, the Go language server

[![PkgGoDev](https://pkg.go.dev/badge/golang.org/x/tools/gopls)](https://pkg.go.dev/golang.org/x/tools/gopls)

`gopls` (pronounced "Go please") is the official Go [language server] developed
by the Go team. It provides IDE features to any [LSP]-compatible editor.

<!--TODO(rfindley): Add gifs here.-->

You should not need to interact with `gopls` directly--it will be automatically
integrated into your editor. The specific features and settings vary slightly
by editor, so we recommend that you proceed to the
[documentation for your editor](#editors) below.

## Editors

To get started with `gopls`, install an LSP plugin in your editor of choice.

* [VS Code](https://github.com/golang/vscode-go/blob/master/README.md)
* [Vim / Neovim](doc/vim.md)
* [Emacs](doc/emacs.md)
* [Atom](https://github.com/MordFustang21/ide-gopls)
* [Sublime Text](doc/subl.md)
* [Acme](https://github.com/fhs/acme-lsp)
* [Lapce](https://github.com/lapce-community/lapce-go)

If you use `gopls` with an editor that is not on this list, please send us a CL
[updating this documentation](doc/contributing.md).

## Installation

For the most part, you should not need to install or update `gopls`. Your
editor should handle that step for you.

If you do want to get the latest stable version of `gopls`, run the following
command:

```sh
go install golang.org/x/tools/gopls@latest
```

Learn more in the
[advanced installation instructions](doc/advanced.md#installing-unreleased-versions).

Learn more about gopls releases in the [release policy](doc/releases.md).

## Setting up your workspace

`gopls` supports both Go module, multi-module and GOPATH modes. See the
[workspace documentation](doc/workspace.md) for information on supported
workspace layouts.

## Configuration

You can configure `gopls` to change your editor experience or view additional
debugging information. Configuration options will be made available by your
editor, so see your [editor's instructions](#editors) for specific details. A
full list of `gopls` settings can be found in the [settings documentation](doc/settings.md).

### Environment variables

`gopls` inherits your editor's environment, so be aware of any environment
variables you configure. Some editors, such as VS Code, allow users to
selectively override the values of some environment variables.

## Support Policy

Gopls is maintained by engineers on the
[Go tools team](https://github.com/orgs/golang/teams/tools-team/members),
who actively monitor the
[Go](https://github.com/golang/go/issues?q=is%3Aissue+is%3Aopen+label%3Agopls)
and
[VS Code Go](https://github.com/golang/vscode-go/issues) issue trackers.

### Supported Go versions

`gopls` follows the
[Go Release Policy](https://golang.org/doc/devel/release.html#policy),
meaning that it officially supports the last 2 major Go releases. Per
[issue #39146](https://go.dev/issues/39146), we attempt to maintain best-effort
support for the last 4 major Go releases, but this support extends only to not
breaking the build and avoiding easily fixable regressions.

In the context of this discussion, gopls "supports" a Go version if it supports
being built with that Go version as well as integrating with the `go` command
of that Go version.

The following table shows the final gopls version that supports a given Go
version. Go releases more recent than any in the table can be used with any
version of gopls.

| Go Version  | Final gopls version with support (without warnings) |
| ----------- | --------------------------------------------------- |
| Go 1.12     | [gopls@v0.7.5](https://github.com/golang/tools/releases/tag/gopls%2Fv0.7.5) |
| Go 1.15     | [gopls@v0.9.5](https://github.com/golang/tools/releases/tag/gopls%2Fv0.9.5) |
| Go 1.17     | [gopls@v0.11.0](https://github.com/golang/tools/releases/tag/gopls%2Fv0.11.0) |

Our extended support is enforced via [continuous integration with older Go
versions](doc/contributing.md#ci). This legacy Go CI may not block releases:
test failures may be skipped rather than fixed. Furthermore, if a regression in
an older Go version causes irreconcilable CI failures, we may drop support for
that Go version in CI if it is 3 or 4 Go versions old.

### Supported build systems

`gopls` currently only supports the `go` command, so if you are using
a different build system, `gopls` will not work well. Bazel is not officially
supported, but may be made to work with an appropriately configured
`go/packages` driver. See
[bazelbuild/rules_go#512](https://github.com/bazelbuild/rules_go/issues/512)
for more information.
You can follow [these instructions](https://github.com/bazelbuild/rules_go/wiki/Editor-setup)
to configure your `gopls` to work with Bazel.

### Troubleshooting

If you are having issues with `gopls`, please follow the steps described in the
[troubleshooting guide](doc/troubleshooting.md).

## Additional information

* [Features](doc/features.md)
* [Command-line interface](doc/command-line.md)
* [Advanced topics](doc/advanced.md)
* [Contributing to `gopls`](doc/contributing.md)
* [Integrating `gopls` with an editor](doc/design/integrating.md)
* [Design requirements and decisions](doc/design/design.md)
* [Implementation details](doc/design/implementation.md)
* [Open issues](https://github.com/golang/go/issues?q=is%3Aissue+is%3Aopen+label%3Agopls)

[language server]: https://langserver.org
[LSP]: https://microsoft.github.io/language-server-protocol/

# Generate server_gen.go

`helper` generates the file `../server_gen.go` (in package
`internal/lsp`) which contains stub declarations of server methods.

To invoke it, run `go generate` in the `gopls/internal/lsp` directory.

It is derived from `gopls/internal/lsp/protocol/tsserver.go`, which
itself is generated from the protocol downloaded from VSCode, so be
sure to run `go generate` in the protocol first. Or run `go generate
./...` twice in the gopls directory.

It decides what stubs are needed and their signatures
by looking at the `Server` interface (`-t` flag). These all look somewhat like
`Resolve(context.Context, *CompletionItem) (*CompletionItem, error)`.

It then parses the `lsp` directory (`-u` flag) to see if there is a corresponding
implementation function (which in this case would be named `resolve`). If so
it discovers the parameter names needed, and generates (in `server_gen.go`) code
like

``` go
func (s *Server) resolve(ctx context.Context, params *protocol.CompletionItem) (*protocol.CompletionItem, error) {
    return s.resolve(ctx, params)
}
```

If `resolve` is not defined (and it is not), then the body of the generated function is

```go
    return nil, notImplemented("resolve")
```

So to add a capability currently not implemented, just define it somewhere in `lsp`.
In this case, just define `func (s *Server) resolve(...)` and re-generate `server_gen.go`.

# Testing

LSP has "marker tests" defined in `internal/lsp/testdata`, as well as
traditional tests.

## Marker tests

Marker tests have a standard input file, like
`internal/lsp/testdata/foo/bar.go`, and some may have a corresponding golden
file, like `internal/lsp/testdata/foo/bar.go.golden`. The former is the "input"
and the latter is the expected output.

Each input file contains annotations like
`//@suggestedfix("}", "refactor.rewrite", "Fill anonymous struct")`. These annotations are interpreted by
test runners to perform certain actions. The expected output after those actions
is encoded in the golden file.

When tests are run, each annotation results in a new subtest, which is encoded
in the golden file with a heading like,

```bash
-- suggestedfix_bar_11_21 --
// expected contents go here
-- suggestedfix_bar_13_20 --
// expected contents go here
```

The format of these headings vary: they are defined by the
[`Golden`](https://pkg.go.dev/golang.org/x/tools/gopls/internal/lsp/tests#Data.Golden)
function for each annotation. In the case above, the format is: annotation
name, file name, annotation line location, annotation character location.

So, if `internal/lsp/testdata/foo/bar.go` has three `suggestedfix` annotations,
the golden file should have three headers with `suggestedfix_bar_xx_yy`
headings.

To see a list of all available annotations, see the exported "expectations" in
[tests.go](https://github.com/golang/tools/blob/299f270db45902e93469b1152fafed034bb3f033/internal/lsp/tests/tests.go#L418-L447).

To run marker tests,

```bash
cd /path/to/tools

# The marker tests are located in "internal/lsp", "internal/lsp/cmd, and
# "internal/lsp/source".
go test ./internal/lsp/...
```

There are quite a lot of marker tests, so to run one individually, pass the test
path and heading into a -run argument:

```bash
cd /path/to/tools
go test ./internal/lsp/... -v -run TestLSP/Modules/SuggestedFix/bar_11_21
```

## Resetting marker tests

Sometimes, a change is made to lsp that requires a change to multiple golden
files. When this happens, you can run,

```bash
cd /path/to/tools
./internal/lsp/reset_golden.sh
```

c Maxim Markevitch <maxim % hea.iki.rssi.ru>, Wed Aug 30 23:32:38 1995
c 15.3.00: changed acosd to acos

      subroutine theta_phi (x0, y0, x, y, theta, phi)

c x0,y0 and x,y - coords of 2 points,
c theta (pix) and phi (deg) - pos. angle from x axis to vector
c (x0,y0)->(x,y), counterclockwise.

      implicit none
      real x0,y0,x,y,theta,phi,cosphi

      theta=sqrt((x-x0)**2+(y-y0)**2)

      if (theta.gt.0.) then
        cosphi=(x-x0)/theta
        if (y.gt.y0) then
          phi=acos(cosphi)/3.1415926*180
        else
          phi=360.-acos(cosphi)/3.1415926*180
        end if
      else
        phi=0.
      end if
      if (phi.ge.360.) phi=phi-360.


      end

c Maxim Markevitch <maxim % head-cfa.harvard.edu>, last change 30 Jan 7

c 30.1.7: changed string dim. from 128 to 512, removed commas from write()
c 30.8.95: orig.
c Gets numbered parameter in either of the 3 forms: pbase00N, pbase0N, pbaseN

      subroutine get_numbered_param (iret,pfile,pbase,n,val)


      implicit none
      integer iret,n
      character*512 pfile, pname, val
      character*(*) pbase
      integer len,lnblnk


      len=lnblnk(pbase)

      write(pname,'(a,i3.3," ")') pbase(1:len),n
      call get_param (iret,pfile,pname,val)
      if (iret.ne.0) then

        write(pname,'(a,i2.2," ")') pbase(1:len),n
        call get_param (iret,pfile,pname,val)
        if (iret.ne.0) then

          write(pname,'(a,i1," ")') pbase(1:len),n
          call get_param (iret,pfile,pname,val)
        end if 
      end if 
      
      end
      

c Maxim Markevitch <maxim % head.cfa.harvard.edu>, last change 24 Mar 07

c 24.3.7: av added data and save declarations for f95;
c         in write_gti, in_gti to be set by ftgiou instead of newunit
c 30.1.7: string lengths from 128 to 512 (also in get_param.c)
c emandel removed commas from read()/write() for compatib.
c 11.12.1: changed maxgti to 16384 (from 1024), changed printout order.
c 31.1.1: changed ftopen to ftnopn to allow filename[gti] or filename+7
c 7.7.00: this function is made from if_goodtime (file if_goodtime.f) by
c changing name; arg to real*8 tt; also, changed GTI array from integer igti
c to real*8 ggti.
c Also, separated old (int) and new (real*8) versions in different files:
c if_goodtime.f and if_goodttime.f

c 28.1.00: sub read_gti now accepts param name gti_file and gtifile.
c 15.10.95 previous change

      logical function if_goodttime (tt)

      implicit none
      integer maxgti
      parameter (maxgti=16384)
      real*8 tt, tt0, ggti(maxgti,2)
      logical ajunk, if_goodttime0, first_time
      integer ngti,i
      data tt0, if_goodttime0, first_time /-123456d0, .false., .true./
      save ggti, ngti, first_time


      if (first_time) then
        call read_ggti (ggti, maxgti, ngti, ajunk)

*        print*,' r_g ok, ngti', ngti
*        do i=1,ngti
*          print*,ggti(i,1),ggti(i,2)
*        end do 
        first_time=.false.
      end if 


c check this photon:

      if (tt.ne.tt0) then
c if the time is new, do real check:        
      
        if_goodttime=.false.
        do i=1,ngti 
          if (tt.gt.ggti(i,1) .and. tt.lt.ggti(i,2)) then
            if_goodttime=.true.
            goto 1
          end if 
        end do 
 1      continue 

        tt0=tt
        if_goodttime0=if_goodttime

      else 
c else return old value of if_goodttime:
        if_goodttime=if_goodttime0
      end if 

      end
*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
c Maxim Markevitch <maxim % head-cfa.harvard.edu>, 07 Jul 00

c 7.7.00: changed read_gti (file if_goodtime.f) throughout to read GTI into a
c real*8 array instead of integer, and renamed the function to read_ggti.

      subroutine read_ggti (ggti, maxgti, ngti, was_fits)

c read fits file with gti, whose name specified as gti_file in param_file.

      implicit none
      integer maxgti, ngti
      character*1 pfile*512, pname*512, val*512, a80*80, a30*30
      real*8 ggti(maxgti,2), tt0, tt1
      logical anyf, was_fits
      integer in_gti,newunit,iret,junk,istat,ncol,lnblnk,i,nhdu
      common /parf/ pfile

c get gti filename from pfile:
      pname="gti_file "
      call get_param (iret, pfile, pname, val)

      if (iret.ne.0) then
        pname="gtifile "
        call get_param (iret, pfile, pname, val)

        if (iret.ne.0) then
          print'(" no gti_file provided, assuming all times are good")'
        
          ngti=1
          ggti(1,1)=0d0
          ggti(1,2)=999999999d0
        
          return
        end if 
      end if 
      
c open it:
      istat = 0
      call ftgiou (in_gti,istat)
      call ftnopn (in_gti, val, 0, istat)
      
      if (istat.eq.0) then
c this is fits:
        
c get the current ext number and see if need to move (if the filename did 
c not contain the ext already):
        call ftghdn (in_gti, nhdu)

        if (nhdu.eq.1) then
c did not specify ext in the filename, so need to move to 2nd hdu (1st ext
c after primary array):
          call ftmahd (in_gti, 2, junk, istat)
        end if 

        call ftgkyj (in_gti, "NAXIS2", ngti, a80, istat)
        
        call ftgcno (in_gti, .false.,"START", ncol, istat)
        
c check if have column "START" (this will check if we are in a GTI ext.):
        if (istat.ne.0) then
          call ftgerr (istat, a30)
          print'(" read_ggti: error <",a,"> on file")',a30(1:lnblnk(a30))
          print'(" ",a65)',val
          print'(" exiting.")'
          
          call exit(1)
        end if
   
c check maxgti:     
        if (istat.eq.0.and.ngti.gt.maxgti) then
          print'(" read_ggti: increase maxgti=",i5," in the code. exiting.")',
     ~        maxgti
          call exit(1)
        end if 

c read the rest:

c read values in START:
        call ftgcvd (in_gti, ncol, 1,1, ngti, -1, ggti(1,1), anyf, istat)
        
        call ftgcno (in_gti, .false.,"STOP", ncol, istat)
        call ftgcvd (in_gti, ncol, 1,1, ngti, -1, ggti(1,2), anyf, istat)
        
        if (istat.ne.0) then
          call ftgerr (istat, a30)
          print'(" read_ggti: error <",a,"> on file")',a30(1:lnblnk(a30))
          print'(" ",a65)',val
          print'(" exiting.")'
          
          call exit(1)
        end if
        
        call ftclos (in_gti, istat)
        call ftfiou (in_gti, istat)
        was_fits=.true.

      else
c maybe gti file is ascii:
        istat=0
        call ftclos (in_gti, istat)
        istat = 0
        call ftfiou (in_gti, istat)
        istat = 0
        
        in_gti=newunit()
        open(in_gti, file=val, status="old", iostat=iret)

        if (iret.eq.0) then
          ngti=0
          do i=1,maxgti
            read(in_gti,*,iostat=iret) tt0, tt1
            if (iret.eq.0) then
              ggti(i,1)=tt0
              ggti(i,2)=tt1
              ngti=i
            end if
          end do
          if (ngti.eq.0) then
            print'(" read_ggti: gti_file is empty? exiting.")'
            call exit(1)
          end if 
          close(in_gti)
        else
          print'(" read_ggti: cannot open gti file, tried fits and ascii:")'
          print'(" ",a70)',val
          print'(" exiting.")'
          call exit(1)
        end if 

        was_fits=.false.
      end if 
      
*      do i=1,ngti
*        print*,i,ggti(i,1),ggti(i,2)
*      end do 

      end

c 24.3.7: av added save statement

      FUNCTION URAND(IY)
      DOUBLE PRECISION HALFM
      DATA ITWO/2/,M2/0/
      save HALFM, ITWO, M2, M, IC, IA, MIC, S

      IF(M2.NE.0) GO TO 20
      M=1
 10   M2=M
      M=ITWO*M2
      IF(M.GT.M2) GO TO 10
      HALFM=M2
      IC=912703751
      IA=660258821
      MIC=(M2-IC)+M2
      S=0.5/HALFM
 20   IY=IY*IA
      IF(IY.GT.MIC) IY=(IY-M2)-M2
      IY=IY+IC
      IF(IY.LT.0) IY=(IY+M2)+M2
      URAND=FLOAT(IY)*S
      RETURN
      END

c Removes blanks from the string s
c (from A.Vikhlinin)

      subroutine rmblanks (s)

      character*(*) s
      integer len,lnblnk,n,i
      
      len=lnblnk(s)
      
      n=0
      do i=1,len
        if(s(i:i).ne.' '.and.s(i:i).ne.'\t')then
          n=n+1
          s(n:n)=s(i:i)
        endif
      enddo
      
      do i=n+1,len
        s(i:i)=' '
      enddo
      
      end

c 9.2.01 MM: made it a func (was sub) returining the ret code of ini_pixlib_0
c this piece is originally from AV, changes by JCM

      function ini_pixlib (aimpoint, fpsys)
      implicit none
      character*(*) aimpoint, fpsys
      integer ini_pixlib
      integer*2 ini_pixlib_0

      character*80 aim, fp
      integer lnblnk, i

      aim = aimpoint
      fp  = fpsys

      i = lnblnk(aim)+1
      aim(i:i)=char(0)
      i = lnblnk(fp)+1
      fp(i:i)= char(0)
      
      ini_pixlib=ini_pixlib_0 (aim,fp) 
c                (C function, see file pixlib_interface.c)

      end

c Returns position of first occurence of substring c in string cs. 0 if not
c present.
c (from A.Vikhlinin)

      integer function istrchr(cs,c)

      implicit none
      character*(*) cs,c
      integer lnblnk,n,n1,i
      
      n=lnblnk(cs)
      n1=lnblnk(c)-1

      do i=1,n-n1
        if(cs(i:i+n1).eq.c)then
          istrchr=i
          return
        endif
      enddo
        
      istrchr=0

      end

c Maxim Markevitch <maxim % head.cfa.harvard.edu>, last update 14 Aug 07

c 14.8.7: emandel changed 0->0.0 in all write statements for compiler
c 24.3.7: av added istat=0
c 1.2.7: emandel fixed syntax, mm fixed format error, to run on f95
c 30.1.7: string lengths from 128 to 512 (also in get_param.c)
c emandel removed commas from read() for compatib.
c 6.10.5: instead of rejecting bins with >2% gti gaps, include all bins
c         with more than okfrac=90% of good time (correcting tbin for okfrac),
c         even those with one bound outside of gti, which were 
c         automatically excluded before.
c 5.10.5: 1. select tstart as max(header,gti,1stevt); was from header
c         2. check for gti gaps inside each lc bin; if >okfrac, exclude bin
c         3. if both ends of bin are outside gti, look for narrow gti fully 
c            enclosed, exclude if present
c         4. instead of excluding gtis<tbin, for each excluded lc bin reset
c            any inside gti bounds to the bin bounds, and then exclude only
c            gtis<1s. This saves good bins containing narrow gti gaps
c            which follow an excluded bin.
c         5. manually exclude gtis prior to tstart (G. Sivakoff)
c 4.10.5: filter by ratio of rates in 2 energy bands (par. fileref*);
c         print more decimal places;
c         added write_separate_chips par (instead of always writing sep. chips)
c 23.10.3: check par. ignore_neg_devs in addition to ignore_neg_dev
c   removed commas in write(), to compile by intel fortran
c 30.5.3: increased maxev to 4e6
c 12.7.2: added ignore_neg_dev (default not ignore, exclude from gti),
c  ignore_spikes now only applies to positive deviations.
c 3.4.2: fixed writing of individ. chip's light curves (was writing rlight
c  instead of rlchip)
c 24.2.2: tbin -> r*8 ttbin; compare gtis with 0.999*ttbin to avoid num
c  problem; fixed missing 1st and last lc bins when writing histogr.
c 11.12.1: note that maxgti here and in if_goodttime are different
c  (no changes in this file)
c 3.10.1: in write_gti, replaced ftcopy with ftcphd (no longer copy the data
c   from input gti and overwrite it); now update checksums. added summing of
c   narrow and bin boundary gtis; changed some printout.
c 1.8.1:  added error diagn. printout, renamed tbeg -> tstart for clarity
c 27.6.1: initialize istat=0, because g77 doesn't. 
c 6.2.1:  parameter write_table_lc; print how much zero-rate time excluded;
c   calc and writing now use (mink,maxk) index interval instead of (0,maxlc)
c 31.1.1: take care of ext# in input gti file, if given (in if_goodttime.f and
c   sub write_gti below)
c 26.10.00: fixed minor bugs: exclude from the final GTI the lc bins sitting on
c   the boundaries of the original GTIs (added -2 flag to rlight);
c   fixed writing GTI in ascii format (iout_gti was undefined);
c   changeg output format for times and rates to f*.3
c 7.7.00: changed int itime to real*8 ttime, tbeg -> real*8 ttbeg,
c   itbin -> tbin; igti to real*8 ggti; if_goodtime to real*8 version
c   if_goodttime; read_gti to real*8 ver. read_ggti; sort -> ssort, i t.p.
c 15.3.00: now takes par file name from command line; says if cannot open it.
c 20.10.99: now outputs count rate after cleaning.
c 20.8.99: many changes to user interface.
c   clean_lc -> lc_clean (adopt for ACIS); changed num of chips from 0:3 (SIS)
c   to 0:9.

c clean_lc for ASCA:
c 23.12.97: changed printout when asking for tbeg
c 7.7.97 (v2): changed lc creation algorithm to use nonchronologic input
c files; added parameters tbeg, ignore_nodata and ignore_spikes
c 14.5.97 (v1.4): output uncleaned light curves for individual sis chips, to
c check for saturation. also, replace ? in the output filenames by s0, g2 etc.

      parameter (maxev=4 000 000, maxlc=50 000, maxgti=2048, clip0=3.,
     ~    okfrac=0.9)
      character*1 pfile*512, pname*512, val*512, a80*80, a30*30, fname*512,
     ~    a1*1,a2*2,a8*8, accd(maxev)
      integer lnblnk
      real rlight(0:maxlc,2), rlchip(0:maxlc,0:9)
      real*8 mmean, mmean2, ttime(maxev),tt,tt0,ttz, ggti(maxgti,2),
     ~    jjunk1(maxgti), jjunk2(maxgti), ttbin, ttb,tte,
     ~    ttstart, ttstartgti, ttstarthead, ttstartevt
      logical anyf, was_fits, if_goodttime, have_tstart,
     ~    ignore_nodata, ignore_spikes, ignore_neg_dev,
     ~    acis, chips(0:9),
     ~    filt_sigma, filt_factor, force_mean, write_table_lc, filt_ratio,
     ~    write_separate_chips, tstart_undecided, use_gtistart
      data chips /10*.false./
      common /parf/ pfile
      istat=0

      print*
      print'(" This is lc_clean v140807")'
      print*


c get name of par file from command line, if supplied:
      call getarg (1,pfile)

*      print*,"_",lnblnk(pfile),"_"
* check lnblnk on intel

      if (pfile(1:1).eq."@") then
c cut AV's leading @:
        pfile=pfile(2:lnblnk(pfile))
      end if
      if (pfile.eq."") then
        pfile="lc_clean.par"
      end if 


c read parameters:

c how many data files:
      pname="num_datafiles "
      call get_param (iret, pfile, pname, val)
      if (iret.eq.255) then
        print'(" Cannot open or read parameter file.")'
        call exit(1)
      end if
      if (iret.eq.0) read(val,*,iostat=iret) nfiles
      if (iret.ne.0) then
        print'(" lc_clean: please set num_datafiles")'
        call exit(1)
      end if 
      
c get binsize for the lightcurve:
      pname="binsize "
      call get_param (iret, pfile, pname, val)
      if (iret.eq.0) read(val,*,iostat=iret) ttbin
      if (iret.ne.0) then
        ttbin=200.
        print*,' will use 200 sec bins; to override, set parameter binsize'
      end if
      print'(" binsize=",f8.2)',ttbin

c try to get mean rate from par file:
      pname="mean "
      call get_param (iret, pfile, pname, val)
      if (iret.eq.0) read(val,*,iostat=iret) rmean
      force_mean=(iret.eq.0)

c clipping (in sigmas) for calculation of mean:
      pname="clip "
      call get_param (iret, pfile, pname, val)
      if (iret.eq.0) read(val,*,iostat=iret) clip
      if (iret.ne.0) then
        clip=clip0
      else
        if (force_mean) then 
          print'(" Ignoring clip parameter because mean is set")'
        end if
      end if

      if (force_mean) then
        print'(" mean=",f7.4)',rmean
      else
        print'(" clip=",f4.2)',clip
      end if

c get max deviation for the lightcurve:
      pname="max_sigma "
      call get_param (iret, pfile, pname, val)
      if (iret.eq.0) read(val,*,iostat=iret) sigma_max
      if (iret.eq.0) then
        filt_sigma=.true.
        filt_factor=.false.
        print'(" max_sigma=",f5.2)',sigma_max
      else
        filt_sigma=.false.
        filt_factor=.true.
        
c try getting max_factor:
        pname="max_factor "
        call get_param (iret, pfile, pname, val)
        if (iret.eq.0) read(val,*,iostat=iret) factor_max
        if (iret.ne.0) then
          print*,' cannot get either max_sigma or max_factor, will use'
          print*,' max_factor=2'
          factor_max=2
        end if
        print'(" max_factor=",f6.3)',factor_max
      end if


c observ beginning time in seconds (if not set then later take it equal to the
c tstart of the first datafile, which will work with the old observations that
c have chronologic files): 
      pname="tstart "
      call get_param (iret, pfile, pname, val)
      if (iret.ne.0) then
        pname="tbeg "
        call get_param (iret, pfile, pname, val)
      end if 
      if (iret.eq.0) read(val,*,iostat=iret) ttstart
      have_tstart=(iret.eq.0.and.ttstart.gt.0)
        
c whether to ignore (leave in gti) zero photon bins:
      pname="ignore_nodata "
      call get_param (iret, pfile, pname, val)
      if (iret.eq.0) read(val,'(a1)',iostat=iret) a1
      ignore_nodata=(iret.eq.0.and.(a1.eq."y".or.a1.eq."Y"))
        
c whether to ignore (leave in gti) positive spikes of the lightcurve:
      pname="ignore_spikes "
      call get_param (iret, pfile, pname, val)
      if (iret.eq.0) read(val,'(a1)',iostat=iret) a1
      ignore_spikes=(iret.eq.0.and.(a1.eq."y".or.a1.eq."Y"))

c whether to ignore (leave in gti) negative deviations:
      pname="ignore_neg_dev "
      call get_param (iret, pfile, pname, val)
      if (iret.ne.0) then
c       in case of a typo:
        pname="ignore_neg_devs "
        call get_param (iret, pfile, pname, val)
      end if
      if (iret.eq.0) read(val,'(a1)',iostat=iret) a1
      ignore_neg_dev=(iret.eq.0.and.(a1.eq."y".or.a1.eq."Y"))
      if (ignore_neg_dev) print'(" ignore_neg_dev=y")'


c whether to write lc in the form of a normal ascii table (not histogram):
      pname="write_table_lc "
      call get_param (iret, pfile, pname, val)
      if (iret.eq.0) read(val,'(a1)',iostat=iret) a1
      write_table_lc=(iret.eq.0.and.(a1.eq."y".or.a1.eq."Y"))

c whether to write dirty lc for separate acis chips (in addition to sum lc):
      pname="write_separate_chips "
      call get_param (iret, pfile, pname, val)
      if (iret.eq.0) read(val,'(a1)',iostat=iret) a1
      write_separate_chips=(iret.eq.0.and.(a1.eq."y".or.a1.eq."Y"))

c whether to filter by ratio instead of the rate:
      pname="fileref1 "
      call get_param (iret, pfile, pname, val)
      if (iret.eq.0) read(val,'(a1)',iostat=iret) a1
      filt_ratio=(iret.eq.0)
      
      if (filt_ratio) then
        nbands=2
      else
        nbands=1
      end if

      do i=0,maxlc
        rlight(i,1)=0
        rlight(i,2)=0
        do ic=0,9
          rlchip(i,ic)=0
        end do
      end do


c read input gti (will need here for info):
      call read_ggti (ggti,maxgti,ngti,was_fits)

c beg. of gti, for a later decision which tstart to use:
      ttstartgti=ggti(1,1)

      tstart_undecided=.true.

c go through data files:
      do ifile=1,nfiles
        do iband=1,nbands

          if (iband.eq.1) then
            call get_numbered_param (iret,pfile,"file ",ifile,val)
          else
            call get_numbered_param (iret,pfile,"fileref ",ifile,val)
          end if

          if (iret.ne.0) then
            print'(" lc_clean: cannot get file",i3.3,", ignored")',ifile
          else

            call ftgiou (ifi, istat)
            call ftopen (ifi, val, 0, junk, istat)
            call ftmnhd (ifi, -1, "EVENTS", 0, istat)

c tstart keyword from header of 1st file, for a later decision on tstart:
            if (tstart_undecided) then
c (cannot just check for ifile=1 because that file may be missing)
              call ftgkyd (ifi,"TSTART",ttstarthead,a80,istat)
            end if

            call ftgkys (ifi, "INSTRUME", a8, a80, istat)
            if (istat.eq.0) then
              acis=(a8(1:lnblnk(a8)).eq."ACIS")
            else
              acis=.false.
            end if

            call ftgkyj (ifi, "NAXIS2", nrows, a80, istat)
            if (nrows.gt.maxev) then
              print'(" lc_clean: increase maxev in the code or"//
     ~            " split this event file:")'
              print'(" n events = ",i7,", maxev = ",i7)',nrows,maxev
              call exit(0)
            end if
            
            call ftgcno (ifi,.false.,"TIME",ncol,istat)
            call ftgcvd (ifi,ncol, 1,1, nrows, -1, ttime, anyf, istat)

c time of 1st photon in 1st evt file:
            if (tstart_undecided) then
              ttstartevt=ttime(1)
            end if

            if (acis) then
              call ftgcno (ifi,.false.,"CCD_ID",ncol,istat)
              call ftgcvb (ifi,ncol, 1,1, nrows, -1, accd, anyf, istat)
            end if

            call ftclos (ifi,istat)
            call ftfiou (ifi,istat)
            if (istat.ne.0) then
              call ftgerr (istat, a30)
              print'(" lc_clean: fitsio err <",a,"> in file")',
     ~            a30(1:lnblnk(a30))
              print'(" ",a,", ignoring it")',val(1:lnblnk(val))
              istat=0
            else

c Now decide at what time to start the lc:
c if tstart was set explicitly in par file, use that; otherwise,
c use the later of the 3 values: beg of gti, header tstart, time of 1st evt.
c Note that if evt files are not chronological, must have tstart par.
              if (tstart_undecided) then
                if (.not.have_tstart) then
                  ttstart=max(ttstartgti,ttstarthead,ttstartevt)
                  use_gtistart=(ttstart.lt.ttstartgti+0.0001)
c                              (testing if ttstart=ttstartgti)
                end if
                tstart_undecided=.false.
              end if
 
c go through events in this data file:
              ngood=0
            
              do i=1,nrows
                tt=ttime(i)
                if (if_goodttime(tt)) then
                  ngood=ngood+1
                
c add this photon to the lightcurve:
                  k=(tt-ttstart)/ttbin
                  if (k.ge.0.and.k.le.maxlc) then
                    rlight(k,iband)=rlight(k,iband)+1

                    if (acis.and..not.filt_ratio) then
                      ic=ichar(accd(i))
                      if (ic.ge.0.and.ic.le.9) then
                        rlchip(k,ic)=rlchip(k,ic)+1
                        chips(ic)=.true.
                      end if
                    end if

                  else
                    if (k.gt.maxlc) then
                      print'(" lc_clean: increase maxlc in the code:")'
                      print'(" maxlc=",i6,"  tstart=",f15.2,'//
     ~                    '" event t=",f15.2)',maxlc,ttstart,tt

                      call exit(1)
                    else
c an event has t<tstart; OK if par. tstart was set or tstart is taken
c from gti, otherwise not OK: 
                      if (have_tstart.or.use_gtistart) then
c ignore, go to next photon
                      else
                        print'(" lc_clean: multiple evt files are not in chronological order?")'
                        print'(" if so, set a parameter tstart manually.")'
                        print'(" tstart=",f15.2," event t=",f15.2)',
     ~                      ttstart,tt

                        call exit(1)
                      end if
                    end if
                  end if
                end if
              end do
              if (iband.eq.1) then
                print'(" ",a,i7," evt")',val(1:lnblnk(val)),nrows
              else
                print'(" /",a,i7," evt")',val(1:lnblnk(val)),nrows
              end if
            end if
          end if
        end do
      end do
      print*
      
c Lightcurve done (if filt_ratio=true, in 2 bands).
c Now normalize it to cts/s and remove bins that are wholly
c or partially outside of original GTIs, assigning them -1 (partially) or -2
c (either whole bin is outside or both beg and end of the bin are outside).
c The -2 bins will be excluded from the clean GTIs; -1 bins will be
c ignored in calculations and excluded from GTI. Bins wholly within GTI 
c but with zero events will remain 0 (will be handled in a special way).
c Bins -2 have 0 events by way the lc was created. If a bin with both bounds
c outside GTIs has a narrow GTI wholly inside it, it is assigned -1.

      maxlc1=(ggti(ngti,2)-ttstart)/ttbin+1

      mink=maxlc1
      maxk=0
c (will be min and max bins that are at least partially inside the orig gtis)

      itnarrow=0
      itbound=0

      do i=0,maxlc1
        tt=ttstart+i*ttbin
        if (if_goodttime(tt).or.if_goodttime(tt+ttbin)) then
c at least one end of the bin is inside the original GTIs. Check if the good
c fraction of the bin is > okfrac, then correct tbin for this fraction;
c otherwise reject as a boundary bin (this will include bins whose both ends
c are inside gti but which contain a large gti gap inside).
          igap=0
          it0=tt+1
          it1=tt+ttbin-1
          do it=it0,it1
            if (.not.if_goodttime(dble(it))) igap=igap+1
          end do
          ttbin1=ttbin-igap

          if (ttbin1/ttbin.lt.okfrac) then
            rlight(i,1)=-1
            itbound=itbound+ttbin
          else

c bin OK:
            if (.not.filt_ratio) then
              rlight(i,1)=rlight(i,1)/ttbin1

              if (acis) then
                do ic=0,9
                  rlchip(i,ic)=rlchip(i,ic)/ttbin1
                end do
              end if
            else
c rlight(i,1) will contain the ratio in 2 bands:
              if (rlight(i,2).gt.0) then
                rlight(i,1)=rlight(i,1)/rlight(i,2)
              else
                rlight(i,1)=0
              end if
            end if
          end if

          if (i.lt.mink) mink=i
          if (i.gt.maxk) maxk=i

        else
c both ends of the bin are outside gti, but check if this bin encloses
c a narrow gti, to be rejected explicitly (ignore a small probability to have
c a gti > okfrac fully enclosed in the bin):
          it0=tt+1
          it1=tt+ttbin-1
          itnarr=0
          do it=it0,it1
            if (if_goodttime(dble(it))) itnarr=itnarr+1
          end do
          if (itnarr.gt.0) then
            itnarrow=itnarrow+itnarr
            if (i.lt.mink) mink=i
            if (i.gt.maxk) maxk=i
            
            rlight(i,1)=-1
          else
c completely outside the gti and doesn't contain any narrow gti, so won't
c need to do anything about this bin:
            rlight(i,1)=-2
          end if
        end if
      end do


c write uncleaned lightcurves:

      pname="lc_dirty "
      call get_param (iret, pfile, pname, val)
      if (iret.eq.0) then
c replace ? by instr:
        k1=istrchr(val,"?")
        if (k1.gt.0) then
          if (acis) then
            fname=val(1:k1-1)//"acis"//val(k1+1:lnblnk(val))
          else
            fname=val(1:k1-1)//"hrc"//val(k1+1:lnblnk(val))
          end if
        else
          fname=val
        end if

c write the total detector uncleaned lightcurve for sm:
        ifi=newunit()
        open(ifi,file=fname,iostat=iret)
        if (iret.eq.0) then
          do i=mink,maxk
            if (.not.write_table_lc) then
c write a histogram, excluding bad bins:
              if (rlight(i,1).gt.-1) then

                if (i.eq.mink) then
                  write(ifi,'(f13.3,f10.5)') ttstart+i*ttbin,0.0
                else
                  if (rlight(i-1,1).le.-1) then
                    write(ifi,'(f13.3,f10.5)') ttstart+i*ttbin,0.0
                  end if
                end if

                write(ifi,'(f13.3,f10.5)') ttstart+i*ttbin, rlight(i,1)
                write(ifi,'(f13.3,f10.5)') ttstart+(i+1)*ttbin, rlight(i,1)

                if (i.eq.maxk) then
                  write(ifi,'(f13.3,f10.5)') ttstart+(i+1)*ttbin,0.0
                else
                  if (rlight(i+1,1).le.-1) then
                    write(ifi,'(f13.3,f10.5)') ttstart+(i+1)*ttbin,0.0
                  end if
                end if

              end if

            else
c write an ascii table, listing all bins:
              if (rlight(i,1).gt.-1) then
                write(ifi,'(f13.3,f10.5)') ttstart+i*ttbin+ttbin/2,rlight(i,1)
              else
                write(ifi,'(f13.3,f10.5)') ttstart+i*ttbin+ttbin/2,0.0
              end if
            end if

          end do 
          close (ifi)
        end if

c for acis, also write uncleaned lightcurves for separate chips:
        if (acis.and.write_separate_chips.and..not.filt_ratio) then
          do ic=0,9
            if (chips(ic)) then
              k1=istrchr(val,"?")
              if (k1.gt.0) then
                write(a2,'("c",i1)') ic
                fname=val(1:k1-1)//a2//val(k1+1:lnblnk(val))
              else
                write(fname,'(a,".c",i1)') val(1:lnblnk(val)),ic
              end if

              ifi=newunit()
              open(ifi,file=fname,iostat=iret)
              if (iret.eq.0) then
                do i=mink,maxk

                  if (.not.write_table_lc) then
c write a histogram, excluding bad bins:
                    if (rlight(i,1).gt.-1) then

                      if (i.eq.mink) then
                        write(ifi,'(f13.3,f10.5)') ttstart+i*ttbin,0.0
                      else
                        if (rlight(i-1,1).le.-1) then
                          write(ifi,'(f13.3,f10.5)') ttstart+i*ttbin,0.0
                        end if
                      end if

                      write(ifi,'(f13.3,f10.5)') ttstart+i*ttbin, rlchip(i,ic)
                      write(ifi,'(f13.3,f10.5)') ttstart+(i+1)*ttbin,
     ~                    rlchip(i,ic)

                      if (i.eq.maxk) then
                        write(ifi,'(f13.3,f10.5)') ttstart+(i+1)*ttbin,0.0
                      else
                        if (rlight(i+1,1).le.-1) then
                          write(ifi,'(f13.3,f10.5)') ttstart+(i+1)*ttbin,0.0
                        end if
                      end if
                    end if
                  else
c write an ascii table, listing all bins:
                    if (rlight(i,1).gt.-1) then
                      write(ifi,'(f13.3,f10.5)') ttstart+i*ttbin+ttbin/2,
     ~                    rlchip(i,ic)
                    else
                      write(ifi,'(f13.3,f10.5)') ttstart+i*ttbin+ttbin/2,0.0
                    end if 
                  end if

                end do
                close (ifi)
              end if
            end if
          end do
        end if
      end if 

c now clean the lc:

      if (force_mean) then
        mmean=rmean
        if (filt_ratio) then
          print'(" Using preset mean ratio ",f8.4)',mmean
        else
          print'(" Using preset mean rate ",f8.4," cts/s")',mmean
        end if
      else
c calc mean by 3-sigma clipping:
        mmean=0d0
        mmean2=0d0
        n=0
        do i=mink,maxk
          if (rlight(i,1).gt.0) then
            mmean=mmean+dble(rlight(i,1))
            if (filt_ratio) mmean2=mmean2+dble(rlight(i,2))
            n=n+1
          end if
        end do
        if (n.eq.0) then
          print'(" no valid time bins")'
          call exit(0) 
        end if
c mean before clipping:
        mmean=mmean/n
        if (filt_ratio) mmean2=mmean2/n

        if (filt_ratio) then
c mmean contains ratio, mmean2 contains denominator in cts (not cts/s);
c sigma(n/m)= n/m * sqrt(1/n + 1/m); n=mean*mean2, m=mean2:
          sig=mmean*sqrt(1./(mmean*mmean2)+1./mmean2)
        else
          sig=sqrt(mmean*ttbin)/ttbin
        end if
        rate_min=mmean-clip*sig
        rate_max=mmean+clip*sig

*        if (filt_ratio) then
*          print'(" Using ",f4.1,"-sigma clipping to calculate mean ratio")',
*     ~        clip
*        else
*          print'(" Using ",f4.1,"-sigma clipping to calculate mean rate")',
*     ~        clip
*        end if
        
        mmean=0d0
        mmean2=0d0
        n=0
        do i=mink,maxk
          if (rlight(i,1).gt.0
     ~        .and.rlight(i,1).gt.rate_min.and.rlight(i,1).lt.rate_max) then
            mmean=mmean+dble(rlight(i,1))
            if (filt_ratio) mmean2=mmean2+dble(rlight(i,2))
            n=n+1
          end if
        end do
        if (n.eq.0) then
          print'(" cannot calculate mean, try setting it manually")'
          call exit(0) 
        end if
c mean after clipping:
        mmean=mmean/n
        if (filt_ratio) mmean2=mmean2/n

        if (.not.filt_ratio) then
          print'(" Calculated mean rate ",f8.4," cts/s")',mmean
        else
          print'(" Calculated mean ratio ",f8.4)',mmean
        end if
      end if

      if (filt_sigma) then
        if (filt_ratio) then
          sig=mmean*sqrt(1./(mmean*mmean2)+1./mmean2)
        else
          sig=sqrt(mmean*ttbin)/ttbin
        end if
        rate_min=mmean-sigma_max*sig
        rate_max=mmean+sigma_max*sig
      else
        rate_min=mmean/factor_max
        rate_max=mmean*factor_max
      end if

      if (.not.filt_ratio) then
        print'(" Removing bins with rate outside ",f8.4," -",f8.4," cts/s")',
     ~      rate_min,rate_max
      else
        print'(" Removing bins with ratio outside ",f8.4," -",f8.4)',
     ~      rate_min,rate_max
      end if
c min and max rate done.

 
c to check later how much time we excluded, calc sum of input gtis:
      tt0=0
      do i=1,ngti
        tt0=tt0+ ggti(i,2)-ggti(i,1)
      end do 

      ttz=0
      do i=mink,maxk
c add zero-rate time inside the original GTIs:
        if (rlight(i,1).eq.0.and..not.ignore_nodata) ttz=ttz+ttbin

        if ((rlight(i,1).gt.0 .and.rlight(i,1).gt.rate_max
     ~      .and..not.ignore_spikes)
     ~      .or.
     ~      (rlight(i,1).gt.0 .and.rlight(i,1).lt.rate_min
     ~      .and..not.ignore_neg_dev)
     ~      .or.
     ~      (rlight(i,1).eq.0 .and..not.ignore_nodata)) then

c bad bin, exclude it from gti:
          rlight(i,1)=-1
        end if

        if (rlight(i,1).eq.-1) then
          ttb=ttstart+i*ttbin
          tte=ttstart+(i+1)*ttbin
c exclude from the GTIs the bins that satisfied the above criterion, and in
c addition the -1 bins identified earlier (sitting on the original GTI bounds, 
c or enclosing a narrow GTI, or including a wider-than-okfrac GTI gap,
c but not the -2 bins, which are already completely outside the gtis):

c first, look inside this bin for any gti bounds and reset them to the bin
c bounds, to avoid complications with gtis narrower than the bin:
          do k=1,ngti
            if (ggti(k,1).gt.ttb.and.ggti(k,1).lt.tte) ggti(k,1)=tte
            if (ggti(k,2).gt.ttb.and.ggti(k,2).lt.tte) ggti(k,2)=ttb
          end do

c append end of the bad bin to the column of gti t_beg, and beg of the bad
c bin to the column of gti t_end:
          ngti=ngti+1
          if (ngti.le.maxgti) then
            ggti(ngti,1)=tte
            ggti(ngti,2)=ttb
          else
            print'(" lc_clean: increase maxgti=",i4," in the code. exiting.")'
     ~          ,maxgti
            call exit(1)
          end if 
        end if 
      end do 


c write the cleaned lightcurve:
      pname="lc_clean "
      call get_param (iret, pfile, pname, val)
      if (iret.eq.0) then
        k1=istrchr(val,"?")
        if (k1.gt.0) then
          if (acis) then
            fname=val(1:k1-1)//"acis"//val(k1+1:lnblnk(val))
          else
            fname=val(1:k1-1)//"hrc"//val(k1+1:lnblnk(val))
          end if
        else
          fname=val
        end if

        ifi=newunit()
        if (iret.eq.0) open(ifi,file=fname,iostat=iret)
        if (iret.eq.0) then
          do i=mink,maxk

            if (.not.write_table_lc) then
c write a histogram, excluding bad bins:
              if (rlight(i,1).gt.-1) then

                if (i.eq.mink) then
                  write(ifi,'(f13.3,f10.5)') ttstart+i*ttbin,0.0
                else
                  if (rlight(i-1,1).le.-1) then
                    write(ifi,'(f13.3,f10.5)') ttstart+i*ttbin,0.0
                  end if
                end if

                write(ifi,'(f13.3,f10.5)') ttstart+i*ttbin, rlight(i,1)
                write(ifi,'(f13.3,f10.5)') ttstart+(i+1)*ttbin, rlight(i,1)

                if (i.eq.maxk) then
                  write(ifi,'(f13.3,f10.5)') ttstart+(i+1)*ttbin,0.0
                else
                  if (rlight(i+1,1).le.-1) then
                    write(ifi,'(f13.3,f10.5)') ttstart+(i+1)*ttbin,0.0
                  end if
                end if

              end if

            else
c write an ascii table, listing all bins:
              if (rlight(i,1).gt.-1) then
                write(ifi,'(f13.3,f10.5)') ttstart+i*ttbin+ttbin/2, rlight(i,1)
              else
                write(ifi,'(f13.3,f10.5)') ttstart+i*ttbin+ttbin/2, 0
              end if 
            end if

          end do 
          close (ifi)
        end if
      end if


c now reorder the gti t_beg and t_end columns:
      do i=1,ngti
c if any gti low bound < tstart, reset it to tstart (otherwise, if 1st lc
c bin was ok, that part of gti is not excluded - noticed by G Sivakoff):
        if (ggti(i,1).lt.ttstart) ggti(i,1)=ttstart
        jjunk1(i)=ggti(i,1)
        jjunk2(i)=ggti(i,2)
      end do
      call ssort (ngti,jjunk1)
      call ssort (ngti,jjunk2)

c now clean GTIs < 1s (this includes GTIs which now became negative)
c (should exclude only gtis <= 0, but have used 1s steps to 
c check for the presence of narrow gtis inside lc bins, so should also exclude 
c gtis <1s).
c Note that in version <051005, excluded gtis<tbin here; this excluded some
c good bins if there was a narrow gti gap inside. Now, resetting bounds of gtis
c inside bad bins (see above) so this is not necessary.
      tt=0
      kgti=0
      do i=1,ngti
        if (jjunk2(i)-jjunk1(i).gt.1) then
          kgti=kgti+1
          ggti(kgti,1)=jjunk1(i)
          ggti(kgti,2)=jjunk2(i)

          tt=tt+ ggti(kgti,2)-ggti(kgti,1)
        end if 
      end do 
      ngti=kgti
      print'(" Discarded ",i6," s of bad time bins")',int(tt0-tt) 
      print'(" (of them",i6," s zero rate, approx",i6," s boundary bins and narrow GTIs)")',
     ~      int(ttz),itnarrow+itbound
      print*
      print'(" Good time left ",i7," s")',int(tt)


c calc cleaned rate:
      mmean=0d0
      n=0
      do i=mink,maxk
        if (rlight(i,1).gt.-1) then
          mmean=mmean+dble(rlight(i,1))
          n=n+1
        end if
      end do
      if (n.gt.0) then
        if (filt_ratio) then
          print'(" Mean cleaned ratio ",f8.4)',mmean/n
        else
          print'(" Mean cleaned rate ",f8.4," cts/s")',mmean/n
        end if
      end if

      call write_gti (tt,tt0-tt, ggti, maxgti, ngti, was_fits)

*      print*
*      print'(" Compare cleaned and uncleaned lightcurves and if unhappy,")'
*      print'(" try setting the parameter mean to the expected value.")'

      call exit(0) 
      end
*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

c 31.1.1: take care of ext# in input gti file, if given
c 7.7.00: edited throughout to use real*8 time and gti instead of integer.
c 20.8.99: removed instr from list of args and from filename.

      subroutine write_gti (ttgood,ttdisc, ggti, maxgti, ngti, tobe_fits)

c write fits file with cleaned gti to the clean_gti_file in pfile.
c copies all header stuff from gti_file.

      character*1 pfile*512, pname*512, val*512, f512*512, sig*50,
     ~    history*70, a30*30
      real*8 ggti(maxgti,2), ttgood,ttdisc
c     external unlink
      logical tobe_fits
      common /parf/ pfile


      sig="lc_clean v240307 (M. Markevitch)"

c get name of clean_gti_file and open it:
      pname="clean_gti_file "
      call get_param (iret, pfile, pname, f512)
      if (iret.ne.0) then
        return
c (filename not supplied, assume we don't want to write it)
      end if


c get gti filename from pfile:
      if (tobe_fits) then
        pname="gti_file "
        call get_param (iret, pfile, pname, val)
        if (iret.ne.0) then
          print'(" write_gti: cannot get gti_file name, will write ascii")'
          tobe_fits=.false.
        end if
      end if


      if (tobe_fits) then
c open fits:
        istat = 0
        call ftgiou (in_gti, istat)

        call ftnopn (in_gti, val, 0, istat)

        if (istat.gt.0) then
          call ftgerr (istat, a30)
          print'(" write_gti: fitsio err <",a,"> on file")',a30(1:lnblnk(a30))
          print'("   ",a,", cannot write clean_gti_file")',val(1:lnblnk(val))
          return
        end if 

c get the current ext number (in case in_gti filename was given with ext#):
        call ftghdn (in_gti, nhdu)

c open outfile:
        call unlink (f512)
        call ftgiou (iout_gti, istat)
        call ftinit (iout_gti, f512, 1, istat)

        if (istat.ne.0) then
          call ftgerr (istat, a30)
          print'(" write_gti: fitsio err <",a,"> on file")',a30(1:lnblnk(a30))
          print'(" ",a,", cannot write clean_gti_file")',f512(1:lnblnk(f512))
          return
        end if


c copy 1st header (primary array with info keywords) from in_gti to iout_gti:
        call ftmahd (in_gti, 1, junk, istat)
        call ftcopy (in_gti, iout_gti, 0, istat)


c copy 2nd hdu (or whatever ext# was given in the in_gti filename):
        if (nhdu.ne.1) then
c in_gti filename contains ext#, copy that one:
          call ftmahd (in_gti, nhdu, junk, istat)
        else
c in_gti is a regular gti file, so copy 2nd hdu:
          call ftmahd (in_gti, 2, junk, istat)
        end if

        call ftcrhd (iout_gti, istat)
        call ftcphd (in_gti, iout_gti, istat)
        
c modify naxis2 (nrows) keyword:
        call ftmkyj (iout_gti, "NAXIS2", ngti, "&", istat)
c write data:
        call ftpcld (iout_gti, 1, 1,1, ngti, ggti(1,1),  istat)
        call ftpcld (iout_gti, 2, 1,1, ngti, ggti(1,2),  istat)


c history, checksums, datasums, date stamps, etc. in both hdus:
        call ftmahd (iout_gti, 1, junk, istat)

        call ftukys (iout_gti,"CREATOR",sig," tool that created this file",
     ~      istat)
        call ftpdat (iout_gti, istat)
        call ftpcks (iout_gti, istat)

        call ftmahd (iout_gti, 2, junk, istat)

c add history:
        write(history,'(" ",a," deleted ",i6," s")')
     ~      sig(1:lnblnk(sig)),int(ttdisc)
        call ftphis (iout_gti, history, istat)
        write(history,'(" of anomalous light curve bins, leaving ",'//
     ~       'i7," s of good time.")') int(ttgood)
        call ftphis (iout_gti, history, istat)

        call ftpdat (iout_gti, istat)
        call ftpcks (iout_gti, istat)

c close all:        
        call ftclos (in_gti, istat)
        call ftfiou (in_gti, istat)
        call ftclos (iout_gti, istat)
        call ftfiou (iout_gti, istat)

        close(in_gti)
        close(iout_gti)

        if (istat.ne.0) then
          call ftgerr (istat, a30)
          print'(" write_gti: fitsio err <",a,"> on file")',a30(1:lnblnk(a30))
          print'(" ",a)',f512(1:lnblnk(f512))
        else
          print'(" Wrote ",a)',f512(1:lnblnk(f512))
        end if

      else
c output GTI file will be in ascii format:

        iout_gti=newunit()
        open(iout_gti, file=f512, iostat=iret)

        if (iret.eq.0) then
          do i=1,ngti
            write(iout_gti,'(2f15.3)') ggti(i,1), ggti(i,2)
          end do
        else
          print'(" write_gti: cannot open ",a)',f512(1:lnblnk(f512))
        end if

        close(iout_gti)
      end if
      
      end

c Maxim Markevitch <maxim % head.cfa.harvard.edu>, last change 30 Jan 7

c Fills sky coords in the ACIS background event file for a given observation.

c 30.1.7: changed string lengths from 128 to 512 (also in get_param.c)
c emandel removed commas from read()/write() for compatib.
c 11.2.5: increased maxev to 4e6 (acisi_D 1.5Ms bg has 3.3e6)
c 13.5.4: increased maxasp from 5e5 to 1.5e6, maxev from 1.5e6 to 2.5e6
c 4.1.2: fixed format of wcs keywords (was TCRVL08, now TCRVL8)
c 11.12.1: now read real*8 time from aoff1 (was integer).
c   see also changes in if_goodttime.f.
c 27.6.1: initialize istat=0, because g77 doesn't. 
c 9.2.1: A. Vikhlinin changed sub. det2sky so now it adds stf_[yz], obviating
c   the need to run asp_apply_sim on the aoff1 file.
c   MM added a check whether it was run.
c   Also: fixed nullval type in fgtcve calls; ichip type 'byte' to int*2.
c 31.1.1: if_goodtime(it) to if_goodttime(dble(it)), to drop if_goodtime
c 21.12.00: removed func ini_pixlib, now a separate file pixlib_int.f
c   (9.2.1: renamed pixlib_int.f -> ini_pixlib.f)
c science evt files.
c 6.6.00: print "Will shift..." added xs,ys
c 15.3.00: cosd to cos
c 5.3.00: started but not finished adding use_time to correct coords in
c 2.2.00: added manual image shifts.
c 28.1.00: now gets name of par file from command line; also changed par names
c as AV asked.

c Uses pieces of from AV's /data/alexey1/chandra/expmap/chipmap.F
c Compile with MMLIBS and
c $B/pixlib_interface.o -L /data/alexey1/chandra/LIB/ -lpix -lmatrix -lparam
c
c Function chip2det is defined in pixlib_interface.c, function det2sky is
c defined in this file.

      parameter (maxev=4 000 000, maxasp=1 500 000, 
     ~    x0=4096.5, y0=4096.5, pix=0.492, dx=-pix/3600, dy=pix/3600)
      character*1 pfile*512, pname*512, val*512, bgfile*512, a80*80, a30*30,
     ~    fpsys*80, aimpoint*200, a81*8,a82*8,a83*8,a84*8, a1*1, b80*80
      integer*2 icx(maxev), icy(maxev), ichip(maxev)
      real detx(maxev), dety(maxev), x(maxev), y(maxev),
     ~    xoff(maxasp), yoff(maxasp), roll(maxasp),
     ~    stf_y(maxasp), stf_z(maxasp)
      real*8 tt(maxasp)
      logical if_goodttime, anyf, use_time
      common /parf/ pfile
      idum=111
      istat=0
      
      print*
      print'(" This is make_acisbg v300107")'
      print*


c get name of par file from command line, if supplied:
      call getarg (1,pfile)

      if (pfile(1:1).eq."@") then
c cut AV's leading @:
        pfile=pfile(2:lnblnk(pfile))
      end if
      if (pfile.eq."") then
        pfile="make_acisbg.par"
      end if 


c read aimpoint pars (sim_x,sim_y,sim_z) and fpsys from the events file (in
c fact, sim_x etc. can also be read from the aoff file, but that file does not
c have fpsys):


      pname="evt_file "
      call get_param (iret, pfile, pname, val)
      if (iret.eq.255) then
        print'(" Cannot open or read parameter file.")'
        call exit(1)
      end if
      if (iret.ne.0) then
        pname="evtfile "
        call get_param (iret, pfile, pname, val)
        if (iret.ne.0) then
          print'(" Please provide parameter evt_file.")'
          call exit(1)
        end if
      end if

      call ftgiou (ifi, istat)
      call ftopen (ifi, val, 0, junk, istat)
      call ftmnhd (ifi, -1, "EVENTS", 0, istat)
      
      call ftgkye (ifi,"SIM_X",simx,a80,istat)
      call ftgkye (ifi,"SIM_Y",simy,a80,istat)
      call ftgkye (ifi,"SIM_Z",simz,a80,istat)
      call ftgkys (ifi,"ACSYS3",fpsys,a80,istat)

      call ftclos (ifi,istat)
      call ftfiou (ifi,istat)

      if (istat.ne.0) then
        call ftgerr (istat, a30)
        print'(" fitsio error <",a,"> on file")',a30(1:lnblnk(a30))
        print'("   ",a)',val(1:lnblnk(val))
        call exit(1) 
      end if

c initialize pixlib:

      write(aimpoint,'(f9.4,",",f9.4,",",f9.4)') simx,simy,simz
      call rmblanks (aimpoint)
      
      iret=ini_pixlib(aimpoint,fpsys)

      if (iret.ne.0) then
        print'(" (Check your CIAO setup)")'
        call exit(0)
      end if

c read time, x,y offsets and roll offsets from the *aoff1* file:

      pname="aoff1_file "
      call get_param (iret, pfile, pname, val)
      if (iret.ne.0) then
        pname="aspfile "
        call get_param (iret, pfile, pname, val)
        if (iret.ne.0) then
          print'(" Please provide parameter aoff1_file.")'
          call exit(1) 
        end if
      end if

      call ftgiou (ifi, istat)
      call ftopen (ifi, val, 0, junk, istat)

c check if asp_apply_sim was not run:
      call ftgkys (ifi,"CREATOR",b80,a80,istat)
      if (b80(1:13).eq."asp_apply_sim") then
        print*
        print'(" It appears that the aoff file has been processed by asp_apply_sim. Make_acisbg")'
        print'(" now needs the original file, please change the aoff1_file parameter.")'
        call exit(0)
      end if 

      call ftmnhd (ifi, -1, "ASPOFF", 0, istat)
      call ftgkyj (ifi, "NAXIS2", nrows, a80, istat)
      
      if (nrows.gt.maxasp) then
        print*,' Number of records ',nrows,
     ~      ' > maxasp, increase maxasp in the code. Proceeding...'
        nrows=maxasp
      end if
      
      call ftgcno (ifi, .false., "time",  ncol, istat)
      call ftgcvd (ifi, ncol, 1,1, nrows, -1, tt, anyf, istat)
      
      call ftgcno (ifi, .false., "x_offsets",  ncol, istat)
      call ftgcve (ifi, ncol, 1,1, nrows, 0., xoff, anyf, istat)
      
      call ftgcno (ifi, .false., "y_offsets",  ncol, istat)
      call ftgcve (ifi, ncol, 1,1, nrows, 0., yoff, anyf, istat)
      
      call ftgcno (ifi, .false., "roll_offsets",  ncol, istat)
      call ftgcve (ifi, ncol, 1,1, nrows, 0., roll, anyf, istat)

      call ftgcno (ifi, .false., "stf_y",  ncol, istat)
      call ftgcve (ifi, ncol, 1,1, nrows, 0., stf_y, anyf, istat)

      call ftgcno (ifi, .false., "stf_z",  ncol, istat)
      call ftgcve (ifi, ncol, 1,1, nrows, 0., stf_z, anyf, istat)
    
      call ftgkye (ifi, "RA_NOM", ranom, a80, istat)
      call ftgkye (ifi, "DEC_NOM", decnom, a80, istat)
      call ftgkye (ifi, "ROLL_NOM", rollnom, a80, istat)

      call ftclos (ifi,istat)
      call ftfiou (ifi,istat)

      if (istat.ne.0) then
        call ftgerr (istat, a30)
        print'(" fitsio error <",a,"> on file")',a30(1:lnblnk(a30))
        print'("   ",a)',val(1:lnblnk(val))
        call exit(1) 
      end if


c discard time bins outside GTI, and also add rolloff to roll_nom:
      k=0
      do i=1,nrows
        if (if_goodttime(tt(i))) then
          k=k+1
          xoff(k)=xoff(i)
          yoff(k)=yoff(i)
          stf_y(k)=stf_y(i)
          stf_z(k)=stf_z(i)
          roll(k)=rollnom+roll(i)
        end if 
      end do
      write (0,*) 'POINTS : ',k
      if (k.eq.0) then
        print*,' Aspect file does not have any points inside GTI.'
        call exit(1) 
      end if
c now k is the total number of good aspect offsets.


c read bg file:

      pname="bg_file "
      call get_param (iret, pfile, pname, bgfile)
      if (iret.ne.0) then
        print'(" Please provide parameter bg_file.")'
        call exit(1) 
      end if

c see if we want to use the time column in the bg file instead of generating
c times randomly (this is for correcting the science evt files after pixlib
c updates):

      pname="use_time "
      call get_param (iret, pfile, pname, val)
      if (iret.eq.0) read(val,'(a1)',iostat=iret) a1
      use_time=(iret.eq.0.and.(a1.eq."y".or.a1.eq."Y"))
*      if (use_time) then
*        print'(" Will use time column in bg_file to calculate sky coords;")'
*        print'(" only events within GTI will be modified, and x,y for others will be set to 0.")'
*      end if


      call ftgiou (ifi, istat)
      call ftopen (ifi, bgfile, 1, junk, istat)
      call ftmnhd (ifi, -1, "EVENTS", 0, istat)
      call ftgkyj (ifi, "NAXIS2", nrows, a80, istat)
      
      if (nrows.gt.maxev) then
        print*,' Number of events ',nrows,
     ~      ' > maxn, increase maxn in the code. Proceeding...'
        nrows=maxev
      end if
      
      call ftgcno (ifi, .false., "ccd_id",  ncol, istat)
      call ftgcvi (ifi, ncol, 1,1, nrows, -1, ichip, anyf, istat)
      
      call ftgcno (ifi, .false., "chipx",  ncol, istat)
      call ftgcvi (ifi, ncol, 1,1, nrows, -1, icx, anyf, istat)
      
      call ftgcno (ifi, .false., "chipy",  ncol, istat)
      call ftgcvi (ifi, ncol, 1,1, nrows, -1, icy, anyf, istat)

*      if (use_time) then
*        call ftgcno (ifi, .false., "time",  ncol, istat)
*        call ftgcvj (ifi, ncol, 1,1, nrows, -1, itime, anyf, istat)
*      end if


      if (istat.ne.0) then
        call ftgerr (istat, a30)
        print'(" fitsio error <",a,"> on file")',a30(1:lnblnk(a30))
        print'("   ",a)',bgfile(1:lnblnk(bgfile))
        call exit(1) 
      end if


c read shifts to apply to x,y coords (in arcsec), if provided:

      pname="bg_x_shift "
      call get_param (iret, pfile, pname, val)
      if (iret.eq.0) read(val,*,iostat=iret) xs
      if (iret.ne.0) xs=0
      
      pname="bg_y_shift "
      call get_param (iret, pfile, pname, val)
      if (iret.eq.0) read(val,*,iostat=iret) ys
      if (iret.ne.0) ys=0

      if (xs.ne.0.or.ys.ne.0) then
        print'(" Will shift background sky coords by",2f8.2," arcsec")',xs,ys
      end if

      xs=xs/pix
      ys=ys/pix


c now calc sky coords for each bg event by calling pixlib:

      kt=1
      do i=1,nrows
        cx=icx(i)
        cy=icy(i)
        ich=ichip(i)

        call chip2det (cx,cy,ich,detx(i),dety(i))

        if (use_time) then
          print*,' use_time not yet implemented'
          call exit(0)
*          if (if_goodttime(dble(itime(i)))) then
*          else
*            x(i)=0
*            y(i)=0
*          end if
        else

c convert det to sky choosing aspect offsets and roll randomly: 
          j=k*urand(idum)+1
          if (j.gt.k) j=k

          call det2sky (detx(i),dety(i),xoff(j),yoff(j),roll(j),stf_y(j)
     ~        ,stf_z(j),x(i),y(i))
        end if


c apply user-supplied shifts to sky coords:
        x(i)=x(i)+xs
        y(i)=y(i)+ys
      end do


c update detx,dety,x,y columns in the bg events file; also, update ra_nom and
c crval keywords:

      call ftgcno (ifi, .false., "detx",  ncol, istat)
      call ftpcle (ifi, ncol, 1,1, nrows, detx, istat)

      call ftgcno (ifi, .false., "dety",  ncol, istat)
      call ftpcle (ifi, ncol, 1,1, nrows, dety, istat)

c x:
      call ftgcno (ifi, .false., "x",  ncol, istat)
      call ftpcle (ifi, ncol, 1,1, nrows, x, istat)

c update WCS keywords for x, if exist already:
      if (ncol.le.9) then
        write(a81,'("TCTYP",i1)') ncol
        write(a82,'("TCRVL",i1)') ncol
        write(a83,'("TCRPX",i1)') ncol
        write(a84,'("TCDLT",i1)') ncol
      else
        write(a81,'("TCTYP",i2)') ncol
        write(a82,'("TCRVL",i2)') ncol
        write(a83,'("TCRPX",i2)') ncol
        write(a84,'("TCDLT",i2)') ncol
      end if
      call ftukys (ifi,a81,"RA---TAN"," ",istat)
      call ftukyf (ifi,a82,ranom,6," Nominal RA",istat)
      call ftukyf (ifi,a83,x0,1," ",istat)
      call ftukye (ifi,a84,dx,7," ",istat)
      

c y:
      call ftgcno (ifi, .false., "y",  ncol, istat)
      call ftpcle (ifi, ncol, 1,1, nrows, y, istat)

c update WCS keywords for y, if exist already:
      if (ncol.le.9) then
        write(a81,'("TCTYP",i1)') ncol
        write(a82,'("TCRVL",i1)') ncol
        write(a83,'("TCRPX",i1)') ncol
        write(a84,'("TCDLT",i1)') ncol
      else
        write(a81,'("TCTYP",i2)') ncol
        write(a82,'("TCRVL",i2)') ncol
        write(a83,'("TCRPX",i2)') ncol
        write(a84,'("TCDLT",i2)') ncol
      end if
      call ftukys (ifi,a81,"DEC--TAN"," ",istat)
      call ftukyf (ifi,a82,decnom,6," Nominal Dec",istat)
      call ftukyf (ifi,a83,y0,1," ",istat)
      call ftukye (ifi,a84,dy,7," ",istat)
      

      call ftukyf (ifi,"RA_NOM",ranom,6," Nominal RA",istat)
      call ftukyf (ifi,"DEC_NOM",decnom,6," Nominal Dec",istat)
      call ftukyf (ifi,"ROLL_NOM",rollnom,6," Nominal Roll",istat)

      call ftclos (ifi,istat)
      
      if (istat.ne.0) then
        call ftgerr (istat, a30)
        print'(" fitsio error <",a,"> on file")',a30(1:lnblnk(a30))
        print'("   ",a)',bgfile(1:lnblnk(bgfile))
        call exit(1) 
      end if

      call exit(0)
      end
*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
c changed on 7.2.1 by AV, now adds stf_[yz]

      subroutine det2sky (detx,dety,xoff,yoff,roll,stf_y,stf_z,x,y)

      parameter (detx0=4096.5,dety0=4096.5,x0=4096.5,y0=4096.5)
      real deg2rad
      parameter (deg2rad=3.1415926536/180.0)
      real sinroll, cosroll, dx, dy, pix2mm
      parameter (pix2mm=41.6892) 
c               (assuming 1 pixel is 23.987 micron)

      call theta_phi (detx0,dety0,detx,dety,r,phi)
      beta=360-roll+phi

      sinroll = sin(-roll*deg2rad)
      cosroll = cos(-roll*deg2rad)

      dx = xoff + ( stf_y*cosroll + stf_z*sinroll ) * pix2mm
      dy = yoff + ( stf_y*sinroll - stf_z*cosroll ) * pix2mm

      x=x0+r*cos(beta*deg2rad)+dx
      y=y0+r*sin(beta*deg2rad)+dy

      end

c outputs unopened fortran file unit
c (from A. Vikhlinin)

      integer function newunit ()
      
      logical opened
      integer i
      
      opened=.true.
      i=6
      do while (opened)
        i=i+1
        inquire(unit=i,opened=opened)
      enddo
      
      newunit=i
      
      end

#!/usr/bin/env bash

# Run this script to install or update your dmd toolchain from
# github.
#
# First run, create a working directory, e.g. /path/to/d/. Then run
# this script from that directory (the location of the script itself
# doesn't matter). It will create the following subdirectories:
# /path/to/d/dmd, /path/to/d/phobos, /path/to/d/dlang.org,
# /path/to/d/tools, and /path/to/d/installer. Then it will fetch all
# corresponding projects from github and build them fresh.
#
# On an ongoing basis, to update your toolchain from github go again
# to the same directory (in our example /path/to/d) and run the script
# again. The script will detect that directories exist and will do an
# update.
#

set -ueo pipefail

declare -a projects
projects=(dmd phobos dlang.org tools installer dub)
# Working directory
wd=$(pwd)
# github username
githubUser="dlang"
# Configuration
makecmd="make"
parallel=8
model=64
build="release"
githubUri="https://github.com/"
tag=""
# List of projects to install vs. update. Their disjoint union is
# $projects.
declare -a toInstall toUpdate
toInstall=()
toUpdate=()
# Mess to go here
tempdir=$(mktemp -d /tmp/dmd-update.XXX)

function cleanup() {
    rm -rf "$tempdir";
}
trap cleanup EXIT

function help() {
    echo "./setup.sh
Clones and builds dmd, phobos, dlang.org, tools, installer and dub.

Additional usage

  install       replace current dmd binary with the freshly dmd

Options

  --user=USER   set a custom GitHub user name (requires the repos to be forked)
  --tag=TAG     select a specific tag to clone" >&2
}

#
# Take care of the command line arguments
#
function handleCmdLine() {
    for arg in "$@"; do
        case "$arg" in
    	    --tag=*)
    	    tag="${arg//[-a-zA-Z0-9]*=/}"
            ;;
    	    --user=*)
    	    githubUser="${arg//[-a-zA-Z0-9]*=/}"
            ;;
            install)
            install="yes"
            ;;
            *)
            echo "Error: $arg not recognized." >&2
            echo >&2
            help
            exit 1
            ;;
        esac
    done

    if [ -n "${tag+x}" ] ; then
        wd+="/$tag"
        mkdir -p "$wd"
    fi
}

#
# Confirm correct choices
#
function confirmChoices() {
    function joinWithWorkingDir() {
        for i in "$@"; do
            echo "$wd/$i"
        done
    }

    for project in "${projects[@]}" ; do
        if [ -d "$wd/$project" ] ; then
            toUpdate+=("$project")
        else
            toInstall+=("$project")
        fi
    done
    if [[ ${#toInstall[@]} -gt 0 ]]; then
        echo "*** The following projects will be INSTALLED:"
        joinWithWorkingDir "${toInstall[@]}"
    fi
    if [[ ${#toUpdate[@]} -gt 0 ]]; then
        echo "*** The following projects will be UPDATED:"
        joinWithWorkingDir "${toUpdate[@]}"
    fi

    echo "Is this what you want? [y|n]"
    local yn
    while true; do
        read -r yn
        case "$yn" in
            [Yy]* ) break;;
            [Nn]* ) exit;;
            * ) echo "Please answer y or n.";;
        esac
    done
}

#
# Install from scratch
#

function installAnew() {
    local projects
    projects=("$@")
    for project in "${projects[@]}" ; do
        (
        git clone "${githubUri}${githubUser}/$project.git" "$wd/$project"
        if [ "$githubUser" != "dlang" ] ; then
            git -C "$wd/$project" remote add upstream "${githubUri}dlang/$project.git"
        fi
        touch "$tempdir/$project"
        ) &
    done
    wait

    for project in "${projects[@]}" ; do
        if [ ! -f "$tempdir/$project" ]; then
            echo "Getting $project failed." >&2
            exit 1
        fi
        if [ -n "${tag}" ] ; then
            if [ "$project" == "dmd" ] || [ "$project" == "phobos" ] || \
		[ "$project" == "dlang.org" ] || [ "$project" == "tools" ] ; then
	            git -C "$wd/$project" checkout "v$tag"
            fi
        fi
    done
}

#
# Freshen existing stuff
#

function update() {
    echo "Updating projects in $wd..."

    function update_project() {
        local project=$1
        local gitproject="${githubUri}dlang/$project.git"
        local git=("git" "-C" "$wd/$project")
        if ! ( \
            "${git[@]}" checkout master && \
            "${git[@]}" pull --ff-only --tags "$gitproject" master ) 2> "$tempdir/$project.log"
        then
            echo "Failure updating $wd/$project." >> "$tempdir/errors"
            exit 1
        fi
    }

    for project in "${toUpdate[@]}" ; do
        update_project "$project" &
    done
    wait

    if [ -f "$tempdir/errors" ]; then
        cat "$tempdir"/*.log >&2
        exit 1
    fi
}

function makeWorld() {
    local BOOTSTRAP=""
    command -v dmd >/dev/null || BOOTSTRAP="AUTO_BOOTSTRAP=1"
    for repo in dmd phobos ; do
        # Pass `AUTO_BOOTSTRAP` because of https://issues.dlang.org/show_bug.cgi?id=20727
        "$makecmd" -C "$wd/$repo" -f posix.mak clean $BOOTSTRAP
        "$makecmd" -C "$wd/$repo" -f posix.mak "-j${parallel}" MODEL="$model" BUILD="$build" $BOOTSTRAP
    done

    # Update the running dmd version (only required once)
    if [[ -n "${install+x}" ]]; then
        local old dmdBinary
        old=$(command -v dmd)
        dmdBinary=$(ls -1 $wd/dmd/generated/*/$build/$model/dmd)
        if [ -f "$old" ]; then
            echo "Linking '$dmdBinary' to $old"
            local sudo=""
            if [ ! -w "$old" ] ; then
                sudo="sudo"
            fi
            ln -s "$tempdir/dmd.symlink" "$old"
            "$sudo" mv "$tempdir/dmd.symlink" "$old"
        fi
    fi
}

# main
handleCmdLine "$@"
confirmChoices
if [ ${#toInstall[@]} -gt 0 ] ; then
    installAnew "${toInstall[@]}"
fi
if [ ${#toUpdate[@]} -gt 0 ] ; then
    update "${toUpdate[@]}"
fi
makeWorld

#!/bin/bash
# Test building of all DUB packages

set -euo pipefail

DIR="$( cd "$( dirname "${BASH_SOURCE[0]}" )" && pwd )"

# dman is excluded in this test because it requires the d-tags.json file for building
for package in tests_extractor dget checkwhitespace ddemangle detab tolf \
               rdmd contributors changed catdoc ; do
    echo "Testing DUB build of $package"
    dub build --root "$DIR/.." ":$package"
done

---
name: Regression
about: Change in behavior that broke your code or use case
title: ''
labels: Type.Bug, Prio.1.Regression
assignees: ''

---

**Describe the regression**
A clear and concise description of what the bug is.

Please include :
- The **previous behavior**;
- When the change happened (which version of the compiler / library / tool);
In order to find the timeline of a regression, you can use [Digger](https://github.com/CyberShadow/Digger).

**Platform**
If applicable, provide informations about the platform the bug triggers on.
*OS*: (Windows, Linux, Mac OSX, FreeBSD, Android, iOS, etc...)
*Compiler*: (DMD 2.091.1, LDC 1.20.1, DMD@1897da, etc...)
Any other tooling and version that is relevant (e.g. dub version, C++ compiler/version if the bugs concerns `extern(C++)`, etc...)

**To Reproduce**
A [Short, Self Contained, Correct Example](http://sscce.org/), and the expected behavior vs the actual one.
Please provide code examples, command example, and error messages when applicable.
E.g.
```D
void main () { /* Some code */ }
``` 
```console
$ dmd -unittest -run test.d
test.d(1): Error: cannot implicitly convert expression `a` of type `A` to `B`
```
Screenshot, links to repositories are also welcome, however bear in mind that anything that is self contained is less likely to disappear over time. Note that in order to reduce bugs, you can use [DustMite](https://github.com/CyberShadow/DustMite), which will reduce the bug for you. It is also available via `dub dustmite`.

---
name: Feature request
about: 'Suggest an idea for this project'
title: ''
labels: Prio.3.Normal, Type.Enhancement
assignees: ''

---

**NOTE**
For significant feature requests, please consider raising a [DIP](https://github.com/dlang/DIPs).
If you're new to the language, consider [asking a question on the D forum](https://forum.dlang.org/group/learn) first.

**Is your feature request related to a problem? Please describe.**
A clear and concise description of what the problem is. Ex. I'm always frustrated when [...]

**Describe the solution you'd like**
A clear and concise description of what you want to happen.

**Describe alternatives you've considered**
A clear and concise description of any alternative solutions or features you've considered.

**Additional context**
Add any other context or screenshots about the feature request here.

# Advanced topics

This documentation is for advanced `gopls` users, who may want to test
unreleased versions or try out special features.

## Installing unreleased versions

To get a specific version of `gopls` (for example, to test a prerelease
version), run:

```sh
GO111MODULE=on go install golang.org/x/tools/gopls@vX.Y.Z
```

Where `vX.Y.Z` is the desired version.

### Unstable versions

To update `gopls` to the latest **unstable** version, use the following
commands.

```sh
# Create an empty go.mod file, only for tracking requirements.
cd $(mktemp -d)
go mod init gopls-unstable

# Use 'go get' to add requirements and to ensure they work together.
go get -d golang.org/x/tools/gopls@master golang.org/x/tools@master

go install golang.org/x/tools/gopls
```

## Working on the Go source distribution

If you are working on the [Go project] itself, the `go` command that `gopls`
invokes will have to correspond to the version of the source you are working
on. That is, if you have checked out the Go project to `$HOME/go`, your `go`
command should be the `$HOME/go/bin/go` executable that you built with
`make.bash` or equivalent.

You can achieve this by adding the right version of `go` to your `PATH`
(`export PATH=$HOME/go/bin:$PATH` on Unix systems) or by configuring your
editor.

To work on both `std` and `cmd` simultaneously, add a `go.work` file to
`GOROOT/src`:

```
cd $(go env GOROOT)/src
go work init . cmd
```

Note that you must work inside the `GOROOT/src` subdirectory, as the `go`
command does not recognize `go.work` files in a parent of `GOROOT/src`
(https://go.dev/issue/59429).

## Working with generic code

Gopls has support for editing generic Go code. To enable this support, you need
to **install gopls using Go 1.18 or later**. The easiest way to do this is by
[installing Go 1.18+](https://go.dev/dl) and then using this Go version to
install gopls:

```
$ go install golang.org/x/tools/gopls@latest
```

It is strongly recommended that you install the latest version of `gopls`, or
the latest **unstable** version as [described above](#installing-unreleased-versions).

The `gopls` built with these instructions understands generic code. See the
[generics tutorial](https://go.dev/doc/tutorial/generics) for more information
on how to use generics in Go!

### Known issues

  * [`staticcheck`](https://github.com/golang/tools/blob/master/gopls/doc/settings.md#staticcheck-bool)
    on generic code is not supported yet.

[Go project]: https://go.googlesource.com/go

---
title: "Gopls release v0.21.0 (forthcoming)"
---

## Configuration changes
## Web-based features
## Editing features
## Analysis features
## Code transformation features

<!-- golang/go#42301 -->
The Rename operation now treats [Doc Links](https://tip.golang.org/doc/comment#doclinks)
like identifiers, so you can initiate a renaming from a Doc Link.

<!--

### $feature

https://go.dev/issue#xxxxx

-->

# Commands

This document describes the LSP-level commands supported by `gopls`. They cannot be invoked directly by users, and all the details are subject to change, so nobody should rely on this information.

<!-- BEGIN Commands: DO NOT MANUALLY EDIT THIS SECTION -->
### **Add a dependency**
Identifier: `gopls.add_dependency`

Adds a dependency to the go.mod file for a module.

Args:

```
{
	// The go.mod file URI.
	"URI": string,
	// Additional args to pass to the go command.
	"GoCmdArgs": []string,
	// Whether to add a require directive.
	"AddRequire": bool,
}
```

### **Add an import**
Identifier: `gopls.add_import`

Ask the server to add an import path to a given Go file.  The method will
call applyEdit on the client so that clients don't have to apply the edit
themselves.

Args:

```
{
	// ImportPath is the target import path that should
	// be added to the URI file
	"ImportPath": string,
	// URI is the file that the ImportPath should be
	// added to
	"URI": string,
}
```

### **Apply a fix**
Identifier: `gopls.apply_fix`

Applies a fix to a region of source code.

Args:

```
{
	// The fix to apply.
	"Fix": string,
	// The file URI for the document to fix.
	"URI": string,
	// The document range to scan for fixes.
	"Range": {
		"start": {
			"line": uint32,
			"character": uint32,
		},
		"end": {
			"line": uint32,
			"character": uint32,
		},
	},
}
```

### **Check for upgrades**
Identifier: `gopls.check_upgrades`

Checks for module upgrades.

Args:

```
{
	// The go.mod file URI.
	"URI": string,
	// The modules to check.
	"Modules": []string,
}
```

### **Run go mod edit -go=version**
Identifier: `gopls.edit_go_directive`

Runs `go mod edit -go=version` for a module.

Args:

```
{
	// Any document URI within the relevant module.
	"URI": string,
	// The version to pass to `go mod edit -go`.
	"Version": string,
}
```

### **Get known vulncheck result**
Identifier: `gopls.fetch_vulncheck_result`

Fetch the result of latest vulnerability check (`govulncheck`).

Args:

```
{
	// The file URI.
	"URI": string,
}
```

Result:

```
map[golang.org/x/tools/gopls/internal/lsp/protocol.DocumentURI]*golang.org/x/tools/gopls/internal/govulncheck.Result
```

### **Toggle gc_details**
Identifier: `gopls.gc_details`

Toggle the calculation of gc annotations.

Args:

```
string
```

### **Run go generate**
Identifier: `gopls.generate`

Runs `go generate` for a given directory.

Args:

```
{
	// URI for the directory to generate.
	"Dir": string,
	// Whether to generate recursively (go generate ./...)
	"Recursive": bool,
}
```

### **go get a package**
Identifier: `gopls.go_get_package`

Runs `go get` to fetch a package.

Args:

```
{
	// Any document URI within the relevant module.
	"URI": string,
	// The package to go get.
	"Pkg": string,
	"AddRequire": bool,
}
```

### **List imports of a file and its package**
Identifier: `gopls.list_imports`

Retrieve a list of imports in the given Go file, and the package it
belongs to.

Args:

```
{
	// The file URI.
	"URI": string,
}
```

Result:

```
{
	// Imports is a list of imports in the requested file.
	"Imports": []{
		"Path": string,
		"Name": string,
	},
	// PackageImports is a list of all imports in the requested file's package.
	"PackageImports": []{
		"Path": string,
	},
}
```

### **List known packages**
Identifier: `gopls.list_known_packages`

Retrieve a list of packages that are importable from the given URI.

Args:

```
{
	// The file URI.
	"URI": string,
}
```

Result:

```
{
	// Packages is a list of packages relative
	// to the URIArg passed by the command request.
	// In other words, it omits paths that are already
	// imported or cannot be imported due to compiler
	// restrictions.
	"Packages": []string,
}
```

### **fetch memory statistics**
Identifier: `gopls.mem_stats`

Call runtime.GC multiple times and return memory statistics as reported by
runtime.MemStats.

This command is used for benchmarking, and may change in the future.

Result:

```
{
	"HeapAlloc": uint64,
	"HeapInUse": uint64,
	"TotalAlloc": uint64,
}
```

### **Regenerate cgo**
Identifier: `gopls.regenerate_cgo`

Regenerates cgo definitions.

Args:

```
{
	// The file URI.
	"URI": string,
}
```

### **Remove a dependency**
Identifier: `gopls.remove_dependency`

Removes a dependency from the go.mod file of a module.

Args:

```
{
	// The go.mod file URI.
	"URI": string,
	// The module path to remove.
	"ModulePath": string,
	// If the module is tidied apart from the one unused diagnostic, we can
	// run `go get module@none`, and then run `go mod tidy`. Otherwise, we
	// must make textual edits.
	"OnlyDiagnostic": bool,
}
```

### **Reset go.mod diagnostics**
Identifier: `gopls.reset_go_mod_diagnostics`

Reset diagnostics in the go.mod file of a module.

Args:

```
{
	"URIArg": {
		"URI": string,
	},
	// Optional: source of the diagnostics to reset.
	// If not set, all resettable go.mod diagnostics will be cleared.
	"DiagnosticSource": string,
}
```

### **run `go work [args...]`, and apply the resulting go.work**
Identifier: `gopls.run_go_work_command`

edits to the current go.work file.

Args:

```
{
	"ViewID": string,
	"InitFirst": bool,
	"Args": []string,
}
```

### **Run govulncheck.**
Identifier: `gopls.run_govulncheck`

Run vulnerability check (`govulncheck`).

Args:

```
{
	// Any document in the directory from which govulncheck will run.
	"URI": string,
	// Package pattern. E.g. "", ".", "./...".
	"Pattern": string,
}
```

Result:

```
{
	// Token holds the progress token for LSP workDone reporting of the vulncheck
	// invocation.
	"Token": interface{},
}
```

### **Run test(s)**
Identifier: `gopls.run_tests`

Runs `go test` for a specific set of test or benchmark functions.

Args:

```
{
	// The test file containing the tests to run.
	"URI": string,
	// Specific test names to run, e.g. TestFoo.
	"Tests": []string,
	// Specific benchmarks to run, e.g. BenchmarkFoo.
	"Benchmarks": []string,
}
```

### **Start the gopls debug server**
Identifier: `gopls.start_debugging`

Start the gopls debug server if it isn't running, and return the debug
address.

Args:

```
{
	// Optional: the address (including port) for the debug server to listen on.
	// If not provided, the debug server will bind to "localhost:0", and the
	// full debug URL will be contained in the result.
	// 
	// If there is more than one gopls instance along the serving path (i.e. you
	// are using a daemon), each gopls instance will attempt to start debugging.
	// If Addr specifies a port, only the daemon will be able to bind to that
	// port, and each intermediate gopls instance will fail to start debugging.
	// For this reason it is recommended not to specify a port (or equivalently,
	// to specify ":0").
	// 
	// If the server was already debugging this field has no effect, and the
	// result will contain the previously configured debug URL(s).
	"Addr": string,
}
```

Result:

```
{
	// The URLs to use to access the debug servers, for all gopls instances in
	// the serving path. For the common case of a single gopls instance (i.e. no
	// daemon), this will be exactly one address.
	// 
	// In the case of one or more gopls instances forwarding the LSP to a daemon,
	// URLs will contain debug addresses for each server in the serving path, in
	// serving order. The daemon debug address will be the last entry in the
	// slice. If any intermediate gopls instance fails to start debugging, no
	// error will be returned but the debug URL for that server in the URLs slice
	// will be empty.
	"URLs": []string,
}
```

### **Run test(s) (legacy)**
Identifier: `gopls.test`

Runs `go test` for a specific set of test or benchmark functions.

Args:

```
string,
[]string,
[]string
```

### **Run go mod tidy**
Identifier: `gopls.tidy`

Runs `go mod tidy` for a module.

Args:

```
{
	// The file URIs.
	"URIs": []string,
}
```

### **Toggle gc_details**
Identifier: `gopls.toggle_gc_details`

Toggle the calculation of gc annotations.

Args:

```
{
	// The file URI.
	"URI": string,
}
```

### **Update go.sum**
Identifier: `gopls.update_go_sum`

Updates the go.sum file for a module.

Args:

```
{
	// The file URIs.
	"URIs": []string,
}
```

### **Upgrade a dependency**
Identifier: `gopls.upgrade_dependency`

Upgrades a dependency in the go.mod file for a module.

Args:

```
{
	// The go.mod file URI.
	"URI": string,
	// Additional args to pass to the go command.
	"GoCmdArgs": []string,
	// Whether to add a require directive.
	"AddRequire": bool,
}
```

### **Run go mod vendor**
Identifier: `gopls.vendor`

Runs `go mod vendor` for a module.

Args:

```
{
	// The file URI.
	"URI": string,
}
```

### **fetch workspace statistics**
Identifier: `gopls.workspace_stats`

Query statistics about workspace builds, modules, packages, and files.

This command is intended for internal use only, by the gopls stats
command.

Result:

```
{
	"Files": {
		"Total": int,
		"Largest": int,
		"Errs": int,
	},
	"Views": []{
		"GoCommandVersion": string,
		"AllPackages": {
			"Packages": int,
			"LargestPackage": int,
			"CompiledGoFiles": int,
			"Modules": int,
		},
		"WorkspacePackages": {
			"Packages": int,
			"LargestPackage": int,
			"CompiledGoFiles": int,
			"Modules": int,
		},
		"Diagnostics": int,
	},
}
```

<!-- END Commands: DO NOT MANUALLY EDIT THIS SECTION -->

# Documentation for contributors

This documentation augments the general documentation for contributing to the
x/tools repository, described at the [repository root](../../CONTRIBUTING.md).

Contributions are welcome, but since development is so active, we request that
you file an issue and claim it before starting to work on something. Otherwise,
it is likely that we might already be working on a fix for your issue.

## Finding issues

All `gopls` issues are labeled as such (see the [`gopls` label][issue-gopls]).
Issues that are suitable for contributors are additionally tagged with the
[`help-wanted` label][issue-wanted].

Before you begin working on an issue, please leave a comment that you are
claiming it.

## Getting started

Most of the `gopls` logic is in the `golang.org/x/tools/gopls/internal/lsp`
directory.

## Build

To build a version of `gopls` with your changes applied:

```bash
cd /path/to/tools/gopls
go install
```

To confirm that you are testing with the correct `gopls` version, check that
your `gopls` version looks like this:

```bash
$ gopls version
golang.org/x/tools/gopls master
    golang.org/x/tools/gopls@(devel)
```

## Getting help

The best way to contact the gopls team directly is via the
[#gopls-dev](https://app.slack.com/client/T029RQSE6/CRWSN9NCD) channel on the
gophers slack. Please feel free to ask any questions about your contribution or
about contributing in general.


## Error handling

It is important for the user experience that, whenever practical,
minor logic errors in a particular feature don't cause the server to
crash.

The representation of a Go program is complex. The import graph of
package metadata, the syntax trees of parsed files, and their
associated type information together form a huge API surface area.
Even when the input is valid, there are many edge cases to consider,
and this grows by an order of magnitude when you consider missing
imports, parse errors, and type errors.

What should you do when your logic must handle an error that you
believe "can't happen"?

- If it's possible to return an error, then use the `bug.Errorf`
  function to return an error to the user, but also record the bug in
  gopls' cache so that it is less likely to be ignored.

- If it's safe to proceed, you can call `bug.Reportf` to record the
  error and continue as normal.

- If there's no way to proceed, call `bug.Fatalf` to record the error
  and then stop the program with `log.Fatalf`. You can also use
  `bug.Panicf` if there's a chance that a recover handler might save
  the situation.

- Only if you can prove locally that an error is impossible should you
  call `log.Fatal`. If the error may happen for some input, however
  unlikely, then you should use one of the approaches above. Also, if
  the proof of safety depends on invariants broadly distributed across
  the code base, then you should instead use `bug.Panicf`.

Note also that panicking is preferable to `log.Fatal` because it
allows VS Code's crash reporting to recognize and capture the stack.

Bugs reported through `bug.Errorf` and friends are retrieved using the
`gopls bug` command, which opens a GitHub Issue template and populates
it with a summary of each bug and its frequency.
The text of the bug is rather fastidiously printed to stdout to avoid
sharing user names and error message strings (which could contain
project identifiers) with GitHub.
Users are invited to share it if they are willing.

## Testing

To run tests for just `gopls/`, run,

```bash
cd /path/to/tools/gopls
go test ./...
```

But, much of the gopls work involves `internal/lsp` too, so you will want to
run both:

```bash
cd /path/to/tools
cd gopls && go test ./...
cd ..
go test ./internal/lsp/...
```

There is additional information about the `internal/lsp` tests in the
[internal/lsp/tests `README`](https://github.com/golang/tools/blob/master/internal/lsp/tests/README.md).

### Regtests

gopls has a suite of regression tests defined in the `./gopls/internal/regtest`
directory. Each of these tests writes files to a temporary directory, starts a
separate gopls session, and scripts interactions using an editor-like API. As a
result of this overhead they can be quite slow, particularly on systems where
file operations are costly.

Due to the asynchronous nature of the LSP, regtests assertions are written
as 'expectations' that the editor state must achieve _eventually_. This can
make debugging the regtests difficult. To aid with debugging, the regtests
output their LSP logs on any failure. If your CL gets a test failure while
running the regtests, please do take a look at the description of the error and
the LSP logs, but don't hesitate to [reach out](#getting-help) to the gopls
team if you need help.

### CI

When you mail your CL and you or a fellow contributor assigns the
`Run-TryBot=1` label in Gerrit, the
[TryBots](https://golang.org/doc/contribute.html#trybots) will run tests in
both the `golang.org/x/tools` and `golang.org/x/tools/gopls` modules, as
described above.

Furthermore, an additional "gopls-CI" pass will be run by _Kokoro_, which is a
Jenkins-like Google infrastructure for running Dockerized tests. This allows us
to run gopls tests in various environments that would be difficult to add to
the TryBots. Notably, Kokoro runs tests on
[older Go versions](../README.md#supported-go-versions) that are no longer supported
by the TryBots. Per that that policy, support for these older Go versions is
best-effort, and test failures may be skipped rather than fixed.

Kokoro runs are triggered by the `Run-TryBot=1` label, just like TryBots, but
unlike TryBots they do not automatically re-run if the "gopls-CI" result is
removed in Gerrit. To force a re-run of the Kokoro CI on a CL containing the
`Run-TryBot=1` label, you can reply in Gerrit with the comment "kokoro rerun".

## Debugging

The easiest way to debug your change is to run a single `gopls` test with a
debugger.

See also [Troubleshooting](troubleshooting.md#troubleshooting).

<!--TODO(rstambler): Add more details about the debug server and viewing
telemetry.-->

[issue-gopls]: https://github.com/golang/go/issues?utf8=%E2%9C%93&q=is%3Aissue+is%3Aopen+label%3Agopls "gopls issues"
[issue-wanted]: https://github.com/golang/go/issues?utf8=✓&q=is%3Aissue+is%3Aopen+label%3Agopls+label%3A"help+wanted" "help wanted"

# Settings

<!--TODO: Generate this file from the documentation in golang.org/x/tools/gopls/internal/lsp/source/options.go.-->

This document describes the global settings for `gopls` inside the editor.
The settings block will be called `"gopls"` and contains a collection of
controls for `gopls` that the editor is not expected to understand or control.
These settings can also be configured differently per workspace folder.

In VSCode, this would be a section in your `settings.json` file that might look
like this:

```json5
  "gopls": {
    "ui.completion.usePlaceholders": true,
     ...
  },
```

## Officially supported

Below is the list of settings that are officially supported for `gopls`.

Any settings that are experimental or for debugging purposes are marked as
such.

To enable all experimental features, use **allExperiments: `true`**. You will
still be able to independently override specific experimental features.

<!-- BEGIN User: DO NOT MANUALLY EDIT THIS SECTION -->

* [Build](#build)
* [Formatting](#formatting)
* [UI](#ui)
  * [Completion](#completion)
  * [Diagnostic](#diagnostic)
  * [Documentation](#documentation)
  * [Inlayhint](#inlayhint)
  * [Navigation](#navigation)

### Build

#### **buildFlags** *[]string*

buildFlags is the set of flags passed on to the build system when invoked.
It is applied to queries like `go list`, which is used when discovering files.
The most common use is to set `-tags`.

Default: `[]`.

#### **env** *map[string]string*

env adds environment variables to external commands run by `gopls`, most notably `go list`.

Default: `{}`.

#### **directoryFilters** *[]string*

directoryFilters can be used to exclude unwanted directories from the
workspace. By default, all directories are included. Filters are an
operator, `+` to include and `-` to exclude, followed by a path prefix
relative to the workspace folder. They are evaluated in order, and
the last filter that applies to a path controls whether it is included.
The path prefix can be empty, so an initial `-` excludes everything.

DirectoryFilters also supports the `**` operator to match 0 or more directories.

Examples:

Exclude node_modules at current depth: `-node_modules`

Exclude node_modules at any depth: `-**/node_modules`

Include only project_a: `-` (exclude everything), `+project_a`

Include only project_a, but not node_modules inside it: `-`, `+project_a`, `-project_a/node_modules`

Default: `["-**/node_modules"]`.

#### **templateExtensions** *[]string*

templateExtensions gives the extensions of file names that are treateed
as template files. (The extension
is the part of the file name after the final dot.)

Default: `[]`.

#### **memoryMode** *enum*

**This setting is experimental and may be deleted.**

memoryMode controls the tradeoff `gopls` makes between memory usage and
correctness.

Values other than `Normal` are untested and may break in surprising ways.

Must be one of:

* `"DegradeClosed"`: In DegradeClosed mode, `gopls` will collect less information about
packages without open files. As a result, features like Find
References and Rename will miss results in such packages.
* `"Normal"`

Default: `"Normal"`.

#### **expandWorkspaceToModule** *bool*

**This setting is experimental and may be deleted.**

expandWorkspaceToModule instructs `gopls` to adjust the scope of the
workspace to find the best available module root. `gopls` first looks for
a go.mod file in any parent directory of the workspace folder, expanding
the scope to that directory if it exists. If no viable parent directory is
found, gopls will check if there is exactly one child directory containing
a go.mod file, narrowing the scope to that directory if it exists.

Default: `true`.

#### **allowModfileModifications** *bool*

**This setting is experimental and may be deleted.**

allowModfileModifications disables -mod=readonly, allowing imports from
out-of-scope modules. This option will eventually be removed.

Default: `false`.

#### **allowImplicitNetworkAccess** *bool*

**This setting is experimental and may be deleted.**

allowImplicitNetworkAccess disables GOPROXY=off, allowing implicit module
downloads rather than requiring user action. This option will eventually
be removed.

Default: `false`.

#### **standaloneTags** *[]string*

standaloneTags specifies a set of build constraints that identify
individual Go source files that make up the entire main package of an
executable.

A common example of standalone main files is the convention of using the
directive `//go:build ignore` to denote files that are not intended to be
included in any package, for example because they are invoked directly by
the developer using `go run`.

Gopls considers a file to be a standalone main file if and only if it has
package name "main" and has a build directive of the exact form
"//go:build tag" or "// +build tag", where tag is among the list of tags
configured by this setting. Notably, if the build constraint is more
complicated than a simple tag (such as the composite constraint
`//go:build tag && go1.18`), the file is not considered to be a standalone
main file.

This setting is only supported when gopls is built with Go 1.16 or later.

Default: `["ignore"]`.

### Formatting

#### **local** *string*

local is the equivalent of the `goimports -local` flag, which puts
imports beginning with this string after third-party packages. It should
be the prefix of the import path whose imports should be grouped
separately.

Default: `""`.

#### **gofumpt** *bool*

gofumpt indicates if we should run gofumpt formatting.

Default: `false`.

### UI

#### **codelenses** *map[string]bool*

codelenses overrides the enabled/disabled state of code lenses. See the
"Code Lenses" section of the
[Settings page](https://github.com/golang/tools/blob/master/gopls/doc/settings.md#code-lenses)
for the list of supported lenses.

Example Usage:

```json5
"gopls": {
...
  "codelenses": {
    "generate": false,  // Don't show the `go generate` lens.
    "gc_details": true  // Show a code lens toggling the display of gc's choices.
  }
...
}
```

Default: `{"gc_details":false,"generate":true,"regenerate_cgo":true,"tidy":true,"upgrade_dependency":true,"vendor":true}`.

#### **semanticTokens** *bool*

**This setting is experimental and may be deleted.**

semanticTokens controls whether the LSP server will send
semantic tokens to the client.

Default: `false`.

#### **noSemanticString** *bool*

**This setting is experimental and may be deleted.**

noSemanticString turns off the sending of the semantic token 'string'

Default: `false`.

#### **noSemanticNumber** *bool*

**This setting is experimental and may be deleted.**

noSemanticNumber  turns off the sending of the semantic token 'number'

Default: `false`.

#### Completion

##### **usePlaceholders** *bool*

placeholders enables placeholders for function parameters or struct
fields in completion responses.

Default: `false`.

##### **completionBudget** *time.Duration*

**This setting is for debugging purposes only.**

completionBudget is the soft latency goal for completion requests. Most
requests finish in a couple milliseconds, but in some cases deep
completions can take much longer. As we use up our budget we
dynamically reduce the search scope to ensure we return timely
results. Zero means unlimited.

Default: `"100ms"`.

##### **matcher** *enum*

**This is an advanced setting and should not be configured by most `gopls` users.**

matcher sets the algorithm that is used when calculating completion
candidates.

Must be one of:

* `"CaseInsensitive"`
* `"CaseSensitive"`
* `"Fuzzy"`

Default: `"Fuzzy"`.

##### **experimentalPostfixCompletions** *bool*

**This setting is experimental and may be deleted.**

experimentalPostfixCompletions enables artificial method snippets
such as "someSlice.sort!".

Default: `true`.

#### Diagnostic

##### **analyses** *map[string]bool*

analyses specify analyses that the user would like to enable or disable.
A map of the names of analysis passes that should be enabled/disabled.
A full list of analyzers that gopls uses can be found in
[analyzers.md](https://github.com/golang/tools/blob/master/gopls/doc/analyzers.md).

Example Usage:

```json5
...
"analyses": {
  "unreachable": false, // Disable the unreachable analyzer.
  "unusedparams": true  // Enable the unusedparams analyzer.
}
...
```

Default: `{}`.

##### **staticcheck** *bool*

**This setting is experimental and may be deleted.**

staticcheck enables additional analyses from staticcheck.io.
These analyses are documented on
[Staticcheck's website](https://staticcheck.io/docs/checks/).

Default: `false`.

##### **annotations** *map[string]bool*

**This setting is experimental and may be deleted.**

annotations specifies the various kinds of optimization diagnostics
that should be reported by the gc_details command.

Can contain any of:

* `"bounds"` controls bounds checking diagnostics.
* `"escape"` controls diagnostics about escape choices.
* `"inline"` controls diagnostics about inlining choices.
* `"nil"` controls nil checks.

Default: `{"bounds":true,"escape":true,"inline":true,"nil":true}`.

##### **vulncheck** *enum*

**This setting is experimental and may be deleted.**

vulncheck enables vulnerability scanning.

Must be one of:

* `"Imports"`: In Imports mode, `gopls` will report vulnerabilities that affect packages
directly and indirectly used by the analyzed main module.
* `"Off"`: Disable vulnerability analysis.

Default: `"Off"`.

##### **diagnosticsDelay** *time.Duration*

**This is an advanced setting and should not be configured by most `gopls` users.**

diagnosticsDelay controls the amount of time that gopls waits
after the most recent file modification before computing deep diagnostics.
Simple diagnostics (parsing and type-checking) are always run immediately
on recently modified packages.

This option must be set to a valid duration string, for example `"250ms"`.

Default: `"1s"`.

#### Documentation

##### **hoverKind** *enum*

hoverKind controls the information that appears in the hover text.
SingleLine and Structured are intended for use only by authors of editor plugins.

Must be one of:

* `"FullDocumentation"`
* `"NoDocumentation"`
* `"SingleLine"`
* `"Structured"` is an experimental setting that returns a structured hover format.
This format separates the signature from the documentation, so that the client
can do more manipulation of these fields.\
This should only be used by clients that support this behavior.
* `"SynopsisDocumentation"`

Default: `"FullDocumentation"`.

##### **linkTarget** *string*

linkTarget controls where documentation links go.
It might be one of:

* `"godoc.org"`
* `"pkg.go.dev"`

If company chooses to use its own `godoc.org`, its address can be used as well.

Modules matching the GOPRIVATE environment variable will not have
documentation links in hover.

Default: `"pkg.go.dev"`.

##### **linksInHover** *bool*

linksInHover toggles the presence of links to documentation in hover.

Default: `true`.

#### Inlayhint

##### **hints** *map[string]bool*

**This setting is experimental and may be deleted.**

hints specify inlay hints that users want to see. A full list of hints
that gopls uses can be found in
[inlayHints.md](https://github.com/golang/tools/blob/master/gopls/doc/inlayHints.md).

Default: `{}`.

#### Navigation

##### **importShortcut** *enum*

importShortcut specifies whether import statements should link to
documentation or go to definitions.

Must be one of:

* `"Both"`
* `"Definition"`
* `"Link"`

Default: `"Both"`.

##### **symbolMatcher** *enum*

**This is an advanced setting and should not be configured by most `gopls` users.**

symbolMatcher sets the algorithm that is used when finding workspace symbols.

Must be one of:

* `"CaseInsensitive"`
* `"CaseSensitive"`
* `"FastFuzzy"`
* `"Fuzzy"`

Default: `"FastFuzzy"`.

##### **symbolStyle** *enum*

**This is an advanced setting and should not be configured by most `gopls` users.**

symbolStyle controls how symbols are qualified in symbol responses.

Example Usage:

```json5
"gopls": {
...
  "symbolStyle": "Dynamic",
...
}
```

Must be one of:

* `"Dynamic"` uses whichever qualifier results in the highest scoring
match for the given symbol query. Here a "qualifier" is any "/" or "."
delimited suffix of the fully qualified symbol. i.e. "to/pkg.Foo.Field" or
just "Foo.Field".
* `"Full"` is fully qualified symbols, i.e.
"path/to/pkg.Foo.Field".
* `"Package"` is package qualified symbols i.e.
"pkg.Foo.Field".

Default: `"Dynamic"`.

##### **symbolScope** *enum*

symbolScope controls which packages are searched for workspace/symbol
requests. The default value, "workspace", searches only workspace
packages. The legacy behavior, "all", causes all loaded packages to be
searched, including dependencies; this is more expensive and may return
unwanted results.

Must be one of:

* `"all"` matches symbols in any loaded package, including
dependencies.
* `"workspace"` matches symbols in workspace packages only.

Default: `"all"`.

#### **verboseOutput** *bool*

**This setting is for debugging purposes only.**

verboseOutput enables additional debug logging.

Default: `false`.

<!-- END User: DO NOT MANUALLY EDIT THIS SECTION -->

#### **newDiff** *string*

newDiff enables the new diff implementation. If this is "both", for now both
diffs will be run and statistics will be generated in a file in $TMPDIR. This
is a risky setting; help in trying it is appreciated. If it is "old" the old
implementation is used, and if it is "new", just the new implementation is
used. This setting will eventually be deleted, once gopls has fully migrated to
the new diff algorithm.

Default: 'both'.

## Code Lenses

These are the code lenses that `gopls` currently supports. They can be enabled
and disabled using the `codelenses` setting, documented above. Their names and
features are subject to change.

<!-- BEGIN Lenses: DO NOT MANUALLY EDIT THIS SECTION -->
### **Toggle gc_details**

Identifier: `gc_details`

Toggle the calculation of gc annotations.
### **Run go generate**

Identifier: `generate`

Runs `go generate` for a given directory.
### **Regenerate cgo**

Identifier: `regenerate_cgo`

Regenerates cgo definitions.
### **Run govulncheck.**

Identifier: `run_govulncheck`

Run vulnerability check (`govulncheck`).
### **Run test(s) (legacy)**

Identifier: `test`

Runs `go test` for a specific set of test or benchmark functions.
### **Run go mod tidy**

Identifier: `tidy`

Runs `go mod tidy` for a module.
### **Upgrade a dependency**

Identifier: `upgrade_dependency`

Upgrades a dependency in the go.mod file for a module.
### **Run go mod vendor**

Identifier: `vendor`

Runs `go mod vendor` for a module.
<!-- END Lenses: DO NOT MANUALLY EDIT THIS SECTION -->

---
title: "Gopls: Analyzers"
---

<!-- No Table of Contents: GitHub's Markdown renderer synthesizes it. -->

Gopls contains a driver for pluggable, modular static
[analyzers](https://pkg.go.dev/golang.org/x/tools/go/analysis#hdr-Analyzer),
such as those used by [go vet](https://pkg.go.dev/cmd/vet).

Most analyzers report mistakes in your code;
some suggest "quick fixes" that can be directly applied in your editor.
Every time you edit your code, gopls re-runs its analyzers.
Analyzer diagnostics help you detect bugs sooner,
before you run your tests, or even before you save your files.

This document describes the suite of analyzers available in gopls,
which aggregates analyzers from a variety of sources:

- all the usual bug-finding analyzers from the `go vet` suite (e.g. `printf`; see [`go tool vet help`](https://pkg.go.dev/cmd/vet) for the complete list);
- a number of analyzers with more substantial dependencies that prevent them from being used in `go vet` (e.g. `nilness`);
- analyzers that augment compilation errors by suggesting quick fixes to common mistakes (e.g. `fillreturns`); and
- a handful of analyzers that suggest possible style improvements (e.g. `simplifyrange`).

To enable or disable analyzers, use the [analyses](settings.md#analyses) setting.

In addition, gopls includes the [`staticcheck` suite](https://staticcheck.dev/docs/checks).
When the [`staticcheck`](settings.md#staticcheck`) boolean option is
unset, slightly more than half of these analyzers are enabled by
default; this subset has been chosen for precision and efficiency. Set
`staticcheck` to `true` to enable the complete set, or to `false` to
disable the complete set.

Staticcheck analyzers, like all other analyzers, can be explicitly
enabled or disabled using the `analyzers` configuration setting; this
setting takes precedence over the `staticcheck` setting, so,
regardless of what value of `staticcheck` you use (true/false/unset),
you can make adjustments to your preferred set of analyzers.


<!-- BEGIN Analyzers: DO NOT MANUALLY EDIT THIS SECTION -->
<a id='QF1001'></a>
## `QF1001`: Apply De Morgan's law


Available since
    2021.1


Default: off. Enable by setting `"analyses": {"QF1001": true}`.

Package documentation: [QF1001](https://staticcheck.dev/docs/checks/#QF1001)

<a id='QF1002'></a>
## `QF1002`: Convert untagged switch to tagged switch


An untagged switch that compares a single variable against a series of
values can be replaced with a tagged switch.

Before:

    switch {
    case x == 1 || x == 2, x == 3:
        ...
    case x == 4:
        ...
    default:
        ...
    }

After:

    switch x {
    case 1, 2, 3:
        ...
    case 4:
        ...
    default:
        ...
    }

Available since
    2021.1


Default: on.

Package documentation: [QF1002](https://staticcheck.dev/docs/checks/#QF1002)

<a id='QF1003'></a>
## `QF1003`: Convert if/else-if chain to tagged switch


A series of if/else-if checks comparing the same variable against
values can be replaced with a tagged switch.

Before:

    if x == 1 || x == 2 {
        ...
    } else if x == 3 {
        ...
    } else {
        ...
    }

After:

    switch x {
    case 1, 2:
        ...
    case 3:
        ...
    default:
        ...
    }

Available since
    2021.1


Default: on.

Package documentation: [QF1003](https://staticcheck.dev/docs/checks/#QF1003)

<a id='QF1004'></a>
## `QF1004`: Use strings.ReplaceAll instead of strings.Replace with n == -1


Available since
    2021.1


Default: on.

Package documentation: [QF1004](https://staticcheck.dev/docs/checks/#QF1004)

<a id='QF1005'></a>
## `QF1005`: Expand call to math.Pow


Some uses of math.Pow can be simplified to basic multiplication.

Before:

    math.Pow(x, 2)

After:

    x * x

Available since
    2021.1


Default: off. Enable by setting `"analyses": {"QF1005": true}`.

Package documentation: [QF1005](https://staticcheck.dev/docs/checks/#QF1005)

<a id='QF1006'></a>
## `QF1006`: Lift if+break into loop condition


Before:

    for {
        if done {
            break
        }
        ...
    }

After:

    for !done {
        ...
    }

Available since
    2021.1


Default: off. Enable by setting `"analyses": {"QF1006": true}`.

Package documentation: [QF1006](https://staticcheck.dev/docs/checks/#QF1006)

<a id='QF1007'></a>
## `QF1007`: Merge conditional assignment into variable declaration


Before:

    x := false
    if someCondition {
        x = true
    }

After:

    x := someCondition

Available since
    2021.1


Default: off. Enable by setting `"analyses": {"QF1007": true}`.

Package documentation: [QF1007](https://staticcheck.dev/docs/checks/#QF1007)

<a id='QF1008'></a>
## `QF1008`: Omit embedded fields from selector expression


Available since
    2021.1


Default: off. Enable by setting `"analyses": {"QF1008": true}`.

Package documentation: [QF1008](https://staticcheck.dev/docs/checks/#QF1008)

<a id='QF1009'></a>
## `QF1009`: Use time.Time.Equal instead of == operator


Available since
    2021.1


Default: on.

Package documentation: [QF1009](https://staticcheck.dev/docs/checks/#QF1009)

<a id='QF1010'></a>
## `QF1010`: Convert slice of bytes to string when printing it


Available since
    2021.1


Default: on.

Package documentation: [QF1010](https://staticcheck.dev/docs/checks/#QF1010)

<a id='QF1011'></a>
## `QF1011`: Omit redundant type from variable declaration


Available since
    2021.1


Default: off. Enable by setting `"analyses": {"QF1011": true}`.

Package documentation: [QF1011](https://staticcheck.dev/docs/checks/#)

<a id='QF1012'></a>
## `QF1012`: Use fmt.Fprintf(x, ...) instead of x.Write(fmt.Sprintf(...))


Available since
    2022.1


Default: on.

Package documentation: [QF1012](https://staticcheck.dev/docs/checks/#QF1012)

<a id='S1000'></a>
## `S1000`: Use plain channel send or receive instead of single-case select


Select statements with a single case can be replaced with a simple
send or receive.

Before:

    select {
    case x := <-ch:
        fmt.Println(x)
    }

After:

    x := <-ch
    fmt.Println(x)

Available since
    2017.1


Default: on.

Package documentation: [S1000](https://staticcheck.dev/docs/checks/#S1000)

<a id='S1001'></a>
## `S1001`: Replace for loop with call to copy


Use copy() for copying elements from one slice to another. For
arrays of identical size, you can use simple assignment.

Before:

    for i, x := range src {
        dst[i] = x
    }

After:

    copy(dst, src)

Available since
    2017.1


Default: on.

Package documentation: [S1001](https://staticcheck.dev/docs/checks/#S1001)

<a id='S1002'></a>
## `S1002`: Omit comparison with boolean constant


Before:

    if x == true {}

After:

    if x {}

Available since
    2017.1


Default: off. Enable by setting `"analyses": {"S1002": true}`.

Package documentation: [S1002](https://staticcheck.dev/docs/checks/#S1002)

<a id='S1003'></a>
## `S1003`: Replace call to strings.Index with strings.Contains


Before:

    if strings.Index(x, y) != -1 {}

After:

    if strings.Contains(x, y) {}

Available since
    2017.1


Default: on.

Package documentation: [S1003](https://staticcheck.dev/docs/checks/#S1003)

<a id='S1004'></a>
## `S1004`: Replace call to bytes.Compare with bytes.Equal


Before:

    if bytes.Compare(x, y) == 0 {}

After:

    if bytes.Equal(x, y) {}

Available since
    2017.1


Default: on.

Package documentation: [S1004](https://staticcheck.dev/docs/checks/#S1004)

<a id='S1005'></a>
## `S1005`: Drop unnecessary use of the blank identifier


In many cases, assigning to the blank identifier is unnecessary.

Before:

    for _ = range s {}
    x, _ = someMap[key]
    _ = <-ch

After:

    for range s{}
    x = someMap[key]
    <-ch

Available since
    2017.1


Default: off. Enable by setting `"analyses": {"S1005": true}`.

Package documentation: [S1005](https://staticcheck.dev/docs/checks/#S1005)

<a id='S1006'></a>
## `S1006`: Use 'for { ... }' for infinite loops


For infinite loops, using for { ... } is the most idiomatic choice.

Available since
    2017.1


Default: off. Enable by setting `"analyses": {"S1006": true}`.

Package documentation: [S1006](https://staticcheck.dev/docs/checks/#S1006)

<a id='S1007'></a>
## `S1007`: Simplify regular expression by using raw string literal


Raw string literals use backticks instead of quotation marks and do not support
any escape sequences. This means that the backslash can be used
freely, without the need of escaping.

Since regular expressions have their own escape sequences, raw strings
can improve their readability.

Before:

    regexp.Compile("\\A(\\w+) profile: total \\d+\\n\\z")

After:

    regexp.Compile(`\A(\w+) profile: total \d+\n\z`)

Available since
    2017.1


Default: on.

Package documentation: [S1007](https://staticcheck.dev/docs/checks/#S1007)

<a id='S1008'></a>
## `S1008`: Simplify returning boolean expression


Before:

    if <expr> {
        return true
    }
    return false

After:

    return <expr>

Available since
    2017.1


Default: off. Enable by setting `"analyses": {"S1008": true}`.

Package documentation: [S1008](https://staticcheck.dev/docs/checks/#S1008)

<a id='S1009'></a>
## `S1009`: Omit redundant nil check on slices, maps, and channels


The len function is defined for all slices, maps, and
channels, even nil ones, which have a length of zero. It is not necessary to
check for nil before checking that their length is not zero.

Before:

    if x != nil && len(x) != 0 {}

After:

    if len(x) != 0 {}

Available since
    2017.1


Default: on.

Package documentation: [S1009](https://staticcheck.dev/docs/checks/#S1009)

<a id='S1010'></a>
## `S1010`: Omit default slice index


When slicing, the second index defaults to the length of the value,
making s[n:len(s)] and s[n:] equivalent.

Available since
    2017.1


Default: on.

Package documentation: [S1010](https://staticcheck.dev/docs/checks/#S1010)

<a id='S1011'></a>
## `S1011`: Use a single append to concatenate two slices


Before:

    for _, e := range y {
        x = append(x, e)
    }
    
    for i := range y {
        x = append(x, y[i])
    }
    
    for i := range y {
        v := y[i]
        x = append(x, v)
    }

After:

    x = append(x, y...)
    x = append(x, y...)
    x = append(x, y...)

Available since
    2017.1


Default: off. Enable by setting `"analyses": {"S1011": true}`.

Package documentation: [S1011](https://staticcheck.dev/docs/checks/#S1011)

<a id='S1012'></a>
## `S1012`: Replace time.Now().Sub(x) with time.Since(x)


The time.Since helper has the same effect as using time.Now().Sub(x)
but is easier to read.

Before:

    time.Now().Sub(x)

After:

    time.Since(x)

Available since
    2017.1


Default: on.

Package documentation: [S1012](https://staticcheck.dev/docs/checks/#S1012)

<a id='S1016'></a>
## `S1016`: Use a type conversion instead of manually copying struct fields


Two struct types with identical fields can be converted between each
other. In older versions of Go, the fields had to have identical
struct tags. Since Go 1.8, however, struct tags are ignored during
conversions. It is thus not necessary to manually copy every field
individually.

Before:

    var x T1
    y := T2{
        Field1: x.Field1,
        Field2: x.Field2,
    }

After:

    var x T1
    y := T2(x)

Available since
    2017.1


Default: off. Enable by setting `"analyses": {"S1016": true}`.

Package documentation: [S1016](https://staticcheck.dev/docs/checks/#S1016)

<a id='S1017'></a>
## `S1017`: Replace manual trimming with strings.TrimPrefix


Instead of using strings.HasPrefix and manual slicing, use the
strings.TrimPrefix function. If the string doesn't start with the
prefix, the original string will be returned. Using strings.TrimPrefix
reduces complexity, and avoids common bugs, such as off-by-one
mistakes.

Before:

    if strings.HasPrefix(str, prefix) {
        str = str[len(prefix):]
    }

After:

    str = strings.TrimPrefix(str, prefix)

Available since
    2017.1


Default: on.

Package documentation: [S1017](https://staticcheck.dev/docs/checks/#S1017)

<a id='S1018'></a>
## `S1018`: Use 'copy' for sliding elements


copy() permits using the same source and destination slice, even with
overlapping ranges. This makes it ideal for sliding elements in a
slice.

Before:

    for i := 0; i < n; i++ {
        bs[i] = bs[offset+i]
    }

After:

    copy(bs[:n], bs[offset:])

Available since
    2017.1


Default: on.

Package documentation: [S1018](https://staticcheck.dev/docs/checks/#S1018)

<a id='S1019'></a>
## `S1019`: Simplify 'make' call by omitting redundant arguments


The 'make' function has default values for the length and capacity
arguments. For channels, the length defaults to zero, and for slices,
the capacity defaults to the length.

Available since
    2017.1


Default: on.

Package documentation: [S1019](https://staticcheck.dev/docs/checks/#S1019)

<a id='S1020'></a>
## `S1020`: Omit redundant nil check in type assertion


Before:

    if _, ok := i.(T); ok && i != nil {}

After:

    if _, ok := i.(T); ok {}

Available since
    2017.1


Default: on.

Package documentation: [S1020](https://staticcheck.dev/docs/checks/#S1020)

<a id='S1021'></a>
## `S1021`: Merge variable declaration and assignment


Before:

    var x uint
    x = 1

After:

    var x uint = 1

Available since
    2017.1


Default: off. Enable by setting `"analyses": {"S1021": true}`.

Package documentation: [S1021](https://staticcheck.dev/docs/checks/#S1021)

<a id='S1023'></a>
## `S1023`: Omit redundant control flow


Functions that have no return value do not need a return statement as
the final statement of the function.

Switches in Go do not have automatic fallthrough, unlike languages
like C. It is not necessary to have a break statement as the final
statement in a case block.

Available since
    2017.1


Default: on.

Package documentation: [S1023](https://staticcheck.dev/docs/checks/#S1023)

<a id='S1024'></a>
## `S1024`: Replace x.Sub(time.Now()) with time.Until(x)


The time.Until helper has the same effect as using x.Sub(time.Now())
but is easier to read.

Before:

    x.Sub(time.Now())

After:

    time.Until(x)

Available since
    2017.1


Default: on.

Package documentation: [S1024](https://staticcheck.dev/docs/checks/#S1024)

<a id='S1025'></a>
## `S1025`: Don't use fmt.Sprintf("%s", x) unnecessarily


In many instances, there are easier and more efficient ways of getting
a value's string representation. Whenever a value's underlying type is
a string already, or the type has a String method, they should be used
directly.

Given the following shared definitions

    type T1 string
    type T2 int

    func (T2) String() string { return "Hello, world" }

    var x string
    var y T1
    var z T2

we can simplify

    fmt.Sprintf("%s", x)
    fmt.Sprintf("%s", y)
    fmt.Sprintf("%s", z)

to

    x
    string(y)
    z.String()

Available since
    2017.1


Default: off. Enable by setting `"analyses": {"S1025": true}`.

Package documentation: [S1025](https://staticcheck.dev/docs/checks/#S1025)

<a id='S1028'></a>
## `S1028`: Simplify error construction with fmt.Errorf


Before:

    errors.New(fmt.Sprintf(...))

After:

    fmt.Errorf(...)

Available since
    2017.1


Default: on.

Package documentation: [S1028](https://staticcheck.dev/docs/checks/#S1028)

<a id='S1029'></a>
## `S1029`: Range over the string directly


Ranging over a string will yield byte offsets and runes. If the offset
isn't used, this is functionally equivalent to converting the string
to a slice of runes and ranging over that. Ranging directly over the
string will be more performant, however, as it avoids allocating a new
slice, the size of which depends on the length of the string.

Before:

    for _, r := range []rune(s) {}

After:

    for _, r := range s {}

Available since
    2017.1


Default: off. Enable by setting `"analyses": {"S1029": true}`.

Package documentation: [S1029](https://staticcheck.dev/docs/checks/#S1029)

<a id='S1030'></a>
## `S1030`: Use bytes.Buffer.String or bytes.Buffer.Bytes


bytes.Buffer has both a String and a Bytes method. It is almost never
necessary to use string(buf.Bytes()) or []byte(buf.String()) – simply
use the other method.

The only exception to this are map lookups. Due to a compiler optimization,
m[string(buf.Bytes())] is more efficient than m[buf.String()].

Available since
    2017.1


Default: on.

Package documentation: [S1030](https://staticcheck.dev/docs/checks/#S1030)

<a id='S1031'></a>
## `S1031`: Omit redundant nil check around loop


You can use range on nil slices and maps, the loop will simply never
execute. This makes an additional nil check around the loop
unnecessary.

Before:

    if s != nil {
        for _, x := range s {
            ...
        }
    }

After:

    for _, x := range s {
        ...
    }

Available since
    2017.1


Default: on.

Package documentation: [S1031](https://staticcheck.dev/docs/checks/#S1031)

<a id='S1032'></a>
## `S1032`: Use sort.Ints(x), sort.Float64s(x), and sort.Strings(x)


The sort.Ints, sort.Float64s and sort.Strings functions are easier to
read than sort.Sort(sort.IntSlice(x)), sort.Sort(sort.Float64Slice(x))
and sort.Sort(sort.StringSlice(x)).

Before:

    sort.Sort(sort.StringSlice(x))

After:

    sort.Strings(x)

Available since
    2019.1


Default: on.

Package documentation: [S1032](https://staticcheck.dev/docs/checks/#S1032)

<a id='S1033'></a>
## `S1033`: Unnecessary guard around call to 'delete'


Calling delete on a nil map is a no-op.

Available since
    2019.2


Default: on.

Package documentation: [S1033](https://staticcheck.dev/docs/checks/#S1033)

<a id='S1034'></a>
## `S1034`: Use result of type assertion to simplify cases


Available since
    2019.2


Default: on.

Package documentation: [S1034](https://staticcheck.dev/docs/checks/#S1034)

<a id='S1035'></a>
## `S1035`: Redundant call to net/http.CanonicalHeaderKey in method call on net/http.Header


The methods on net/http.Header, namely Add, Del, Get
and Set, already canonicalize the given header name.

Available since
    2020.1


Default: on.

Package documentation: [S1035](https://staticcheck.dev/docs/checks/#S1035)

<a id='S1036'></a>
## `S1036`: Unnecessary guard around map access


When accessing a map key that doesn't exist yet, one receives a zero
value. Often, the zero value is a suitable value, for example when
using append or doing integer math.

The following

    if _, ok := m["foo"]; ok {
        m["foo"] = append(m["foo"], "bar")
    } else {
        m["foo"] = []string{"bar"}
    }

can be simplified to

    m["foo"] = append(m["foo"], "bar")

and

    if _, ok := m2["k"]; ok {
        m2["k"] += 4
    } else {
        m2["k"] = 4
    }

can be simplified to

    m["k"] += 4

Available since
    2020.1


Default: on.

Package documentation: [S1036](https://staticcheck.dev/docs/checks/#S1036)

<a id='S1037'></a>
## `S1037`: Elaborate way of sleeping


Using a select statement with a single case receiving
from the result of time.After is a very elaborate way of sleeping that
can much simpler be expressed with a simple call to time.Sleep.

Available since
    2020.1


Default: on.

Package documentation: [S1037](https://staticcheck.dev/docs/checks/#S1037)

<a id='S1038'></a>
## `S1038`: Unnecessarily complex way of printing formatted string


Instead of using fmt.Print(fmt.Sprintf(...)), one can use fmt.Printf(...).

Available since
    2020.1


Default: on.

Package documentation: [S1038](https://staticcheck.dev/docs/checks/#S1038)

<a id='S1039'></a>
## `S1039`: Unnecessary use of fmt.Sprint


Calling fmt.Sprint with a single string argument is unnecessary
and identical to using the string directly.

Available since
    2020.1


Default: on.

Package documentation: [S1039](https://staticcheck.dev/docs/checks/#S1039)

<a id='S1040'></a>
## `S1040`: Type assertion to current type


The type assertion x.(SomeInterface), when x already has type
SomeInterface, can only fail if x is nil. Usually, this is
left-over code from when x had a different type and you can safely
delete the type assertion. If you want to check that x is not nil,
consider being explicit and using an actual if x == nil comparison
instead of relying on the type assertion panicking.

Available since
    2021.1


Default: on.

Package documentation: [S1040](https://staticcheck.dev/docs/checks/#S1040)

<a id='SA1000'></a>
## `SA1000`: Invalid regular expression


Available since
    2017.1


Default: off. Enable by setting `"analyses": {"SA1000": true}`.

Package documentation: [SA1000](https://staticcheck.dev/docs/checks/#SA1000)

<a id='SA1001'></a>
## `SA1001`: Invalid template


Available since
    2017.1


Default: on.

Package documentation: [SA1001](https://staticcheck.dev/docs/checks/#SA1001)

<a id='SA1002'></a>
## `SA1002`: Invalid format in time.Parse


Available since
    2017.1


Default: off. Enable by setting `"analyses": {"SA1002": true}`.

Package documentation: [SA1002](https://staticcheck.dev/docs/checks/#SA1002)

<a id='SA1003'></a>
## `SA1003`: Unsupported argument to functions in encoding/binary


The encoding/binary package can only serialize types with known sizes.
This precludes the use of the int and uint types, as their sizes
differ on different architectures. Furthermore, it doesn't support
serializing maps, channels, strings, or functions.

Before Go 1.8, bool wasn't supported, either.

Available since
    2017.1


Default: off. Enable by setting `"analyses": {"SA1003": true}`.

Package documentation: [SA1003](https://staticcheck.dev/docs/checks/#SA1003)

<a id='SA1004'></a>
## `SA1004`: Suspiciously small untyped constant in time.Sleep


The time.Sleep function takes a time.Duration as its only argument.
Durations are expressed in nanoseconds. Thus, calling time.Sleep(1)
will sleep for 1 nanosecond. This is a common source of bugs, as sleep
functions in other languages often accept seconds or milliseconds.

The time package provides constants such as time.Second to express
large durations. These can be combined with arithmetic to express
arbitrary durations, for example 5 * time.Second for 5 seconds.

If you truly meant to sleep for a tiny amount of time, use
n * time.Nanosecond to signal to Staticcheck that you did mean to sleep
for some amount of nanoseconds.

Available since
    2017.1


Default: on.

Package documentation: [SA1004](https://staticcheck.dev/docs/checks/#SA1004)

<a id='SA1005'></a>
## `SA1005`: Invalid first argument to exec.Command


os/exec runs programs directly (using variants of the fork and exec
system calls on Unix systems). This shouldn't be confused with running
a command in a shell. The shell will allow for features such as input
redirection, pipes, and general scripting. The shell is also
responsible for splitting the user's input into a program name and its
arguments. For example, the equivalent to

    ls / /tmp

would be

    exec.Command("ls", "/", "/tmp")

If you want to run a command in a shell, consider using something like
the following – but be aware that not all systems, particularly
Windows, will have a /bin/sh program:

    exec.Command("/bin/sh", "-c", "ls | grep Awesome")

Available since
    2017.1


Default: on.

Package documentation: [SA1005](https://staticcheck.dev/docs/checks/#SA1005)

<a id='SA1007'></a>
## `SA1007`: Invalid URL in net/url.Parse


Available since
    2017.1


Default: off. Enable by setting `"analyses": {"SA1007": true}`.

Package documentation: [SA1007](https://staticcheck.dev/docs/checks/#SA1007)

<a id='SA1008'></a>
## `SA1008`: Non-canonical key in http.Header map


Keys in http.Header maps are canonical, meaning they follow a specific
combination of uppercase and lowercase letters. Methods such as
http.Header.Add and http.Header.Del convert inputs into this canonical
form before manipulating the map.

When manipulating http.Header maps directly, as opposed to using the
provided methods, care should be taken to stick to canonical form in
order to avoid inconsistencies. The following piece of code
demonstrates one such inconsistency:

    h := http.Header{}
    h["etag"] = []string{"1234"}
    h.Add("etag", "5678")
    fmt.Println(h)

    // Output:
    // map[Etag:[5678] etag:[1234]]

The easiest way of obtaining the canonical form of a key is to use
http.CanonicalHeaderKey.

Available since
    2017.1


Default: on.

Package documentation: [SA1008](https://staticcheck.dev/docs/checks/#SA1008)

<a id='SA1010'></a>
## `SA1010`: (*regexp.Regexp).FindAll called with n == 0, which will always return zero results


If n >= 0, the function returns at most n matches/submatches. To
return all results, specify a negative number.

Available since
    2017.1


Default: off. Enable by setting `"analyses": {"SA1010": true}`.

Package documentation: [SA1010](https://staticcheck.dev/docs/checks/#SA1010)

<a id='SA1011'></a>
## `SA1011`: Various methods in the 'strings' package expect valid UTF-8, but invalid input is provided


Available since
    2017.1


Default: off. Enable by setting `"analyses": {"SA1011": true}`.

Package documentation: [SA1011](https://staticcheck.dev/docs/checks/#SA1011)

<a id='SA1012'></a>
## `SA1012`: A nil context.Context is being passed to a function, consider using context.TODO instead


Available since
    2017.1


Default: on.

Package documentation: [SA1012](https://staticcheck.dev/docs/checks/#SA1012)

<a id='SA1013'></a>
## `SA1013`: io.Seeker.Seek is being called with the whence constant as the first argument, but it should be the second


Available since
    2017.1


Default: on.

Package documentation: [SA1013](https://staticcheck.dev/docs/checks/#SA1013)

<a id='SA1014'></a>
## `SA1014`: Non-pointer value passed to Unmarshal or Decode


Available since
    2017.1


Default: off. Enable by setting `"analyses": {"SA1014": true}`.

Package documentation: [SA1014](https://staticcheck.dev/docs/checks/#SA1014)

<a id='SA1015'></a>
## `SA1015`: Using time.Tick in a way that will leak. Consider using time.NewTicker, and only use time.Tick in tests, commands and endless functions


Before Go 1.23, time.Tickers had to be closed to be able to be garbage
collected. Since time.Tick doesn't make it possible to close the underlying
ticker, using it repeatedly would leak memory.

Go 1.23 fixes this by allowing tickers to be collected even if they weren't closed.

Available since
    2017.1


Default: off. Enable by setting `"analyses": {"SA1015": true}`.

Package documentation: [SA1015](https://staticcheck.dev/docs/checks/#SA1015)

<a id='SA1016'></a>
## `SA1016`: Trapping a signal that cannot be trapped


Not all signals can be intercepted by a process. Specifically, on
UNIX-like systems, the syscall.SIGKILL and syscall.SIGSTOP signals are
never passed to the process, but instead handled directly by the
kernel. It is therefore pointless to try and handle these signals.

Available since
    2017.1


Default: on.

Package documentation: [SA1016](https://staticcheck.dev/docs/checks/#SA1016)

<a id='SA1017'></a>
## `SA1017`: Channels used with os/signal.Notify should be buffered


The os/signal package uses non-blocking channel sends when delivering
signals. If the receiving end of the channel isn't ready and the
channel is either unbuffered or full, the signal will be dropped. To
avoid missing signals, the channel should be buffered and of the
appropriate size. For a channel used for notification of just one
signal value, a buffer of size 1 is sufficient.

Available since
    2017.1


Default: off. Enable by setting `"analyses": {"SA1017": true}`.

Package documentation: [SA1017](https://staticcheck.dev/docs/checks/#SA1017)

<a id='SA1018'></a>
## `SA1018`: strings.Replace called with n == 0, which does nothing


With n == 0, zero instances will be replaced. To replace all
instances, use a negative number, or use strings.ReplaceAll.

Available since
    2017.1


Default: off. Enable by setting `"analyses": {"SA1018": true}`.

Package documentation: [SA1018](https://staticcheck.dev/docs/checks/#SA1018)

<a id='SA1020'></a>
## `SA1020`: Using an invalid host:port pair with a net.Listen-related function


Available since
    2017.1


Default: off. Enable by setting `"analyses": {"SA1020": true}`.

Package documentation: [SA1020](https://staticcheck.dev/docs/checks/#SA1020)

<a id='SA1021'></a>
## `SA1021`: Using bytes.Equal to compare two net.IP


A net.IP stores an IPv4 or IPv6 address as a slice of bytes. The
length of the slice for an IPv4 address, however, can be either 4 or
16 bytes long, using different ways of representing IPv4 addresses. In
order to correctly compare two net.IPs, the net.IP.Equal method should
be used, as it takes both representations into account.

Available since
    2017.1


Default: off. Enable by setting `"analyses": {"SA1021": true}`.

Package documentation: [SA1021](https://staticcheck.dev/docs/checks/#SA1021)

<a id='SA1023'></a>
## `SA1023`: Modifying the buffer in an io.Writer implementation


Write must not modify the slice data, even temporarily.

Available since
    2017.1


Default: off. Enable by setting `"analyses": {"SA1023": true}`.

Package documentation: [SA1023](https://staticcheck.dev/docs/checks/#SA1023)

<a id='SA1024'></a>
## `SA1024`: A string cutset contains duplicate characters


The strings.TrimLeft and strings.TrimRight functions take cutsets, not
prefixes. A cutset is treated as a set of characters to remove from a
string. For example,

    strings.TrimLeft("42133word", "1234")

will result in the string "word" – any characters that are 1, 2, 3 or
4 are cut from the left of the string.

In order to remove one string from another, use strings.TrimPrefix instead.

Available since
    2017.1


Default: off. Enable by setting `"analyses": {"SA1024": true}`.

Package documentation: [SA1024](https://staticcheck.dev/docs/checks/#SA1024)

<a id='SA1025'></a>
## `SA1025`: It is not possible to use (*time.Timer).Reset's return value correctly


Available since
    2019.1


Default: off. Enable by setting `"analyses": {"SA1025": true}`.

Package documentation: [SA1025](https://staticcheck.dev/docs/checks/#SA1025)

<a id='SA1026'></a>
## `SA1026`: Cannot marshal channels or functions


Available since
    2019.2


Default: off. Enable by setting `"analyses": {"SA1026": true}`.

Package documentation: [SA1026](https://staticcheck.dev/docs/checks/#SA1026)

<a id='SA1027'></a>
## `SA1027`: Atomic access to 64-bit variable must be 64-bit aligned


On ARM, x86-32, and 32-bit MIPS, it is the caller's responsibility to
arrange for 64-bit alignment of 64-bit words accessed atomically. The
first word in a variable or in an allocated struct, array, or slice
can be relied upon to be 64-bit aligned.

You can use the structlayout tool to inspect the alignment of fields
in a struct.

Available since
    2019.2


Default: off. Enable by setting `"analyses": {"SA1027": true}`.

Package documentation: [SA1027](https://staticcheck.dev/docs/checks/#SA1027)

<a id='SA1028'></a>
## `SA1028`: sort.Slice can only be used on slices


The first argument of sort.Slice must be a slice.

Available since
    2020.1


Default: off. Enable by setting `"analyses": {"SA1028": true}`.

Package documentation: [SA1028](https://staticcheck.dev/docs/checks/#SA1028)

<a id='SA1029'></a>
## `SA1029`: Inappropriate key in call to context.WithValue


The provided key must be comparable and should not be
of type string or any other built-in type to avoid collisions between
packages using context. Users of WithValue should define their own
types for keys.

To avoid allocating when assigning to an interface{},
context keys often have concrete type struct{}. Alternatively,
exported context key variables' static type should be a pointer or
interface.

Available since
    2020.1


Default: off. Enable by setting `"analyses": {"SA1029": true}`.

Package documentation: [SA1029](https://staticcheck.dev/docs/checks/#SA1029)

<a id='SA1030'></a>
## `SA1030`: Invalid argument in call to a strconv function


This check validates the format, number base and bit size arguments of
the various parsing and formatting functions in strconv.

Available since
    2021.1


Default: off. Enable by setting `"analyses": {"SA1030": true}`.

Package documentation: [SA1030](https://staticcheck.dev/docs/checks/#SA1030)

<a id='SA1031'></a>
## `SA1031`: Overlapping byte slices passed to an encoder


In an encoding function of the form Encode(dst, src), dst and
src were found to reference the same memory. This can result in
src bytes being overwritten before they are read, when the encoder
writes more than one byte per src byte.

Available since
    2024.1


Default: off. Enable by setting `"analyses": {"SA1031": true}`.

Package documentation: [SA1031](https://staticcheck.dev/docs/checks/#SA1031)

<a id='SA1032'></a>
## `SA1032`: Wrong order of arguments to errors.Is


The first argument of the function errors.Is is the error
that we have and the second argument is the error we're trying to match against.
For example:

	if errors.Is(err, io.EOF) { ... }

This check detects some cases where the two arguments have been swapped. It
flags any calls where the first argument is referring to a package-level error
variable, such as

	if errors.Is(io.EOF, err) { /* this is wrong */ }

Available since
    2024.1


Default: off. Enable by setting `"analyses": {"SA1032": true}`.

Package documentation: [SA1032](https://staticcheck.dev/docs/checks/#SA1032)

<a id='SA2001'></a>
## `SA2001`: Empty critical section, did you mean to defer the unlock?


Empty critical sections of the kind

    mu.Lock()
    mu.Unlock()

are very often a typo, and the following was intended instead:

    mu.Lock()
    defer mu.Unlock()

Do note that sometimes empty critical sections can be useful, as a
form of signaling to wait on another goroutine. Many times, there are
simpler ways of achieving the same effect. When that isn't the case,
the code should be amply commented to avoid confusion. Combining such
comments with a //lint:ignore directive can be used to suppress this
rare false positive.

Available since
    2017.1


Default: on.

Package documentation: [SA2001](https://staticcheck.dev/docs/checks/#SA2001)

<a id='SA2002'></a>
## `SA2002`: Called testing.T.FailNow or SkipNow in a goroutine, which isn't allowed


Available since
    2017.1


Default: off. Enable by setting `"analyses": {"SA2002": true}`.

Package documentation: [SA2002](https://staticcheck.dev/docs/checks/#SA2002)

<a id='SA2003'></a>
## `SA2003`: Deferred Lock right after locking, likely meant to defer Unlock instead


Available since
    2017.1


Default: off. Enable by setting `"analyses": {"SA2003": true}`.

Package documentation: [SA2003](https://staticcheck.dev/docs/checks/#SA2003)

<a id='SA3000'></a>
## `SA3000`: TestMain doesn't call os.Exit, hiding test failures


Test executables (and in turn 'go test') exit with a non-zero status
code if any tests failed. When specifying your own TestMain function,
it is your responsibility to arrange for this, by calling os.Exit with
the correct code. The correct code is returned by (*testing.M).Run, so
the usual way of implementing TestMain is to end it with
os.Exit(m.Run()).

Available since
    2017.1


Default: on.

Package documentation: [SA3000](https://staticcheck.dev/docs/checks/#SA3000)

<a id='SA3001'></a>
## `SA3001`: Assigning to b.N in benchmarks distorts the results


The testing package dynamically sets b.N to improve the reliability of
benchmarks and uses it in computations to determine the duration of a
single operation. Benchmark code must not alter b.N as this would
falsify results.

Available since
    2017.1


Default: on.

Package documentation: [SA3001](https://staticcheck.dev/docs/checks/#SA3001)

<a id='SA4000'></a>
## `SA4000`: Binary operator has identical expressions on both sides


Available since
    2017.1


Default: on.

Package documentation: [SA4000](https://staticcheck.dev/docs/checks/#SA4000)

<a id='SA4001'></a>
## `SA4001`: &*x gets simplified to x, it does not copy x


Available since
    2017.1


Default: on.

Package documentation: [SA4001](https://staticcheck.dev/docs/checks/#SA4001)

<a id='SA4003'></a>
## `SA4003`: Comparing unsigned values against negative values is pointless


Available since
    2017.1


Default: on.

Package documentation: [SA4003](https://staticcheck.dev/docs/checks/#SA4003)

<a id='SA4004'></a>
## `SA4004`: The loop exits unconditionally after one iteration


Available since
    2017.1


Default: on.

Package documentation: [SA4004](https://staticcheck.dev/docs/checks/#SA4004)

<a id='SA4005'></a>
## `SA4005`: Field assignment that will never be observed. Did you mean to use a pointer receiver?


Available since
    2021.1


Default: off. Enable by setting `"analyses": {"SA4005": true}`.

Package documentation: [SA4005](https://staticcheck.dev/docs/checks/#SA4005)

<a id='SA4006'></a>
## `SA4006`: A value assigned to a variable is never read before being overwritten. Forgotten error check or dead code?


Available since
    2017.1


Default: off. Enable by setting `"analyses": {"SA4006": true}`.

Package documentation: [SA4006](https://staticcheck.dev/docs/checks/#SA4006)

<a id='SA4008'></a>
## `SA4008`: The variable in the loop condition never changes, are you incrementing the wrong variable?


For example:

	for i := 0; i < 10; j++ { ... }

This may also occur when a loop can only execute once because of unconditional
control flow that terminates the loop. For example, when a loop body contains an
unconditional break, return, or panic:

	func f() {
		panic("oops")
	}
	func g() {
		for i := 0; i < 10; i++ {
			// f unconditionally calls panic, which means "i" is
			// never incremented.
			f()
		}
	}

Available since
    2017.1


Default: off. Enable by setting `"analyses": {"SA4008": true}`.

Package documentation: [SA4008](https://staticcheck.dev/docs/checks/#SA4008)

<a id='SA4009'></a>
## `SA4009`: A function argument is overwritten before its first use


Available since
    2017.1


Default: off. Enable by setting `"analyses": {"SA4009": true}`.

Package documentation: [SA4009](https://staticcheck.dev/docs/checks/#SA4009)

<a id='SA4010'></a>
## `SA4010`: The result of append will never be observed anywhere


Available since
    2017.1


Default: off. Enable by setting `"analyses": {"SA4010": true}`.

Package documentation: [SA4010](https://staticcheck.dev/docs/checks/#SA4010)

<a id='SA4011'></a>
## `SA4011`: Break statement with no effect. Did you mean to break out of an outer loop?


Available since
    2017.1


Default: on.

Package documentation: [SA4011](https://staticcheck.dev/docs/checks/#SA4011)

<a id='SA4012'></a>
## `SA4012`: Comparing a value against NaN even though no value is equal to NaN


Available since
    2017.1


Default: off. Enable by setting `"analyses": {"SA4012": true}`.

Package documentation: [SA4012](https://staticcheck.dev/docs/checks/#SA4012)

<a id='SA4013'></a>
## `SA4013`: Negating a boolean twice (!!b) is the same as writing b. This is either redundant, or a typo.


Available since
    2017.1


Default: on.

Package documentation: [SA4013](https://staticcheck.dev/docs/checks/#SA4013)

<a id='SA4014'></a>
## `SA4014`: An if/else if chain has repeated conditions and no side-effects; if the condition didn't match the first time, it won't match the second time, either


Available since
    2017.1


Default: on.

Package documentation: [SA4014](https://staticcheck.dev/docs/checks/#SA4014)

<a id='SA4015'></a>
## `SA4015`: Calling functions like math.Ceil on floats converted from integers doesn't do anything useful


Available since
    2017.1


Default: off. Enable by setting `"analyses": {"SA4015": true}`.

Package documentation: [SA4015](https://staticcheck.dev/docs/checks/#SA4015)

<a id='SA4016'></a>
## `SA4016`: Certain bitwise operations, such as x ^ 0, do not do anything useful


Available since
    2017.1


Default: on.

Package documentation: [SA4016](https://staticcheck.dev/docs/checks/#SA4016)

<a id='SA4017'></a>
## `SA4017`: Discarding the return values of a function without side effects, making the call pointless


Available since
    2017.1


Default: off. Enable by setting `"analyses": {"SA4017": true}`.

Package documentation: [SA4017](https://staticcheck.dev/docs/checks/#SA4017)

<a id='SA4018'></a>
## `SA4018`: Self-assignment of variables


Available since
    2017.1


Default: off. Enable by setting `"analyses": {"SA4018": true}`.

Package documentation: [SA4018](https://staticcheck.dev/docs/checks/#SA4018)

<a id='SA4019'></a>
## `SA4019`: Multiple, identical build constraints in the same file


Available since
    2017.1


Default: on.

Package documentation: [SA4019](https://staticcheck.dev/docs/checks/#SA4019)

<a id='SA4020'></a>
## `SA4020`: Unreachable case clause in a type switch


In a type switch like the following

    type T struct{}
    func (T) Read(b []byte) (int, error) { return 0, nil }

    var v any = T{}

    switch v.(type) {
    case io.Reader:
        // ...
    case T:
        // unreachable
    }

the second case clause can never be reached because T implements
io.Reader and case clauses are evaluated in source order.

Another example:

    type T struct{}
    func (T) Read(b []byte) (int, error) { return 0, nil }
    func (T) Close() error { return nil }

    var v any = T{}

    switch v.(type) {
    case io.Reader:
        // ...
    case io.ReadCloser:
        // unreachable
    }

Even though T has a Close method and thus implements io.ReadCloser,
io.Reader will always match first. The method set of io.Reader is a
subset of io.ReadCloser. Thus it is impossible to match the second
case without matching the first case.


Structurally equivalent interfaces

A special case of the previous example are structurally identical
interfaces. Given these declarations

    type T error
    type V error

    func doSomething() error {
        err, ok := doAnotherThing()
        if ok {
            return T(err)
        }

        return U(err)
    }

the following type switch will have an unreachable case clause:

    switch doSomething().(type) {
    case T:
        // ...
    case V:
        // unreachable
    }

T will always match before V because they are structurally equivalent
and therefore doSomething()'s return value implements both.

Available since
    2019.2


Default: on.

Package documentation: [SA4020](https://staticcheck.dev/docs/checks/#SA4020)

<a id='SA4022'></a>
## `SA4022`: Comparing the address of a variable against nil


Code such as 'if &x == nil' is meaningless, because taking the address of a variable always yields a non-nil pointer.

Available since
    2020.1


Default: on.

Package documentation: [SA4022](https://staticcheck.dev/docs/checks/#SA4022)

<a id='SA4023'></a>
## `SA4023`: Impossible comparison of interface value with untyped nil


Under the covers, interfaces are implemented as two elements, a
type T and a value V. V is a concrete value such as an int,
struct or pointer, never an interface itself, and has type T. For
instance, if we store the int value 3 in an interface, the
resulting interface value has, schematically, (T=int, V=3). The
value V is also known as the interface's dynamic value, since a
given interface variable might hold different values V (and
corresponding types T) during the execution of the program.

An interface value is nil only if the V and T are both
unset, (T=nil, V is not set), In particular, a nil interface will
always hold a nil type. If we store a nil pointer of type *int
inside an interface value, the inner type will be *int regardless
of the value of the pointer: (T=*int, V=nil). Such an interface
value will therefore be non-nil even when the pointer value V
inside is nil.

This situation can be confusing, and arises when a nil value is
stored inside an interface value such as an error return:

    func returnsError() error {
        var p *MyError = nil
        if bad() {
            p = ErrBad
        }
        return p // Will always return a non-nil error.
    }

If all goes well, the function returns a nil p, so the return
value is an error interface value holding (T=*MyError, V=nil).
This means that if the caller compares the returned error to nil,
it will always look as if there was an error even if nothing bad
happened. To return a proper nil error to the caller, the
function must return an explicit nil:

    func returnsError() error {
        if bad() {
            return ErrBad
        }
        return nil
    }

It's a good idea for functions that return errors always to use
the error type in their signature (as we did above) rather than a
concrete type such as *MyError, to help guarantee the error is
created correctly. As an example, os.Open returns an error even
though, if not nil, it's always of concrete type *os.PathError.

Similar situations to those described here can arise whenever
interfaces are used. Just keep in mind that if any concrete value
has been stored in the interface, the interface will not be nil.
For more information, see The Laws of
Reflection at https://golang.org/doc/articles/laws_of_reflection.html.

This text has been copied from
https://golang.org/doc/faq#nil_error, licensed under the Creative
Commons Attribution 3.0 License.

Available since
    2020.2


Default: off. Enable by setting `"analyses": {"SA4023": true}`.

Package documentation: [SA4023](https://staticcheck.dev/docs/checks/#SA4023)

<a id='SA4024'></a>
## `SA4024`: Checking for impossible return value from a builtin function


Return values of the len and cap builtins cannot be negative.

See https://golang.org/pkg/builtin/#len and https://golang.org/pkg/builtin/#cap.

Example:

    if len(slice) < 0 {
        fmt.Println("unreachable code")
    }

Available since
    2021.1


Default: on.

Package documentation: [SA4024](https://staticcheck.dev/docs/checks/#SA4024)

<a id='SA4025'></a>
## `SA4025`: Integer division of literals that results in zero


When dividing two integer constants, the result will
also be an integer. Thus, a division such as 2 / 3 results in 0.
This is true for all of the following examples:

	_ = 2 / 3
	const _ = 2 / 3
	const _ float64 = 2 / 3
	_ = float64(2 / 3)

Staticcheck will flag such divisions if both sides of the division are
integer literals, as it is highly unlikely that the division was
intended to truncate to zero. Staticcheck will not flag integer
division involving named constants, to avoid noisy positives.

Available since
    2021.1


Default: on.

Package documentation: [SA4025](https://staticcheck.dev/docs/checks/#SA4025)

<a id='SA4026'></a>
## `SA4026`: Go constants cannot express negative zero


In IEEE 754 floating point math, zero has a sign and can be positive
or negative. This can be useful in certain numerical code.

Go constants, however, cannot express negative zero. This means that
the literals -0.0 and 0.0 have the same ideal value (zero) and
will both represent positive zero at runtime.

To explicitly and reliably create a negative zero, you can use the
math.Copysign function: math.Copysign(0, -1).

Available since
    2021.1


Default: on.

Package documentation: [SA4026](https://staticcheck.dev/docs/checks/#SA4026)

<a id='SA4027'></a>
## `SA4027`: (*net/url.URL).Query returns a copy, modifying it doesn't change the URL


(*net/url.URL).Query parses the current value of net/url.URL.RawQuery
and returns it as a map of type net/url.Values. Subsequent changes to
this map will not affect the URL unless the map gets encoded and
assigned to the URL's RawQuery.

As a consequence, the following code pattern is an expensive no-op:
u.Query().Add(key, value).

Available since
    2021.1


Default: on.

Package documentation: [SA4027](https://staticcheck.dev/docs/checks/#SA4027)

<a id='SA4028'></a>
## `SA4028`: x % 1 is always zero


Available since
    2022.1


Default: on.

Package documentation: [SA4028](https://staticcheck.dev/docs/checks/#SA4028)

<a id='SA4029'></a>
## `SA4029`: Ineffective attempt at sorting slice


sort.Float64Slice, sort.IntSlice, and sort.StringSlice are
types, not functions. Doing x = sort.StringSlice(x) does nothing,
especially not sort any values. The correct usage is
sort.Sort(sort.StringSlice(x)) or sort.StringSlice(x).Sort(),
but there are more convenient helpers, namely sort.Float64s,
sort.Ints, and sort.Strings.

Available since
    2022.1


Default: on.

Package documentation: [SA4029](https://staticcheck.dev/docs/checks/#SA4029)

<a id='SA4030'></a>
## `SA4030`: Ineffective attempt at generating random number


Functions in the math/rand package that accept upper limits, such
as Intn, generate random numbers in the half-open interval [0,n). In
other words, the generated numbers will be >= 0 and < n – they
don't include n. rand.Intn(1) therefore doesn't generate 0
or 1, it always generates 0.

Available since
    2022.1


Default: on.

Package documentation: [SA4030](https://staticcheck.dev/docs/checks/#SA4030)

<a id='SA4031'></a>
## `SA4031`: Checking never-nil value against nil


Available since
    2022.1


Default: off. Enable by setting `"analyses": {"SA4031": true}`.

Package documentation: [SA4031](https://staticcheck.dev/docs/checks/#SA4031)

<a id='SA4032'></a>
## `SA4032`: Comparing runtime.GOOS or runtime.GOARCH against impossible value


Available since
    2024.1


Default: on.

Package documentation: [SA4032](https://staticcheck.dev/docs/checks/#SA4032)

<a id='SA5000'></a>
## `SA5000`: Assignment to nil map


Available since
    2017.1


Default: off. Enable by setting `"analyses": {"SA5000": true}`.

Package documentation: [SA5000](https://staticcheck.dev/docs/checks/#SA5000)

<a id='SA5001'></a>
## `SA5001`: Deferring Close before checking for a possible error


Available since
    2017.1


Default: on.

Package documentation: [SA5001](https://staticcheck.dev/docs/checks/#SA5001)

<a id='SA5002'></a>
## `SA5002`: The empty for loop ('for {}') spins and can block the scheduler


Available since
    2017.1


Default: off. Enable by setting `"analyses": {"SA5002": true}`.

Package documentation: [SA5002](https://staticcheck.dev/docs/checks/#SA5002)

<a id='SA5003'></a>
## `SA5003`: Defers in infinite loops will never execute


Defers are scoped to the surrounding function, not the surrounding
block. In a function that never returns, i.e. one containing an
infinite loop, defers will never execute.

Available since
    2017.1


Default: on.

Package documentation: [SA5003](https://staticcheck.dev/docs/checks/#SA5003)

<a id='SA5004'></a>
## `SA5004`: 'for { select { ...' with an empty default branch spins


Available since
    2017.1


Default: on.

Package documentation: [SA5004](https://staticcheck.dev/docs/checks/#SA5004)

<a id='SA5005'></a>
## `SA5005`: The finalizer references the finalized object, preventing garbage collection


A finalizer is a function associated with an object that runs when the
garbage collector is ready to collect said object, that is when the
object is no longer referenced by anything.

If the finalizer references the object, however, it will always remain
as the final reference to that object, preventing the garbage
collector from collecting the object. The finalizer will never run,
and the object will never be collected, leading to a memory leak. That
is why the finalizer should instead use its first argument to operate
on the object. That way, the number of references can temporarily go
to zero before the object is being passed to the finalizer.

Available since
    2017.1


Default: off. Enable by setting `"analyses": {"SA5005": true}`.

Package documentation: [SA5005](https://staticcheck.dev/docs/checks/#SA5005)

<a id='SA5007'></a>
## `SA5007`: Infinite recursive call


A function that calls itself recursively needs to have an exit
condition. Otherwise it will recurse forever, until the system runs
out of memory.

This issue can be caused by simple bugs such as forgetting to add an
exit condition. It can also happen "on purpose". Some languages have
tail call optimization which makes certain infinite recursive calls
safe to use. Go, however, does not implement TCO, and as such a loop
should be used instead.

Available since
    2017.1


Default: off. Enable by setting `"analyses": {"SA5007": true}`.

Package documentation: [SA5007](https://staticcheck.dev/docs/checks/#SA5007)

<a id='SA5008'></a>
## `SA5008`: Invalid struct tag


Available since
    2019.2


Default: on.

Package documentation: [SA5008](https://staticcheck.dev/docs/checks/#SA5008)

<a id='SA5010'></a>
## `SA5010`: Impossible type assertion


Some type assertions can be statically proven to be
impossible. This is the case when the method sets of both
arguments of the type assertion conflict with each other, for
example by containing the same method with different
signatures.

The Go compiler already applies this check when asserting from an
interface value to a concrete type. If the concrete type misses
methods from the interface, or if function signatures don't match,
then the type assertion can never succeed.

This check applies the same logic when asserting from one interface to
another. If both interface types contain the same method but with
different signatures, then the type assertion can never succeed,
either.

Available since
    2020.1


Default: off. Enable by setting `"analyses": {"SA5010": true}`.

Package documentation: [SA5010](https://staticcheck.dev/docs/checks/#SA5010)

<a id='SA5011'></a>
## `SA5011`: Possible nil pointer dereference


A pointer is being dereferenced unconditionally, while
also being checked against nil in another place. This suggests that
the pointer may be nil and dereferencing it may panic. This is
commonly a result of improperly ordered code or missing return
statements. Consider the following examples:

    func fn(x *int) {
        fmt.Println(*x)

        // This nil check is equally important for the previous dereference
        if x != nil {
            foo(*x)
        }
    }

    func TestFoo(t *testing.T) {
        x := compute()
        if x == nil {
            t.Errorf("nil pointer received")
        }

        // t.Errorf does not abort the test, so if x is nil, the next line will panic.
        foo(*x)
    }

Staticcheck tries to deduce which functions abort control flow.
For example, it is aware that a function will not continue
execution after a call to panic or log.Fatal. However, sometimes
this detection fails, in particular in the presence of
conditionals. Consider the following example:

    func Log(msg string, level int) {
        fmt.Println(msg)
        if level == levelFatal {
            os.Exit(1)
        }
    }

    func Fatal(msg string) {
        Log(msg, levelFatal)
    }

    func fn(x *int) {
        if x == nil {
            Fatal("unexpected nil pointer")
        }
        fmt.Println(*x)
    }

Staticcheck will flag the dereference of x, even though it is perfectly
safe. Staticcheck is not able to deduce that a call to
Fatal will exit the program. For the time being, the easiest
workaround is to modify the definition of Fatal like so:

    func Fatal(msg string) {
        Log(msg, levelFatal)
        panic("unreachable")
    }

We also hard-code functions from common logging packages such as
logrus. Please file an issue if we're missing support for a
popular package.

Available since
    2020.1


Default: off. Enable by setting `"analyses": {"SA5011": true}`.

Package documentation: [SA5011](https://staticcheck.dev/docs/checks/#SA5011)

<a id='SA5012'></a>
## `SA5012`: Passing odd-sized slice to function expecting even size


Some functions that take slices as parameters expect the slices to have an even number of elements. 
Often, these functions treat elements in a slice as pairs. 
For example, strings.NewReplacer takes pairs of old and new strings, 
and calling it with an odd number of elements would be an error.

Available since
    2020.2


Default: off. Enable by setting `"analyses": {"SA5012": true}`.

Package documentation: [SA5012](https://staticcheck.dev/docs/checks/#SA5012)

<a id='SA6000'></a>
## `SA6000`: Using regexp.Match or related in a loop, should use regexp.Compile


Available since
    2017.1


Default: off. Enable by setting `"analyses": {"SA6000": true}`.

Package documentation: [SA6000](https://staticcheck.dev/docs/checks/#SA6000)

<a id='SA6001'></a>
## `SA6001`: Missing an optimization opportunity when indexing maps by byte slices


Map keys must be comparable, which precludes the use of byte slices.
This usually leads to using string keys and converting byte slices to
strings.

Normally, a conversion of a byte slice to a string needs to copy the data and
causes allocations. The compiler, however, recognizes m[string(b)] and
uses the data of b directly, without copying it, because it knows that
the data can't change during the map lookup. This leads to the
counter-intuitive situation that

    k := string(b)
    println(m[k])
    println(m[k])

will be less efficient than

    println(m[string(b)])
    println(m[string(b)])

because the first version needs to copy and allocate, while the second
one does not.

For some history on this optimization, check out commit
f5f5a8b6209f84961687d993b93ea0d397f5d5bf in the Go repository.

Available since
    2017.1


Default: off. Enable by setting `"analyses": {"SA6001": true}`.

Package documentation: [SA6001](https://staticcheck.dev/docs/checks/#SA6001)

<a id='SA6002'></a>
## `SA6002`: Storing non-pointer values in sync.Pool allocates memory


A sync.Pool is used to avoid unnecessary allocations and reduce the
amount of work the garbage collector has to do.

When passing a value that is not a pointer to a function that accepts
an interface, the value needs to be placed on the heap, which means an
additional allocation. Slices are a common thing to put in sync.Pools,
and they're structs with 3 fields (length, capacity, and a pointer to
an array). In order to avoid the extra allocation, one should store a
pointer to the slice instead.

See the comments on https://go-review.googlesource.com/c/go/+/24371
that discuss this problem.

Available since
    2017.1


Default: off. Enable by setting `"analyses": {"SA6002": true}`.

Package documentation: [SA6002](https://staticcheck.dev/docs/checks/#SA6002)

<a id='SA6003'></a>
## `SA6003`: Converting a string to a slice of runes before ranging over it


You may want to loop over the runes in a string. Instead of converting
the string to a slice of runes and looping over that, you can loop
over the string itself. That is,

    for _, r := range s {}

and

    for _, r := range []rune(s) {}

will yield the same values. The first version, however, will be faster
and avoid unnecessary memory allocations.

Do note that if you are interested in the indices, ranging over a
string and over a slice of runes will yield different indices. The
first one yields byte offsets, while the second one yields indices in
the slice of runes.

Available since
    2017.1


Default: off. Enable by setting `"analyses": {"SA6003": true}`.

Package documentation: [SA6003](https://staticcheck.dev/docs/checks/#SA6003)

<a id='SA6005'></a>
## `SA6005`: Inefficient string comparison with strings.ToLower or strings.ToUpper


Converting two strings to the same case and comparing them like so

    if strings.ToLower(s1) == strings.ToLower(s2) {
        ...
    }

is significantly more expensive than comparing them with
strings.EqualFold(s1, s2). This is due to memory usage as well as
computational complexity.

strings.ToLower will have to allocate memory for the new strings, as
well as convert both strings fully, even if they differ on the very
first byte. strings.EqualFold, on the other hand, compares the strings
one character at a time. It doesn't need to create two intermediate
strings and can return as soon as the first non-matching character has
been found.

For a more in-depth explanation of this issue, see
https://blog.digitalocean.com/how-to-efficiently-compare-strings-in-go/

Available since
    2019.2


Default: on.

Package documentation: [SA6005](https://staticcheck.dev/docs/checks/#SA6005)

<a id='SA6006'></a>
## `SA6006`: Using io.WriteString to write []byte


Using io.WriteString to write a slice of bytes, as in

    io.WriteString(w, string(b))

is both unnecessary and inefficient. Converting from []byte to string
has to allocate and copy the data, and we could simply use w.Write(b)
instead.

Available since
    2024.1


Default: on.

Package documentation: [SA6006](https://staticcheck.dev/docs/checks/#SA6006)

<a id='SA9001'></a>
## `SA9001`: Defers in range loops may not run when you expect them to


Available since
    2017.1


Default: off. Enable by setting `"analyses": {"SA9001": true}`.

Package documentation: [SA9001](https://staticcheck.dev/docs/checks/#SA9001)

<a id='SA9002'></a>
## `SA9002`: Using a non-octal os.FileMode that looks like it was meant to be in octal.


Available since
    2017.1


Default: on.

Package documentation: [SA9002](https://staticcheck.dev/docs/checks/#SA9002)

<a id='SA9003'></a>
## `SA9003`: Empty body in an if or else branch


Available since
    2017.1, non-default


Default: off. Enable by setting `"analyses": {"SA9003": true}`.

Package documentation: [SA9003](https://staticcheck.dev/docs/checks/#SA9003)

<a id='SA9004'></a>
## `SA9004`: Only the first constant has an explicit type


In a constant declaration such as the following:

    const (
        First byte = 1
        Second     = 2
    )

the constant Second does not have the same type as the constant First.
This construct shouldn't be confused with

    const (
        First byte = iota
        Second
    )

where First and Second do indeed have the same type. The type is only
passed on when no explicit value is assigned to the constant.

When declaring enumerations with explicit values it is therefore
important not to write

    const (
          EnumFirst EnumType = 1
          EnumSecond         = 2
          EnumThird          = 3
    )

This discrepancy in types can cause various confusing behaviors and
bugs.


Wrong type in variable declarations

The most obvious issue with such incorrect enumerations expresses
itself as a compile error:

    package pkg

    const (
        EnumFirst  uint8 = 1
        EnumSecond       = 2
    )

    func fn(useFirst bool) {
        x := EnumSecond
        if useFirst {
            x = EnumFirst
        }
    }

fails to compile with

    ./const.go:11:5: cannot use EnumFirst (type uint8) as type int in assignment


Losing method sets

A more subtle issue occurs with types that have methods and optional
interfaces. Consider the following:

    package main

    import "fmt"

    type Enum int

    func (e Enum) String() string {
        return "an enum"
    }

    const (
        EnumFirst  Enum = 1
        EnumSecond      = 2
    )

    func main() {
        fmt.Println(EnumFirst)
        fmt.Println(EnumSecond)
    }

This code will output

    an enum
    2

as EnumSecond has no explicit type, and thus defaults to int.

Available since
    2019.1


Default: on.

Package documentation: [SA9004](https://staticcheck.dev/docs/checks/#SA9004)

<a id='SA9005'></a>
## `SA9005`: Trying to marshal a struct with no public fields nor custom marshaling


The encoding/json and encoding/xml packages only operate on exported
fields in structs, not unexported ones. It is usually an error to try
to (un)marshal structs that only consist of unexported fields.

This check will not flag calls involving types that define custom
marshaling behavior, e.g. via MarshalJSON methods. It will also not
flag empty structs.

Available since
    2019.2


Default: off. Enable by setting `"analyses": {"SA9005": true}`.

Package documentation: [SA9005](https://staticcheck.dev/docs/checks/#SA9005)

<a id='SA9006'></a>
## `SA9006`: Dubious bit shifting of a fixed size integer value


Bit shifting a value past its size will always clear the value.

For instance:

    v := int8(42)
    v >>= 8

will always result in 0.

This check flags bit shifting operations on fixed size integer values only.
That is, int, uint and uintptr are never flagged to avoid potential false
positives in somewhat exotic but valid bit twiddling tricks:

    // Clear any value above 32 bits if integers are more than 32 bits.
    func f(i int) int {
        v := i >> 32
        v = v << 32
        return i-v
    }

Available since
    2020.2


Default: on.

Package documentation: [SA9006](https://staticcheck.dev/docs/checks/#SA9006)

<a id='SA9007'></a>
## `SA9007`: Deleting a directory that shouldn't be deleted


It is virtually never correct to delete system directories such as
/tmp or the user's home directory. However, it can be fairly easy to
do by mistake, for example by mistakenly using os.TempDir instead
of ioutil.TempDir, or by forgetting to add a suffix to the result
of os.UserHomeDir.

Writing

    d := os.TempDir()
    defer os.RemoveAll(d)

in your unit tests will have a devastating effect on the stability of your system.

This check flags attempts at deleting the following directories:

- os.TempDir
- os.UserCacheDir
- os.UserConfigDir
- os.UserHomeDir

Available since
    2022.1


Default: off. Enable by setting `"analyses": {"SA9007": true}`.

Package documentation: [SA9007](https://staticcheck.dev/docs/checks/#SA9007)

<a id='SA9008'></a>
## `SA9008`: else branch of a type assertion is probably not reading the right value


When declaring variables as part of an if statement (like in 'if
foo := ...; foo {'), the same variables will also be in the scope of
the else branch. This means that in the following example

    if x, ok := x.(int); ok {
        // ...
    } else {
        fmt.Printf("unexpected type %T", x)
    }

x in the else branch will refer to the x from x, ok
:=; it will not refer to the x that is being type-asserted. The
result of a failed type assertion is the zero value of the type that
is being asserted to, so x in the else branch will always have the
value 0 and the type int.

Available since
    2022.1


Default: off. Enable by setting `"analyses": {"SA9008": true}`.

Package documentation: [SA9008](https://staticcheck.dev/docs/checks/#SA9008)

<a id='SA9009'></a>
## `SA9009`: Ineffectual Go compiler directive


A potential Go compiler directive was found, but is ineffectual as it begins
with whitespace.

Available since
    2024.1


Default: on.

Package documentation: [SA9009](https://staticcheck.dev/docs/checks/#SA9009)

<a id='ST1000'></a>
## `ST1000`: Incorrect or missing package comment


Packages must have a package comment that is formatted according to
the guidelines laid out in
https://go.dev/wiki/CodeReviewComments#package-comments.

Available since
    2019.1, non-default


Default: off. Enable by setting `"analyses": {"ST1000": true}`.

Package documentation: [ST1000](https://staticcheck.dev/docs/checks/#ST1000)

<a id='ST1001'></a>
## `ST1001`: Dot imports are discouraged


Dot imports that aren't in external test packages are discouraged.

The dot_import_whitelist option can be used to whitelist certain
imports.

Quoting Go Code Review Comments:

> The import . form can be useful in tests that, due to circular
> dependencies, cannot be made part of the package being tested:
> 
>     package foo_test
> 
>     import (
>         "bar/testutil" // also imports "foo"
>         . "foo"
>     )
> 
> In this case, the test file cannot be in package foo because it
> uses bar/testutil, which imports foo. So we use the import .
> form to let the file pretend to be part of package foo even though
> it is not. Except for this one case, do not use import . in your
> programs. It makes the programs much harder to read because it is
> unclear whether a name like Quux is a top-level identifier in the
> current package or in an imported package.

Available since
    2019.1

Options
    dot_import_whitelist


Default: off. Enable by setting `"analyses": {"ST1001": true}`.

Package documentation: [ST1001](https://staticcheck.dev/docs/checks/#ST1001)

<a id='ST1003'></a>
## `ST1003`: Poorly chosen identifier


Identifiers, such as variable and package names, follow certain rules.

See the following links for details:

- https://go.dev/doc/effective_go#package-names
- https://go.dev/doc/effective_go#mixed-caps
- https://go.dev/wiki/CodeReviewComments#initialisms
- https://go.dev/wiki/CodeReviewComments#variable-names

Available since
    2019.1, non-default

Options
    initialisms


Default: off. Enable by setting `"analyses": {"ST1003": true}`.

Package documentation: [ST1003](https://staticcheck.dev/docs/checks/#ST1003)

<a id='ST1005'></a>
## `ST1005`: Incorrectly formatted error string


Error strings follow a set of guidelines to ensure uniformity and good
composability.

Quoting Go Code Review Comments:

> Error strings should not be capitalized (unless beginning with
> proper nouns or acronyms) or end with punctuation, since they are
> usually printed following other context. That is, use
> fmt.Errorf("something bad") not fmt.Errorf("Something bad"), so
> that log.Printf("Reading %s: %v", filename, err) formats without a
> spurious capital letter mid-message.

Available since
    2019.1


Default: off. Enable by setting `"analyses": {"ST1005": true}`.

Package documentation: [ST1005](https://staticcheck.dev/docs/checks/#ST1005)

<a id='ST1006'></a>
## `ST1006`: Poorly chosen receiver name


Quoting Go Code Review Comments:

> The name of a method's receiver should be a reflection of its
> identity; often a one or two letter abbreviation of its type
> suffices (such as "c" or "cl" for "Client"). Don't use generic
> names such as "me", "this" or "self", identifiers typical of
> object-oriented languages that place more emphasis on methods as
> opposed to functions. The name need not be as descriptive as that
> of a method argument, as its role is obvious and serves no
> documentary purpose. It can be very short as it will appear on
> almost every line of every method of the type; familiarity admits
> brevity. Be consistent, too: if you call the receiver "c" in one
> method, don't call it "cl" in another.

Available since
    2019.1


Default: off. Enable by setting `"analyses": {"ST1006": true}`.

Package documentation: [ST1006](https://staticcheck.dev/docs/checks/#ST1006)

<a id='ST1008'></a>
## `ST1008`: A function's error value should be its last return value


A function's error value should be its last return value.

Available since
    2019.1


Default: off. Enable by setting `"analyses": {"ST1008": true}`.

Package documentation: [ST1008](https://staticcheck.dev/docs/checks/#ST1008)

<a id='ST1011'></a>
## `ST1011`: Poorly chosen name for variable of type time.Duration


time.Duration values represent an amount of time, which is represented
as a count of nanoseconds. An expression like 5 * time.Microsecond
yields the value 5000. It is therefore not appropriate to suffix a
variable of type time.Duration with any time unit, such as Msec or
Milli.

Available since
    2019.1


Default: off. Enable by setting `"analyses": {"ST1011": true}`.

Package documentation: [ST1011](https://staticcheck.dev/docs/checks/#ST1011)

<a id='ST1012'></a>
## `ST1012`: Poorly chosen name for error variable


Error variables that are part of an API should be called errFoo or
ErrFoo.

Available since
    2019.1


Default: off. Enable by setting `"analyses": {"ST1012": true}`.

Package documentation: [ST1012](https://staticcheck.dev/docs/checks/#ST1012)

<a id='ST1013'></a>
## `ST1013`: Should use constants for HTTP error codes, not magic numbers


HTTP has a tremendous number of status codes. While some of those are
well known (200, 400, 404, 500), most of them are not. The net/http
package provides constants for all status codes that are part of the
various specifications. It is recommended to use these constants
instead of hard-coding magic numbers, to vastly improve the
readability of your code.

Available since
    2019.1

Options
    http_status_code_whitelist


Default: off. Enable by setting `"analyses": {"ST1013": true}`.

Package documentation: [ST1013](https://staticcheck.dev/docs/checks/#ST1013)

<a id='ST1015'></a>
## `ST1015`: A switch's default case should be the first or last case


Available since
    2019.1


Default: off. Enable by setting `"analyses": {"ST1015": true}`.

Package documentation: [ST1015](https://staticcheck.dev/docs/checks/#ST1015)

<a id='ST1016'></a>
## `ST1016`: Use consistent method receiver names


Available since
    2019.1, non-default


Default: off. Enable by setting `"analyses": {"ST1016": true}`.

Package documentation: [ST1016](https://staticcheck.dev/docs/checks/#ST1016)

<a id='ST1017'></a>
## `ST1017`: Don't use Yoda conditions


Yoda conditions are conditions of the kind 'if 42 == x', where the
literal is on the left side of the comparison. These are a common
idiom in languages in which assignment is an expression, to avoid bugs
of the kind 'if (x = 42)'. In Go, which doesn't allow for this kind of
bug, we prefer the more idiomatic 'if x == 42'.

Available since
    2019.2


Default: off. Enable by setting `"analyses": {"ST1017": true}`.

Package documentation: [ST1017](https://staticcheck.dev/docs/checks/#ST1017)

<a id='ST1018'></a>
## `ST1018`: Avoid zero-width and control characters in string literals


Available since
    2019.2


Default: off. Enable by setting `"analyses": {"ST1018": true}`.

Package documentation: [ST1018](https://staticcheck.dev/docs/checks/#ST1018)

<a id='ST1019'></a>
## `ST1019`: Importing the same package multiple times


Go allows importing the same package multiple times, as long as
different import aliases are being used. That is, the following
bit of code is valid:

    import (
        "fmt"
        fumpt "fmt"
        format "fmt"
        _ "fmt"
    )

However, this is very rarely done on purpose. Usually, it is a
sign of code that got refactored, accidentally adding duplicate
import statements. It is also a rarely known feature, which may
contribute to confusion.

Do note that sometimes, this feature may be used
intentionally (see for example
https://github.com/golang/go/commit/3409ce39bfd7584523b7a8c150a310cea92d879d)
– if you want to allow this pattern in your code base, you're
advised to disable this check.

Available since
    2020.1


Default: off. Enable by setting `"analyses": {"ST1019": true}`.

Package documentation: [ST1019](https://staticcheck.dev/docs/checks/#ST1019)

<a id='ST1020'></a>
## `ST1020`: The documentation of an exported function should start with the function's name


Doc comments work best as complete sentences, which
allow a wide variety of automated presentations. The first sentence
should be a one-sentence summary that starts with the name being
declared.

If every doc comment begins with the name of the item it describes,
you can use the doc subcommand of the go tool and run the output
through grep.

See https://go.dev/doc/effective_go#commentary for more
information on how to write good documentation.

Available since
    2020.1, non-default


Default: off. Enable by setting `"analyses": {"ST1020": true}`.

Package documentation: [ST1020](https://staticcheck.dev/docs/checks/#ST1020)

<a id='ST1021'></a>
## `ST1021`: The documentation of an exported type should start with type's name


Doc comments work best as complete sentences, which
allow a wide variety of automated presentations. The first sentence
should be a one-sentence summary that starts with the name being
declared.

If every doc comment begins with the name of the item it describes,
you can use the doc subcommand of the go tool and run the output
through grep.

See https://go.dev/doc/effective_go#commentary for more
information on how to write good documentation.

Available since
    2020.1, non-default


Default: off. Enable by setting `"analyses": {"ST1021": true}`.

Package documentation: [ST1021](https://staticcheck.dev/docs/checks/#ST1021)

<a id='ST1022'></a>
## `ST1022`: The documentation of an exported variable or constant should start with variable's name


Doc comments work best as complete sentences, which
allow a wide variety of automated presentations. The first sentence
should be a one-sentence summary that starts with the name being
declared.

If every doc comment begins with the name of the item it describes,
you can use the doc subcommand of the go tool and run the output
through grep.

See https://go.dev/doc/effective_go#commentary for more
information on how to write good documentation.

Available since
    2020.1, non-default


Default: off. Enable by setting `"analyses": {"ST1022": true}`.

Package documentation: [ST1022](https://staticcheck.dev/docs/checks/#ST1022)

<a id='ST1023'></a>
## `ST1023`: Redundant type in variable declaration


Available since
    2021.1, non-default


Default: off. Enable by setting `"analyses": {"ST1023": true}`.

Package documentation: [ST1023](https://staticcheck.dev/docs/checks/#)

<a id='appends'></a>
## `appends`: check for missing values after append


This checker reports calls to append that pass
no values to be appended to the slice.

	s := []string{"a", "b", "c"}
	_ = append(s)

Such calls are always no-ops and often indicate an
underlying mistake.

Default: on.

Package documentation: [appends](https://pkg.go.dev/golang.org/x/tools/go/analysis/passes/appends)

<a id='asmdecl'></a>
## `asmdecl`: report mismatches between assembly files and Go declarations



Default: on.

Package documentation: [asmdecl](https://pkg.go.dev/golang.org/x/tools/go/analysis/passes/asmdecl)

<a id='assign'></a>
## `assign`: check for useless assignments


This checker reports assignments of the form x = x or a[i] = a[i].
These are almost always useless, and even when they aren't they are
usually a mistake.

Default: on.

Package documentation: [assign](https://pkg.go.dev/golang.org/x/tools/go/analysis/passes/assign)

<a id='atomic'></a>
## `atomic`: check for common mistakes using the sync/atomic package


The atomic checker looks for assignment statements of the form:

	x = atomic.AddUint64(&x, 1)

which are not atomic.

Default: on.

Package documentation: [atomic](https://pkg.go.dev/golang.org/x/tools/go/analysis/passes/atomic)

<a id='atomicalign'></a>
## `atomicalign`: check for non-64-bits-aligned arguments to sync/atomic functions



Default: on.

Package documentation: [atomicalign](https://pkg.go.dev/golang.org/x/tools/go/analysis/passes/atomicalign)

<a id='bools'></a>
## `bools`: check for common mistakes involving boolean operators



Default: on.

Package documentation: [bools](https://pkg.go.dev/golang.org/x/tools/go/analysis/passes/bools)

<a id='buildtag'></a>
## `buildtag`: check //go:build and // +build directives



Default: on.

Package documentation: [buildtag](https://pkg.go.dev/golang.org/x/tools/go/analysis/passes/buildtag)

<a id='cgocall'></a>
## `cgocall`: detect some violations of the cgo pointer passing rules


Check for invalid cgo pointer passing.
This looks for code that uses cgo to call C code passing values
whose types are almost always invalid according to the cgo pointer
sharing rules.
Specifically, it warns about attempts to pass a Go chan, map, func,
or slice to C, either directly, or via a pointer, array, or struct.

Default: on.

Package documentation: [cgocall](https://pkg.go.dev/golang.org/x/tools/go/analysis/passes/cgocall)

<a id='composites'></a>
## `composites`: check for unkeyed composite literals


This analyzer reports a diagnostic for composite literals of struct
types imported from another package that do not use the field-keyed
syntax. Such literals are fragile because the addition of a new field
(even if unexported) to the struct will cause compilation to fail.

As an example,

	err = &net.DNSConfigError{err}

should be replaced by:

	err = &net.DNSConfigError{Err: err}


Default: on.

Package documentation: [composites](https://pkg.go.dev/golang.org/x/tools/go/analysis/passes/composite)

<a id='copylocks'></a>
## `copylocks`: check for locks erroneously passed by value


Inadvertently copying a value containing a lock, such as sync.Mutex or
sync.WaitGroup, may cause both copies to malfunction. Generally such
values should be referred to through a pointer.

Default: on.

Package documentation: [copylocks](https://pkg.go.dev/golang.org/x/tools/go/analysis/passes/copylock)

<a id='deepequalerrors'></a>
## `deepequalerrors`: check for calls of reflect.DeepEqual on error values


The deepequalerrors checker looks for calls of the form:

    reflect.DeepEqual(err1, err2)

where err1 and err2 are errors. Using reflect.DeepEqual to compare
errors is discouraged.

Default: on.

Package documentation: [deepequalerrors](https://pkg.go.dev/golang.org/x/tools/go/analysis/passes/deepequalerrors)

<a id='defers'></a>
## `defers`: report common mistakes in defer statements


The defers analyzer reports a diagnostic when a defer statement would
result in a non-deferred call to time.Since, as experience has shown
that this is nearly always a mistake.

For example:

	start := time.Now()
	...
	defer recordLatency(time.Since(start)) // error: call to time.Since is not deferred

The correct code is:

	defer func() { recordLatency(time.Since(start)) }()

Default: on.

Package documentation: [defers](https://pkg.go.dev/golang.org/x/tools/go/analysis/passes/defers)

<a id='deprecated'></a>
## `deprecated`: check for use of deprecated identifiers


The deprecated analyzer looks for deprecated symbols and package
imports.

See https://go.dev/wiki/Deprecated to learn about Go's convention
for documenting and signaling deprecated identifiers.

Default: on.

Package documentation: [deprecated](https://pkg.go.dev/golang.org/x/tools/gopls/internal/analysis/deprecated)

<a id='directive'></a>
## `directive`: check Go toolchain directives such as //go:debug


This analyzer checks for problems with known Go toolchain directives
in all Go source files in a package directory, even those excluded by
//go:build constraints, and all non-Go source files too.

For //go:debug (see https://go.dev/doc/godebug), the analyzer checks
that the directives are placed only in Go source files, only above the
package comment, and only in package main or *_test.go files.

Support for other known directives may be added in the future.

This analyzer does not check //go:build, which is handled by the
buildtag analyzer.


Default: on.

Package documentation: [directive](https://pkg.go.dev/golang.org/x/tools/go/analysis/passes/directive)

<a id='embed'></a>
## `embed`: check //go:embed directive usage


This analyzer checks that the embed package is imported if //go:embed
directives are present, providing a suggested fix to add the import if
it is missing.

This analyzer also checks that //go:embed directives precede the
declaration of a single variable.

Default: on.

Package documentation: [embed](https://pkg.go.dev/golang.org/x/tools/gopls/internal/analysis/embeddirective)

<a id='errorsas'></a>
## `errorsas`: report passing non-pointer or non-error values to errors.As


The errorsas analysis reports calls to errors.As where the type
of the second argument is not a pointer to a type implementing error.

Default: on.

Package documentation: [errorsas](https://pkg.go.dev/golang.org/x/tools/go/analysis/passes/errorsas)

<a id='fillreturns'></a>
## `fillreturns`: suggest fixes for errors due to an incorrect number of return values


This checker provides suggested fixes for type errors of the
type "wrong number of return values (want %d, got %d)". For example:

	func m() (int, string, *bool, error) {
		return
	}

will turn into

	func m() (int, string, *bool, error) {
		return 0, "", nil, nil
	}

This functionality is similar to https://github.com/sqs/goreturns.

Default: on.

Package documentation: [fillreturns](https://pkg.go.dev/golang.org/x/tools/gopls/internal/analysis/fillreturns)

<a id='framepointer'></a>
## `framepointer`: report assembly that clobbers the frame pointer before saving it



Default: on.

Package documentation: [framepointer](https://pkg.go.dev/golang.org/x/tools/go/analysis/passes/framepointer)

<a id='gofix'></a>
## `gofix`: apply fixes based on go:fix comment directives


The gofix analyzer inlines functions and constants that are marked for inlining.

## Functions

Given a function that is marked for inlining, like this one:

	//go:fix inline
	func Square(x int) int { return Pow(x, 2) }

this analyzer will recommend that calls to the function elsewhere, in the same
or other packages, should be inlined.

Inlining can be used to move off of a deprecated function:

	// Deprecated: prefer Pow(x, 2).
	//go:fix inline
	func Square(x int) int { return Pow(x, 2) }

It can also be used to move off of an obsolete package,
as when the import path has changed or a higher major version is available:

	package pkg

	import pkg2 "pkg/v2"

	//go:fix inline
	func F() { pkg2.F(nil) }

Replacing a call pkg.F() by pkg2.F(nil) can have no effect on the program,
so this mechanism provides a low-risk way to update large numbers of calls.
We recommend, where possible, expressing the old API in terms of the new one
to enable automatic migration.

The inliner takes care to avoid behavior changes, even subtle ones,
such as changes to the order in which argument expressions are
evaluated. When it cannot safely eliminate all parameter variables,
it may introduce a "binding declaration" of the form

	var params = args

to evaluate argument expressions in the correct order and bind them to
parameter variables. Since the resulting code transformation may be
stylistically suboptimal, such inlinings may be disabled by specifying
the -gofix.allow_binding_decl=false flag to the analyzer driver.

(In cases where it is not safe to "reduce" a call—that is, to replace
a call f(x) by the body of function f, suitably substituted—the
inliner machinery is capable of replacing f by a function literal,
func(){...}(). However, the gofix analyzer discards all such
"literalizations" unconditionally, again on grounds of style.)

## Constants

Given a constant that is marked for inlining, like this one:

	//go:fix inline
	const Ptr = Pointer

this analyzer will recommend that uses of Ptr should be replaced with Pointer.

As with functions, inlining can be used to replace deprecated constants and
constants in obsolete packages.

A constant definition can be marked for inlining only if it refers to another
named constant.

The "//go:fix inline" comment must appear before a single const declaration on its own,
as above; before a const declaration that is part of a group, as in this case:

	const (
	   C = 1
	   //go:fix inline
	   Ptr = Pointer
	)

or before a group, applying to every constant in the group:

	//go:fix inline
	const (
		Ptr = Pointer
	    Val = Value
	)

The proposal https://go.dev/issue/32816 introduces the "//go:fix" directives.

You can use this (officially unsupported) command to apply gofix fixes en masse:

	$ go run golang.org/x/tools/internal/gofix/cmd/gofix@latest -test ./...

(Do not use "go get -tool" to add gopls as a dependency of your
module; gopls commands must be built from their release branch.)

Default: on.

Package documentation: [gofix](https://pkg.go.dev/golang.org/x/tools/internal/gofix)

<a id='hostport'></a>
## `hostport`: check format of addresses passed to net.Dial


This analyzer flags code that produce network address strings using
fmt.Sprintf, as in this example:

    addr := fmt.Sprintf("%s:%d", host, 12345) // "will not work with IPv6"
    ...
    conn, err := net.Dial("tcp", addr)       // "when passed to dial here"

The analyzer suggests a fix to use the correct approach, a call to
net.JoinHostPort:

    addr := net.JoinHostPort(host, "12345")
    ...
    conn, err := net.Dial("tcp", addr)

A similar diagnostic and fix are produced for a format string of "%s:%s".


Default: on.

Package documentation: [hostport](https://pkg.go.dev/golang.org/x/tools/go/analysis/passes/hostport)

<a id='httpresponse'></a>
## `httpresponse`: check for mistakes using HTTP responses


A common mistake when using the net/http package is to defer a function
call to close the http.Response Body before checking the error that
determines whether the response is valid:

	resp, err := http.Head(url)
	defer resp.Body.Close()
	if err != nil {
		log.Fatal(err)
	}
	// (defer statement belongs here)

This checker helps uncover latent nil dereference bugs by reporting a
diagnostic for such mistakes.

Default: on.

Package documentation: [httpresponse](https://pkg.go.dev/golang.org/x/tools/go/analysis/passes/httpresponse)

<a id='ifaceassert'></a>
## `ifaceassert`: detect impossible interface-to-interface type assertions


This checker flags type assertions v.(T) and corresponding type-switch cases
in which the static type V of v is an interface that cannot possibly implement
the target interface T. This occurs when V and T contain methods with the same
name but different signatures. Example:

	var v interface {
		Read()
	}
	_ = v.(io.Reader)

The Read method in v has a different signature than the Read method in
io.Reader, so this assertion cannot succeed.

Default: on.

Package documentation: [ifaceassert](https://pkg.go.dev/golang.org/x/tools/go/analysis/passes/ifaceassert)

<a id='infertypeargs'></a>
## `infertypeargs`: check for unnecessary type arguments in call expressions


Explicit type arguments may be omitted from call expressions if they can be
inferred from function arguments, or from other type arguments:

	func f[T any](T) {}
	
	func _() {
		f[string]("foo") // string could be inferred
	}


Default: on.

Package documentation: [infertypeargs](https://pkg.go.dev/golang.org/x/tools/gopls/internal/analysis/infertypeargs)

<a id='loopclosure'></a>
## `loopclosure`: check references to loop variables from within nested functions


This analyzer reports places where a function literal references the
iteration variable of an enclosing loop, and the loop calls the function
in such a way (e.g. with go or defer) that it may outlive the loop
iteration and possibly observe the wrong value of the variable.

Note: An iteration variable can only outlive a loop iteration in Go versions <=1.21.
In Go 1.22 and later, the loop variable lifetimes changed to create a new
iteration variable per loop iteration. (See go.dev/issue/60078.)

In this example, all the deferred functions run after the loop has
completed, so all observe the final value of v [<go1.22].

	for _, v := range list {
	    defer func() {
	        use(v) // incorrect
	    }()
	}

One fix is to create a new variable for each iteration of the loop:

	for _, v := range list {
	    v := v // new var per iteration
	    defer func() {
	        use(v) // ok
	    }()
	}

After Go version 1.22, the previous two for loops are equivalent
and both are correct.

The next example uses a go statement and has a similar problem [<go1.22].
In addition, it has a data race because the loop updates v
concurrent with the goroutines accessing it.

	for _, v := range elem {
	    go func() {
	        use(v)  // incorrect, and a data race
	    }()
	}

A fix is the same as before. The checker also reports problems
in goroutines started by golang.org/x/sync/errgroup.Group.
A hard-to-spot variant of this form is common in parallel tests:

	func Test(t *testing.T) {
	    for _, test := range tests {
	        t.Run(test.name, func(t *testing.T) {
	            t.Parallel()
	            use(test) // incorrect, and a data race
	        })
	    }
	}

The t.Parallel() call causes the rest of the function to execute
concurrent with the loop [<go1.22].

The analyzer reports references only in the last statement,
as it is not deep enough to understand the effects of subsequent
statements that might render the reference benign.
("Last statement" is defined recursively in compound
statements such as if, switch, and select.)

See: https://golang.org/doc/go_faq.html#closures_and_goroutines

Default: on.

Package documentation: [loopclosure](https://pkg.go.dev/golang.org/x/tools/go/analysis/passes/loopclosure)

<a id='lostcancel'></a>
## `lostcancel`: check cancel func returned by context.WithCancel is called


The cancellation function returned by context.WithCancel, WithTimeout,
WithDeadline and variants such as WithCancelCause must be called,
or the new context will remain live until its parent context is cancelled.
(The background context is never cancelled.)

Default: on.

Package documentation: [lostcancel](https://pkg.go.dev/golang.org/x/tools/go/analysis/passes/lostcancel)

<a id='maprange'></a>
## `maprange`: checks for unnecessary calls to maps.Keys and maps.Values in range statements


Consider a loop written like this:

	for val := range maps.Values(m) {
		fmt.Println(val)
	}

This should instead be written without the call to maps.Values:

	for _, val := range m {
		fmt.Println(val)
	}

golang.org/x/exp/maps returns slices for Keys/Values instead of iterators,
but unnecessary calls should similarly be removed:

	for _, key := range maps.Keys(m) {
		fmt.Println(key)
	}

should be rewritten as:

	for key := range m {
		fmt.Println(key)
	}

Default: on.

Package documentation: [maprange](https://pkg.go.dev/golang.org/x/tools/gopls/internal/analysis/maprange)

<a id='modernize'></a>
## `modernize`: simplify code by using modern constructs


This analyzer reports opportunities for simplifying and clarifying
existing code by using more modern features of Go and its standard
library.

Each diagnostic provides a fix. Our intent is that these fixes may
be safely applied en masse without changing the behavior of your
program. In some cases the suggested fixes are imperfect and may
lead to (for example) unused imports or unused local variables,
causing build breakage. However, these problems are generally
trivial to fix. We regard any modernizer whose fix changes program
behavior to have a serious bug and will endeavor to fix it.

To apply all modernization fixes en masse, you can use the
following command:

	$ go run golang.org/x/tools/gopls/internal/analysis/modernize/cmd/modernize@latest -fix -test ./...

(Do not use "go get -tool" to add gopls as a dependency of your
module; gopls commands must be built from their release branch.)

If the tool warns of conflicting fixes, you may need to run it more
than once until it has applied all fixes cleanly. This command is
not an officially supported interface and may change in the future.

Changes produced by this tool should be reviewed as usual before
being merged. In some cases, a loop may be replaced by a simple
function call, causing comments within the loop to be discarded.
Human judgment may be required to avoid losing comments of value.

Each diagnostic reported by modernize has a specific category. (The
categories are listed below.) Diagnostics in some categories, such
as "efaceany" (which replaces "interface{}" with "any" where it is
safe to do so) are particularly numerous. It may ease the burden of
code review to apply fixes in two passes, the first change
consisting only of fixes of category "efaceany", the second
consisting of all others. This can be achieved using the -category flag:

	$ modernize -category=efaceany  -fix -test ./...
	$ modernize -category=-efaceany -fix -test ./...

Categories of modernize diagnostic:

  - forvar: remove x := x variable declarations made unnecessary by the new semantics of loops in go1.22.

  - slicescontains: replace 'for i, elem := range s { if elem == needle { ...; break }'
    by a call to slices.Contains, added in go1.21.

  - minmax: replace an if/else conditional assignment by a call to
    the built-in min or max functions added in go1.21.

  - sortslice: replace sort.Slice(s, func(i, j int) bool) { return s[i] < s[j] }
    by a call to slices.Sort(s), added in go1.21.

  - efaceany: replace interface{} by the 'any' type added in go1.18.

  - mapsloop: replace a loop around an m[k]=v map update by a call
    to one of the Collect, Copy, Clone, or Insert functions from
    the maps package, added in go1.21.

  - fmtappendf: replace []byte(fmt.Sprintf...) by fmt.Appendf(nil, ...),
    added in go1.19.

  - testingcontext: replace uses of context.WithCancel in tests
    with t.Context, added in go1.24.

  - omitzero: replace omitempty by omitzero on structs, added in go1.24.

  - bloop: replace "for i := range b.N" or "for range b.N" in a
    benchmark with "for b.Loop()", and remove any preceding calls
    to b.StopTimer, b.StartTimer, and b.ResetTimer.

    B.Loop intentionally defeats compiler optimizations such as
    inlining so that the benchmark is not entirely optimized away.
    Currently, however, it may cause benchmarks to become slower
    in some cases due to increased allocation; see
    https://go.dev/issue/73137.

  - rangeint: replace a 3-clause "for i := 0; i < n; i++" loop by
    "for i := range n", added in go1.22.

  - stringsseq: replace Split in "for range strings.Split(...)" by go1.24's
    more efficient SplitSeq, or Fields with FieldSeq.

  - stringscutprefix: replace some uses of HasPrefix followed by TrimPrefix with CutPrefix,
    added to the strings package in go1.20.

  - waitgroup: replace old complex usages of sync.WaitGroup by less complex WaitGroup.Go method in go1.25.

Default: on.

Package documentation: [modernize](https://pkg.go.dev/golang.org/x/tools/gopls/internal/analysis/modernize)

<a id='nilfunc'></a>
## `nilfunc`: check for useless comparisons between functions and nil


A useless comparison is one like f == nil as opposed to f() == nil.

Default: on.

Package documentation: [nilfunc](https://pkg.go.dev/golang.org/x/tools/go/analysis/passes/nilfunc)

<a id='nilness'></a>
## `nilness`: check for redundant or impossible nil comparisons


The nilness checker inspects the control-flow graph of each function in
a package and reports nil pointer dereferences, degenerate nil
pointers, and panics with nil values. A degenerate comparison is of the form
x==nil or x!=nil where x is statically known to be nil or non-nil. These are
often a mistake, especially in control flow related to errors. Panics with nil
values are checked because they are not detectable by

	if r := recover(); r != nil {

This check reports conditions such as:

	if f == nil { // impossible condition (f is a function)
	}

and:

	p := &v
	...
	if p != nil { // tautological condition
	}

and:

	if p == nil {
		print(*p) // nil dereference
	}

and:

	if p == nil {
		panic(p)
	}

Sometimes the control flow may be quite complex, making bugs hard
to spot. In the example below, the err.Error expression is
guaranteed to panic because, after the first return, err must be
nil. The intervening loop is just a distraction.

	...
	err := g.Wait()
	if err != nil {
		return err
	}
	partialSuccess := false
	for _, err := range errs {
		if err == nil {
			partialSuccess = true
			break
		}
	}
	if partialSuccess {
		reportStatus(StatusMessage{
			Code:   code.ERROR,
			Detail: err.Error(), // "nil dereference in dynamic method call"
		})
		return nil
	}

...

Default: on.

Package documentation: [nilness](https://pkg.go.dev/golang.org/x/tools/go/analysis/passes/nilness)

<a id='nonewvars'></a>
## `nonewvars`: suggested fixes for "no new vars on left side of :="


This checker provides suggested fixes for type errors of the
type "no new vars on left side of :=". For example:

	z := 1
	z := 2

will turn into

	z := 1
	z = 2

Default: on.

Package documentation: [nonewvars](https://pkg.go.dev/golang.org/x/tools/gopls/internal/analysis/nonewvars)

<a id='noresultvalues'></a>
## `noresultvalues`: suggested fixes for unexpected return values


This checker provides suggested fixes for type errors of the
type "no result values expected" or "too many return values".
For example:

	func z() { return nil }

will turn into

	func z() { return }

Default: on.

Package documentation: [noresultvalues](https://pkg.go.dev/golang.org/x/tools/gopls/internal/analysis/noresultvalues)

<a id='printf'></a>
## `printf`: check consistency of Printf format strings and arguments


The check applies to calls of the formatting functions such as
[fmt.Printf] and [fmt.Sprintf], as well as any detected wrappers of
those functions such as [log.Printf]. It reports a variety of
mistakes such as syntax errors in the format string and mismatches
(of number and type) between the verbs and their arguments.

See the documentation of the fmt package for the complete set of
format operators and their operand types.

Default: on.

Package documentation: [printf](https://pkg.go.dev/golang.org/x/tools/go/analysis/passes/printf)

<a id='recursiveiter'></a>
## `recursiveiter`: check for inefficient recursive iterators


This analyzer reports when a function that returns an iterator
(iter.Seq or iter.Seq2) calls itself as the operand of a range
statement, as this is inefficient.

When implementing an iterator (e.g. iter.Seq[T]) for a recursive
data type such as a tree or linked list, it is tempting to
recursively range over the iterator for each child element.

Here's an example of a naive iterator over a binary tree:

	type tree struct {
		value       int
		left, right *tree
	}

	func (t *tree) All() iter.Seq[int] {
		return func(yield func(int) bool) {
			if t != nil {
				for elem := range t.left.All() { // "inefficient recursive iterator"
					if !yield(elem) {
						return
					}
				}
				if !yield(t.value) {
					return
				}
				for elem := range t.right.All() { // "inefficient recursive iterator"
					if !yield(elem) {
						return
					}
				}
			}
		}
	}

Though it correctly enumerates the elements of the tree, it hides a
significant performance problem--two, in fact. Consider a balanced
tree of N nodes. Iterating the root node will cause All to be
called once on every node of the tree. This results in a chain of
nested active range-over-func statements when yield(t.value) is
called on a leaf node.

The first performance problem is that each range-over-func
statement must typically heap-allocate a variable, so iteration of
the tree allocates as many variables as there are elements in the
tree, for a total of O(N) allocations, all unnecessary.

The second problem is that each call to yield for a leaf of the
tree causes each of the enclosing range loops to receive a value,
which they then immediately pass on to their respective yield
function. This results in a chain of log(N) dynamic yield calls per
element, a total of O(N*log N) dynamic calls overall, when only
O(N) are necessary.

A better implementation strategy for recursive iterators is to
first define the "every" operator for your recursive data type,
where every(f) reports whether f(x) is true for every element x in
the data type. For our tree, the every function would be:

	func (t *tree) every(f func(int) bool) bool {
		return t == nil ||
			t.left.every(f) && f(t.value) && t.right.every(f)
	}

Then the iterator can be simply expressed as a trivial wrapper
around this function:

	func (t *tree) All() iter.Seq[int] {
		return func(yield func(int) bool) {
			_ = t.every(yield)
		}
	}

In effect, tree.All computes whether yield returns true for each
element, short-circuiting if it every returns false, then discards
the final boolean result.

This has much better performance characteristics: it makes one
dynamic call per element of the tree, and it doesn't heap-allocate
anything. It is also clearer.

Default: on.

Package documentation: [recursiveiter](https://pkg.go.dev/golang.org/x/tools/gopls/internal/analysis/recursiveiter)

<a id='shadow'></a>
## `shadow`: check for possible unintended shadowing of variables


This analyzer check for shadowed variables.
A shadowed variable is a variable declared in an inner scope
with the same name and type as a variable in an outer scope,
and where the outer variable is mentioned after the inner one
is declared.

(This definition can be refined; the module generates too many
false positives and is not yet enabled by default.)

For example:

	func BadRead(f *os.File, buf []byte) error {
		var err error
		for {
			n, err := f.Read(buf) // shadows the function variable 'err'
			if err != nil {
				break // causes return of wrong value
			}
			foo(buf)
		}
		return err
	}

Default: off. Enable by setting `"analyses": {"shadow": true}`.

Package documentation: [shadow](https://pkg.go.dev/golang.org/x/tools/go/analysis/passes/shadow)

<a id='shift'></a>
## `shift`: check for shifts that equal or exceed the width of the integer



Default: on.

Package documentation: [shift](https://pkg.go.dev/golang.org/x/tools/go/analysis/passes/shift)

<a id='sigchanyzer'></a>
## `sigchanyzer`: check for unbuffered channel of os.Signal


This checker reports call expression of the form

	signal.Notify(c <-chan os.Signal, sig ...os.Signal),

where c is an unbuffered channel, which can be at risk of missing the signal.

Default: on.

Package documentation: [sigchanyzer](https://pkg.go.dev/golang.org/x/tools/go/analysis/passes/sigchanyzer)

<a id='simplifycompositelit'></a>
## `simplifycompositelit`: check for composite literal simplifications


An array, slice, or map composite literal of the form:

	[]T{T{}, T{}}

will be simplified to:

	[]T{{}, {}}

This is one of the simplifications that "gofmt -s" applies.

This analyzer ignores generated code.

Default: on.

Package documentation: [simplifycompositelit](https://pkg.go.dev/golang.org/x/tools/gopls/internal/analysis/simplifycompositelit)

<a id='simplifyrange'></a>
## `simplifyrange`: check for range statement simplifications


A range of the form:

	for x, _ = range v {...}

will be simplified to:

	for x = range v {...}

A range of the form:

	for _ = range v {...}

will be simplified to:

	for range v {...}

This is one of the simplifications that "gofmt -s" applies.

This analyzer ignores generated code.

Default: on.

Package documentation: [simplifyrange](https://pkg.go.dev/golang.org/x/tools/gopls/internal/analysis/simplifyrange)

<a id='simplifyslice'></a>
## `simplifyslice`: check for slice simplifications


A slice expression of the form:

	s[a:len(s)]

will be simplified to:

	s[a:]

This is one of the simplifications that "gofmt -s" applies.

This analyzer ignores generated code.

Default: on.

Package documentation: [simplifyslice](https://pkg.go.dev/golang.org/x/tools/gopls/internal/analysis/simplifyslice)

<a id='slog'></a>
## `slog`: check for invalid structured logging calls


The slog checker looks for calls to functions from the log/slog
package that take alternating key-value pairs. It reports calls
where an argument in a key position is neither a string nor a
slog.Attr, and where a final key is missing its value.
For example,it would report

	slog.Warn("message", 11, "k") // slog.Warn arg "11" should be a string or a slog.Attr

and

	slog.Info("message", "k1", v1, "k2") // call to slog.Info missing a final value

Default: on.

Package documentation: [slog](https://pkg.go.dev/golang.org/x/tools/go/analysis/passes/slog)

<a id='sortslice'></a>
## `sortslice`: check the argument type of sort.Slice


sort.Slice requires an argument of a slice type. Check that
the interface{} value passed to sort.Slice is actually a slice.

Default: on.

Package documentation: [sortslice](https://pkg.go.dev/golang.org/x/tools/go/analysis/passes/sortslice)

<a id='stdmethods'></a>
## `stdmethods`: check signature of methods of well-known interfaces


Sometimes a type may be intended to satisfy an interface but may fail to
do so because of a mistake in its method signature.
For example, the result of this WriteTo method should be (int64, error),
not error, to satisfy io.WriterTo:

	type myWriterTo struct{...}
	func (myWriterTo) WriteTo(w io.Writer) error { ... }

This check ensures that each method whose name matches one of several
well-known interface methods from the standard library has the correct
signature for that interface.

Checked method names include:

	Format GobEncode GobDecode MarshalJSON MarshalXML
	Peek ReadByte ReadFrom ReadRune Scan Seek
	UnmarshalJSON UnreadByte UnreadRune WriteByte
	WriteTo

Default: on.

Package documentation: [stdmethods](https://pkg.go.dev/golang.org/x/tools/go/analysis/passes/stdmethods)

<a id='stdversion'></a>
## `stdversion`: report uses of too-new standard library symbols


The stdversion analyzer reports references to symbols in the standard
library that were introduced by a Go release higher than the one in
force in the referring file. (Recall that the file's Go version is
defined by the 'go' directive its module's go.mod file, or by a
"//go:build go1.X" build tag at the top of the file.)

The analyzer does not report a diagnostic for a reference to a "too
new" field or method of a type that is itself "too new", as this may
have false positives, for example if fields or methods are accessed
through a type alias that is guarded by a Go version constraint.


Default: on.

Package documentation: [stdversion](https://pkg.go.dev/golang.org/x/tools/go/analysis/passes/stdversion)

<a id='stringintconv'></a>
## `stringintconv`: check for string(int) conversions


This checker flags conversions of the form string(x) where x is an integer
(but not byte or rune) type. Such conversions are discouraged because they
return the UTF-8 representation of the Unicode code point x, and not a decimal
string representation of x as one might expect. Furthermore, if x denotes an
invalid code point, the conversion cannot be statically rejected.

For conversions that intend on using the code point, consider replacing them
with string(rune(x)). Otherwise, strconv.Itoa and its equivalents return the
string representation of the value in the desired base.

Default: on.

Package documentation: [stringintconv](https://pkg.go.dev/golang.org/x/tools/go/analysis/passes/stringintconv)

<a id='structtag'></a>
## `structtag`: check that struct field tags conform to reflect.StructTag.Get


Also report certain struct tags (json, xml) used with unexported fields.

Default: on.

Package documentation: [structtag](https://pkg.go.dev/golang.org/x/tools/go/analysis/passes/structtag)

<a id='testinggoroutine'></a>
## `testinggoroutine`: report calls to (*testing.T).Fatal from goroutines started by a test


Functions that abruptly terminate a test, such as the Fatal, Fatalf, FailNow, and
Skip{,f,Now} methods of *testing.T, must be called from the test goroutine itself.
This checker detects calls to these functions that occur within a goroutine
started by the test. For example:

	func TestFoo(t *testing.T) {
	    go func() {
	        t.Fatal("oops") // error: (*T).Fatal called from non-test goroutine
	    }()
	}

Default: on.

Package documentation: [testinggoroutine](https://pkg.go.dev/golang.org/x/tools/go/analysis/passes/testinggoroutine)

<a id='tests'></a>
## `tests`: check for common mistaken usages of tests and examples


The tests checker walks Test, Benchmark, Fuzzing and Example functions checking
malformed names, wrong signatures and examples documenting non-existent
identifiers.

Please see the documentation for package testing in golang.org/pkg/testing
for the conventions that are enforced for Tests, Benchmarks, and Examples.

Default: on.

Package documentation: [tests](https://pkg.go.dev/golang.org/x/tools/go/analysis/passes/tests)

<a id='timeformat'></a>
## `timeformat`: check for calls of (time.Time).Format or time.Parse with 2006-02-01


The timeformat checker looks for time formats with the 2006-02-01 (yyyy-dd-mm)
format. Internationally, "yyyy-dd-mm" does not occur in common calendar date
standards, and so it is more likely that 2006-01-02 (yyyy-mm-dd) was intended.

Default: on.

Package documentation: [timeformat](https://pkg.go.dev/golang.org/x/tools/go/analysis/passes/timeformat)

<a id='unmarshal'></a>
## `unmarshal`: report passing non-pointer or non-interface values to unmarshal


The unmarshal analysis reports calls to functions such as json.Unmarshal
in which the argument type is not a pointer or an interface.

Default: on.

Package documentation: [unmarshal](https://pkg.go.dev/golang.org/x/tools/go/analysis/passes/unmarshal)

<a id='unreachable'></a>
## `unreachable`: check for unreachable code


The unreachable analyzer finds statements that execution can never reach
because they are preceded by a return statement, a call to panic, an
infinite loop, or similar constructs.

Default: on.

Package documentation: [unreachable](https://pkg.go.dev/golang.org/x/tools/go/analysis/passes/unreachable)

<a id='unsafeptr'></a>
## `unsafeptr`: check for invalid conversions of uintptr to unsafe.Pointer


The unsafeptr analyzer reports likely incorrect uses of unsafe.Pointer
to convert integers to pointers. A conversion from uintptr to
unsafe.Pointer is invalid if it implies that there is a uintptr-typed
word in memory that holds a pointer value, because that word will be
invisible to stack copying and to the garbage collector.

Default: on.

Package documentation: [unsafeptr](https://pkg.go.dev/golang.org/x/tools/go/analysis/passes/unsafeptr)

<a id='unusedfunc'></a>
## `unusedfunc`: check for unused functions, methods, etc


The unusedfunc analyzer reports functions and methods that are
never referenced outside of their own declaration.

A function is considered unused if it is unexported and not
referenced (except within its own declaration).

A method is considered unused if it is unexported, not referenced
(except within its own declaration), and its name does not match
that of any method of an interface type declared within the same
package.

The tool may report false positives in some situations, for
example:

  - for a declaration of an unexported function that is referenced
    from another package using the go:linkname mechanism, if the
    declaration's doc comment does not also have a go:linkname
    comment.

    (Such code is in any case strongly discouraged: linkname
    annotations, if they must be used at all, should be used on both
    the declaration and the alias.)

  - for compiler intrinsics in the "runtime" package that, though
    never referenced, are known to the compiler and are called
    indirectly by compiled object code.

  - for functions called only from assembly.

  - for functions called only from files whose build tags are not
    selected in the current build configuration.

Since these situations are relatively common in the low-level parts
of the runtime, this analyzer ignores the standard library.
See https://go.dev/issue/71686 and https://go.dev/issue/74130 for
further discussion of these limitations.

The unusedfunc algorithm is not as precise as the
golang.org/x/tools/cmd/deadcode tool, but it has the advantage that
it runs within the modular analysis framework, enabling near
real-time feedback within gopls.

The unusedfunc analyzer also reports unused types, vars, and
constants. Enums--constants defined with iota--are ignored since
even the unused values must remain present to preserve the logical
ordering.

Default: on.

Package documentation: [unusedfunc](https://pkg.go.dev/golang.org/x/tools/gopls/internal/analysis/unusedfunc)

<a id='unusedparams'></a>
## `unusedparams`: check for unused parameters of functions


The unusedparams analyzer checks functions to see if there are
any parameters that are not being used.

To ensure soundness, it ignores:
  - "address-taken" functions, that is, functions that are used as
    a value rather than being called directly; their signatures may
    be required to conform to a func type.
  - exported functions or methods, since they may be address-taken
    in another package.
  - unexported methods whose name matches an interface method
    declared in the same package, since the method's signature
    may be required to conform to the interface type.
  - functions with empty bodies, or containing just a call to panic.
  - parameters that are unnamed, or named "_", the blank identifier.

The analyzer suggests a fix of replacing the parameter name by "_",
but in such cases a deeper fix can be obtained by invoking the
"Refactor: remove unused parameter" code action, which will
eliminate the parameter entirely, along with all corresponding
arguments at call sites, while taking care to preserve any side
effects in the argument expressions; see
https://github.com/golang/tools/releases/tag/gopls%2Fv0.14.

This analyzer ignores generated code.

Default: on.

Package documentation: [unusedparams](https://pkg.go.dev/golang.org/x/tools/gopls/internal/analysis/unusedparams)

<a id='unusedresult'></a>
## `unusedresult`: check for unused results of calls to some functions


Some functions like fmt.Errorf return a result and have no side
effects, so it is always a mistake to discard the result. Other
functions may return an error that must not be ignored, or a cleanup
operation that must be called. This analyzer reports calls to
functions like these when the result of the call is ignored.

The set of functions may be controlled using flags.

Default: on.

Package documentation: [unusedresult](https://pkg.go.dev/golang.org/x/tools/go/analysis/passes/unusedresult)

<a id='unusedvariable'></a>
## `unusedvariable`: check for unused variables and suggest fixes



Default: on.

Package documentation: [unusedvariable](https://pkg.go.dev/golang.org/x/tools/gopls/internal/analysis/unusedvariable)

<a id='unusedwrite'></a>
## `unusedwrite`: checks for unused writes


The analyzer reports instances of writes to struct fields and
arrays that are never read. Specifically, when a struct object
or an array is copied, its elements are copied implicitly by
the compiler, and any element write to this copy does nothing
with the original object.

For example:

	type T struct { x int }

	func f(input []T) {
		for i, v := range input {  // v is a copy
			v.x = i  // unused write to field x
		}
	}

Another example is about non-pointer receiver:

	type T struct { x int }

	func (t T) f() {  // t is a copy
		t.x = i  // unused write to field x
	}

Default: on.

Package documentation: [unusedwrite](https://pkg.go.dev/golang.org/x/tools/go/analysis/passes/unusedwrite)

<a id='waitgroup'></a>
## `waitgroup`: check for misuses of sync.WaitGroup


This analyzer detects mistaken calls to the (*sync.WaitGroup).Add
method from inside a new goroutine, causing Add to race with Wait:

	// WRONG
	var wg sync.WaitGroup
	go func() {
	        wg.Add(1) // "WaitGroup.Add called from inside new goroutine"
	        defer wg.Done()
	        ...
	}()
	wg.Wait() // (may return prematurely before new goroutine starts)

The correct code calls Add before starting the goroutine:

	// RIGHT
	var wg sync.WaitGroup
	wg.Add(1)
	go func() {
		defer wg.Done()
		...
	}()
	wg.Wait()

Default: on.

Package documentation: [waitgroup](https://pkg.go.dev/golang.org/x/tools/go/analysis/passes/waitgroup)

<a id='yield'></a>
## `yield`: report calls to yield where the result is ignored


After a yield function returns false, the caller should not call
the yield function again; generally the iterator should return
promptly.

This example fails to check the result of the call to yield,
causing this analyzer to report a diagnostic:

	yield(1) // yield may be called again (on L2) after returning false
	yield(2)

The corrected code is either this:

	if yield(1) { yield(2) }

or simply:

	_ = yield(1) && yield(2)

It is not always a mistake to ignore the result of yield.
For example, this is a valid single-element iterator:

	yield(1) // ok to ignore result
	return

It is only a mistake when the yield call that returned false may be
followed by another call.

Default: on.

Package documentation: [yield](https://pkg.go.dev/golang.org/x/tools/gopls/internal/analysis/yield)

<!-- END Analyzers: DO NOT MANUALLY EDIT THIS SECTION -->
